//***************************************************************
//*  [[ A D V E R T E N C I A ]] =[ http://Solar-OpenSource.Org ]=
//*
//*  LICENCIA PARA LA DISTRIBUCIÓN DE WAR 3D
//*  1.- WAR 3D es un programa que podrá ser distribuido bajo los términos de la Licencia Pública General, además deberán cumplirse las siguientes condiciones.
//*  2.- Al copiar cualquier parte del código para ponerlo en un programa diferente a WAR 3D, el autor de dicho programa estará de acuerdo en que el código completo de su programa pasa a ser software libre, por lo deberá estar apegado a los términos establecidos por la licencia LGP. Es decir que, el código de WAR 3D solo puede ser tomado si se va a usar en otro proyecto de software libre. De lo contrario absténgase de usar el código o parte de el código de WAR3D.
//*  3.- Queda estrictamente prohibido modificar los nombres que aparecen en los créditos del programa, solo el grupo de desarrollo de  Solar-OpenSource podrá añadir nuevos nombres en los créditos. Si ha hecho alguna modificación y quiere que su nombre aparezca en los créditos debe ponerse en contacto con nosotros.
//*  4.- Cualquier modificación del código debe apegarse en lo posible a las normas que ha establecido el grupo de desarrollo de Solar-OpenSource, esto es para mayor claridad en el código. Dichas normas pueden encontrarse en nuestra pagina web http://www.solar-opensource.org
//*  5.- Puede copiar y distribuir el programa siempre y cuando no olvide: Acompañarlo con el código fuente completo correspondiente, legible para la máquina, así como el código escrito por usted o las modificaciones hechas al código original.
//*  6.- No debe distribuirse el ejecutable sin el código fuente.
//*  7.- Este texto no debe suprimirse. Las distribuciones deben acompañarse con la información que se recibió así como el ofrecimiento para distribuir el código fuente correspondiente.
//*
//***************************************************************

#ifndef __IRCcomunicaciones_h__
#define __IRCcomunicaciones_h__

#include <iostream>
#include <string>
#include <vector>
#include <set>

using namespace std;

#include "constantes.h"

#include "zeru_mat.h"

#include "IRCcomandos.h"


#ifndef SolarSocketsDebug
#include <SolarSockets/SolarSockets.h> // Libreria http://solar-opensource.org
#else
#include "../SolarSockets/include/SolarSockets.h" // Libreria http://solar-opensource.org
#endif


#define IRCPuerto    6667
#define IRCServer   "jupiter2.irc-hispano.org" /*  "localhost"  */
#define CanalWar3D  "#war3d" /*  "#War3dpartidas"  */

//-----------------------------
class IRCNickEnCanal
{
 private:
  string Nick;
  bool Op;
  bool Vos;
 public:

  inline IRCNickEnCanal(string Nick, bool Op, bool Vos) 
    {setNick(Nick); setOp(Op); setVos(Vos);};

  inline const string getNick() {return Nick;};
  inline void setNick(string Nick) {this->Nick = Nick;};

  inline const bool getOp() {return Op;};
  inline void setOp(bool Op) {this->Op = Op;};

  inline const bool getVos() {return Vos;};
  inline void setVos(bool Vos) {this->Vos = Vos;}; 

  // Con esta cosa comparamos si dos Nicks son iguales.
  inline bool operator==(IRCNickEnCanal s2)
    {
      return (getNick().compare(s2.getNick()) == 0);
    };

};


//-----------------------------
class IRCParida
{
 private:
  string Nombre;
  string IP;
  string Mapa;
  int Slots;
  string Nick;
  
  float ultimarenovacion;

 public:
  inline IRCParida(string Nick, string Nombre, string IP, int Slots, string Mapa)
  {putNick(Nick); putNombre(Nombre); putIP(IP); putMapa(Mapa); putSlots(Slots);};
	
  inline void putNombre(string Nombre){this->Nombre = Nombre;};
  inline string getNombre(){return Nombre;};

  inline void putIP(string IP){this->IP = IP;};
  inline string getIP(){return IP;};

  inline void putMapa(string Mapa){this->Mapa = Mapa;};
  inline string getMapa(){return Mapa;};

  inline void putSlots(int Slots){this->Slots = Slots;};
  inline int getSlots(){return Slots;};

  inline void putNick(string Nick){this->Nick = Nick;};
  inline string getNick(){return Nick;};

  inline void DecrementaTiempo(float Retardo){ultimarenovacion -= Retardo;};
  inline void Renueva(){ultimarenovacion = 45;};
  inline bool getActiva() {return ultimarenovacion > 0;};

  bool operator==(IRCParida s2);

};


//-----------------------------
class IRCCanal
{
 private:
  string Nombre;
  bool Op;
  bool Vos;
  set<char> permisos;
  vector<IRCNickEnCanal> Nicks;
  

 public:

  inline string const getNombre() {return Nombre;};
  inline void setNombre(string Nombre) {this->Nombre = Nombre;};

  inline bool const getOp() {return Op;};
  inline void setOp(bool Op) {this->Op = Op;};

  inline bool const getVos() {return Vos;};
  inline void setVos(bool Vos) {this->Vos = Vos;};

  inline set<char> getPermisos() {return permisos;};
  inline void addPermiso(char Permiso){permisos.insert(Permiso);};

  inline vector<IRCNickEnCanal>* getNicks(){return &Nicks;};
  void addNick(IRCNickEnCanal Nick);
  void BorraNick(IRCNickEnCanal Nick);
  void Nick(IRCNickEnCanal Nick, IRCNickEnCanal NuevoNick);


  // Con esta cosa comparamos si dos canales son iguales.
  bool operator==(IRCCanal s2);

};

//-----------------------------
class IRCcomunicaciones
{

 public: // ZG No me gusta este public.
  static IRCcomunicaciones *RefMe;

 protected: 
  IRCcomunicaciones();

 private:
  ssClient IRCClienteSocket;

  // Inicializa
 public:
  virtual ~IRCcomunicaciones(){};
  void Conectar(string Server);
  void getEventos();

 private:
  vector<string> BufferDeComandos;

  // Eventos de Socket
 public:
  bool ConexionRecive(string Mensaje);
  void ConexionConectado();
  void ConexionError(int iErr);

  vector<comIRCComandoBASE*> comComandos;

  // Canales
 private:
  vector<IRCCanal> Canales;

 protected:
  vector<IRCParida> Partidas;

  //Variables
 private:
  string strServer; 
  ssMutex Ocupado;

 protected:
  string MiNick;
  string MiIP;

 public:
  bool StatusIRCConectado;


  //// EVENTOS ////
 public:
  virtual void onNUEVAPARTIDA(string Nick, string Nombre, string IP, string IP2, int Slots, string Mapa) = 0;  
  virtual void onPING (string Numero) = 0;
  virtual void on001 (string MensajeDeBienvenida) = 0;
  virtual void onCONEXION (string Nick) = 0;
  virtual void onMSG_PRIVADO (string Nick, string Mensaje) = 0;
  virtual void onMSG_CANAL (string Nick, string Canal, string Mensaje) = 0;
  virtual void onJOIN_OTRO (string Nick, string Canal) = 0;
  virtual void onJOIN_YO (string Canal) = 0;
  virtual void onLISTA_DE_NICKS (vector<string> Nicks, string Canal) = 0;
  virtual void onPART(string Nick, string Canal) = 0;
  virtual void onQUIT(string Nick) = 0;
  virtual void onNOCONEXION() = 0;
  virtual void onNick(string VNick, string NNick) = 0;
  virtual void onERROR(string Mensaje) = 0;



  //// ACCIONES ////
  void sendUSER(string Nombre, string Host, string Servidor, string NombreReal);
  void sendNICK(string Nick);
  void sendPONG(string Numero);
  void sendJOIN(string Canal);
  void sendMENSAJE(string Canal, string Mensaje);
  void sendNUEVAPARTIDA(string Nombre, int Sockets, string Mapa);
  void sendQUIT();
  void sendGETIP();


  // INFORMACION
  string getMiNick();
  inline string getMiIP() {return MiIP;};
  inline string getIPSocket() {return IRCClienteSocket.getIP();};

  inline void setMiIP(string MiIP){this->MiIP = MiIP;};

  void NuevoCanal(string Canal);
  void QuitNick(IRCNickEnCanal Nick);
  void Nick(IRCNickEnCanal Nick, IRCNickEnCanal NuevoNick);
  vector<IRCCanal>::iterator getCanal(string Canal);

};



#endif
