//***************************************************************
//*  [[ A D V E R T E N C I A ]] =[ http://Solar-OpenSource.Org ]=
//*
//*  LICENCIA PARA LA DISTRIBUCIN DE WAR 3D
//*  1.- WAR 3D es un programa que podr ser distribuido bajo los trminos de la Licencia Pblica General, adems debern cumplirse las siguientes condiciones.
//*  2.- Al copiar cualquier parte del cdigo para ponerlo en un programa diferente a WAR 3D, el autor de dicho programa estar de acuerdo en que el cdigo completo de su programa pasa a ser software libre, por lo deber estar apegado a los trminos establecidos por la licencia LGP. Es decir que, el cdigo de WAR 3D solo puede ser tomado si se va a usar en otro proyecto de software libre. De lo contrario abstngase de usar el cdigo o parte de el cdigo de WAR3D.
//*  3.- Queda estrictamente prohibido modificar los nombres que aparecen en los crditos del programa, solo el grupo de desarrollo de  Solar-OpenSource podr aadir nuevos nombres en los crditos. Si ha hecho alguna modificacin y quiere que su nombre aparezca en los crditos debe ponerse en contacto con nosotros.
//*  4.- Cualquier modificacin del cdigo debe apegarse en lo posible a las normas que ha establecido el grupo de desarrollo de Solar-OpenSource, esto es para mayor claridad en el cdigo. Dichas normas pueden encontrarse en nuestra pagina web http://www.solar-opensource.org
//*  5.- Puede copiar y distribuir el programa siempre y cuando no olvide: Acompaarlo con el cdigo fuente completo correspondiente, legible para la mquina, as como el cdigo escrito por usted o las modificaciones hechas al cdigo original.
//*  6.- No debe distribuirse el ejecutable sin el cdigo fuente.
//*  7.- Este texto no debe suprimirse. Las distribuciones deben acompaarse con la informacin que se recibi as como el ofrecimiento para distribuir el cdigo fuente correspondiente.
//*
//***************************************************************

#include  "Kstar_v1.h"


static KStar getInstancia();



// -----------------------------------------------
float KStar::getAngle(float Xi,float Yi,float Xf,float Yf)
{
	if(Xf>=Xi && Yf>=Yi){	return 000 + atan( (Yf-Yi)/(Xf-Xi) ) / M_PI * 180.0f;	}
	if(Xf<Xi && Yf>=Yi){	return 180 - atan( (Yf-Yi)/(Xi-Xf) ) / M_PI * 180.0f;	}
	if(Xf<Xi && Yf<Yi){	return 180 + atan( (Yi-Yf)/(Xi-Xf) ) / M_PI * 180.0f;	}
	if(Xf>=Xi && Yf<Yi){	return 360 - atan( (Yi-Yf)/(Xf-Xi) ) / M_PI * 180.0f;	}
	return 2511;
}

char KStar::KnextX(char v)
{
	switch(v)
	{
		case 3:	case 4:	case 5:	return -1;
		case 2:	case 6:	return 0;
		case 0:	case 1:	case 7:	return 1;
	};
	return -127;
}

char KStar::KnextY(char v)
{
	switch(v)
	{
		case 5:	case 6:	case 7:	return -1;
		case 0:	case 4:	return 0;
		case 1:	case 2:	case 3:	return 1;
	};
	return -127;
}

bool KStar::isUseless(int value,vector<int> useless)
{
	for(int l=0;l<useless.size();l++)
	{
		if(useless[l]==value){	return true;	}
	}
	return false;
}

// -----------------------------------------------
KStar::KStar()
{
}

// -----------------------------------------------
KStar::~KStar()
{
  if(mapa){	delete[] mapa;	mapa=NULL;	}
}

// -----------------------------------------------
void KStar::SetPoint(int x,int y,bool value)
{
  if(!mapa){	return;	}
  if(x<0 || x>ancho){	return;	}
  if(y<0 || y>alto) {	return;	}

  unsigned char mask[8]={128,64,32,16,8,4,2,1};

  int b=(y*ancho+x)/8;
  if(value)
    {
      mapa[b] = mapa[b] | mask[(y*ancho+x)%8];
    }
  else 
    {	
      mapa[b] = mapa[b] & mask[(y*ancho+x)%8];
    } 
}

// -----------------------------------------------
bool KStar::GetPoint(int x,int y)
{
  if(x<0 || x>ancho){	return false;	}
  if(y<0 || y>alto) {	return false;	}

  unsigned char mask[8]={128,64,32,16,8,4,2,1};

  int b=(y*ancho+x)/8;
  if(mapa[b] & mask[(y*ancho+x)%8])
    {
      return true;
    }
  else 
    {
      return false;
    }
}
 
// -----------------------------------------------
void KStar::Crear(Tierra &t)
{
  ancho = t.getAncho()*4;
  alto = t.getAlto()*4;

  if(ancho*alto%8)
    {
      size=(ancho*alto)/8+1;
    } 
  else
    {
      size=(ancho*alto)/8;
    }

  mapa=new unsigned char[size];	memset(mapa,0,size);

  int ancho_ = ancho/4;

  int x, y;

  verticeTierra *v=(verticeTierra *)t.getVertices();
  for(int l=0;l<alto*ancho/16;l++)
    {
      if(v[l].ObjetosMap)
	{

	  for (y=1; y<TamMayaIA-1 ; y++)
	    {
	      for (x=1; x<TamMayaIA-1 ; x++)
		{
		  if (v[l].ObjetosMap->getModelo()->getIAMaya()[(y+0)*TamMayaIA+(x+1)] ||
		      v[l].ObjetosMap->getModelo()->getIAMaya()[(y+0)*TamMayaIA+(x+0)] ||
		      v[l].ObjetosMap->getModelo()->getIAMaya()[(y+0)*TamMayaIA+(x-1)] ||
		      v[l].ObjetosMap->getModelo()->getIAMaya()[(y+1)*TamMayaIA+(x+0)] ||   
		      v[l].ObjetosMap->getModelo()->getIAMaya()[(y-1)*TamMayaIA+(x+0)])
		    {
		      SetPoint(l%ancho_*4+(x-TamMayaIA/2),
			       l/ancho_*4+(y-TamMayaIA/2),
			       true);
		    }

		}
	    }
	}
    }
}

// ----------------------------------------------------
void KStar::getPath(float iniX, float iniY, float finX, float finY, IACamino &Camino)
{
	if(mapa==NULL){	return;	}

	char next,sec;
	short cpx,cpy;
	float angle;
	vector<IAminiNodo> path;	IAminiNodo tmp;
	vector<int> useless;

	// Convetimos las coordenadas reales a coordenadas en el mapa de la IA
	short inix = (short)(4 * Densidad * iniX),
		  iniy = (short)(4 * Densidad * iniY),
		  finx = (short)(4 * Densidad * finX),
		  finy = (short)(4 * Densidad * finY);

	tmp.x=iniX;	tmp.y=iniY;
	path.push_back(tmp);
	cpx=inix;	cpy=iniy;
		
		// Miramos si el punto en el que hemos cliqueado esta ocupado por algun obstaculo.
		if(GetPoint(finx,finy))
		{
			//si es asi bucaremos el punto mas cercano que no sea obtaculo;
			for(short s=0;;s++)
			{				
				// para ellos miramo cuatro puntos en deredor y nos vamos alejando poco a poco
				if(!GetPoint(finx+s,finy+0)){	finx=finx+s;	finy=finy+0;	break;	}
				if(!GetPoint(finx+s,finy+s)){	finx=finx+s;	finy=finy+s;	break;	}
				if(!GetPoint(finx+0,finy+s)){	finx=finx+0;	finy=finy+s;	break;	}
				if(!GetPoint(finx-s,finy+s)){	finx=finx-s;	finy=finy+s;	break;	}
				if(!GetPoint(finx-s,finy+0)){	finx=finx-s;	finy=finy+0;	break;	}
				if(!GetPoint(finx-s,finy-s)){	finx=finx-s;	finy=finy-s;	break;	}
				if(!GetPoint(finx+0,finy-s)){	finx=finx+0;	finy=finy-s;	break;	}
				if(!GetPoint(finx+s,finy-s)){	finx=finx+s;	finy=finy-s;	break;	}
			}
		}

	angle=getAngle(cpx,cpy,finx,finy);
	next=(angle+22.5f)/45;

	for(int c=0;;c++)
	{
		sec=0;
		label:
		if(!GetPoint(cpx+KnextX(next),cpy+KnextY(next)) && !isUseless((cpy+KnextY(next))*ancho+cpx+KnextX(next),useless))
		{
			tmp.x=tmp.x+KnextX(next)/4.0/Densidad;	tmp.y=tmp.y+KnextY(next)/4.0/Densidad;
			path.push_back(tmp);
			cpx+=KnextX(next);	cpy+=KnextY(next);
			if(cpx==finx && cpy==finy)
			{
				Camino.p=0;
				Camino.Pasos=c;
				Camino.path=new IAminiNodo[c];	memset(Camino.path,0,c*sizeof(IAminiNodo));
				for(int l=0;l<c;l++){	Camino.path[l]=path[l];	}
				Camino.TodoCalculado=true;
				break;
			}
		} else {
			// K_nota mental: no volver a tocar un punto a no ser que no haya otra salida posible,
			//				  o estando en un punto no volver a repetir el mismo camino_K
			if((int)(angle+22.5f)%45>22.5f){	next+=1;	angle+=45.0f;	} else {	next-=1;	angle-=45.0f;	}	next%=8;
			sec++;
			if(sec==6){	int u=cpy*ancho+cpx;	useless.push_back(u);	}
			if(sec>7)
			{
				Camino.p=0;
				Camino.Pasos=c;
				Camino.path=new IAminiNodo[c];	memset(Camino.path,0,c*sizeof(IAminiNodo));
				for(int l=0;l<c;l++){	Camino.path[l]=path[l];	}
				Camino.TodoCalculado=true;
				break;
			}
			goto label;
		}
		angle=getAngle(cpx,cpy,finx,finy);
		next=(angle+22.5f)/45;
	}
}
