//***************************************************************
//*  [[ A D V E R T E N C I A ]] =[ http://Solar-OpenSource.Org ]=
//*
//*  LICENCIA PARA LA DISTRIBUCIN DE WAR 3D
//*  1.- WAR 3D es un programa que podr ser distribuido bajo los trminos de la Licencia Pblica General, adems debern cumplirse las siguientes condiciones.
//*  2.- Al copiar cualquier parte del cdigo para ponerlo en un programa diferente a WAR 3D, el autor de dicho programa estar de acuerdo en que el cdigo completo de su programa pasa a ser software libre, por lo deber estar apegado a los trminos establecidos por la licencia LGP. Es decir que, el cdigo de WAR 3D solo puede ser tomado si se va a usar en otro proyecto de software libre. De lo contrario abstngase de usar el cdigo o parte de el cdigo de WAR3D.
//*  3.- Queda estrictamente prohibido modificar los nombres que aparecen en los crditos del programa, solo el grupo de desarrollo de  Solar-OpenSource podr aadir nuevos nombres en los crditos. Si ha hecho alguna modificacin y quiere que su nombre aparezca en los crditos debe ponerse en contacto con nosotros.
//*  4.- Cualquier modificacin del cdigo debe apegarse en lo posible a las normas que ha establecido el grupo de desarrollo de Solar-OpenSource, esto es para mayor claridad en el cdigo. Dichas normas pueden encontrarse en nuestra pagina web http://www.solar-opensource.org
//*  5.- Puede copiar y distribuir el programa siempre y cuando no olvide: Acompaarlo con el cdigo fuente completo correspondiente, legible para la mquina, as como el cdigo escrito por usted o las modificaciones hechas al cdigo original.
//*  6.- No debe distribuirse el ejecutable sin el cdigo fuente.
//*  7.- Este texto no debe suprimirse. Las distribuciones deben acompaarse con la informacin que se recibi as como el ofrecimiento para distribuir el cdigo fuente correspondiente.
//*
//***************************************************************

// ZeruGiran (c)
//Fixero principal el cual pasa el control a eventos .

#include <iostream>
#include <string>
#include <fstream>
#include <vector>
#include <time.h>

using namespace std;
#define GLUT_DISABLE_ATEXIT_HACK
#include <stdlib.h>
#include <math.h>
#include <stdio.h>


#ifdef _WIN32 // Windows

#else // Linux
 #include <pthread.h>
#endif

#include "zeru_mat.h"

#include "configuracion.h"
#include "Logger.h"
//#include "W3DServer.h"
#include "eventos.h"

//#include "Pathfind.h"

//Bloke 1   Se ve de mierda esta parte pero funciona.
float __zcosArray[2160];
float __zsinArray[2160];
bool __zeruMatIni= false;
// End Bloke 1



//War3DP2PServer Servidor;




// Prototipos
void * th_inicia (void *param);
void SetupRC();
void SetupGL();


int main(int argc, char **argv) {

  cout << "   "  << WarVersion << endl;
  cout << "war3d.sourceforge.net" << endl;
  cout << endl;

  Logger loggerObj1("LogWar.html"); // Preparamos el archivo para el Log

  // Comprobamos a ver si hay algun error que impida el loggeo

  if(!loggerObj1.isValid()) {
	  puts("Algun error antes de comenzar con el log");
  }

  //LLegados a este punto todo va bien , empieza a loggear
  loggerObj1.logLn("<i><H5> No ha habido problemas , empieza la carga del war </i></H5>");

  iniciaZeruMat();

  //Eventos::Me = new Eventos;

  srand(time(0));

  /*
  if (argc == 2)
  {
      configuracion::Server =  argv[1];
	  if(configuracion::Server == "SERVER")
	  {
	    //War3DP2PServer Servidor;
	    Servidor.Escucha();
	    cout << "Servidor iniciado" << endl;
	  }
  }
  else
  {
	//War3DP2PServer Servidor;
	Servidor.Escucha();
	cout << "Servidor iniciado" << endl;
  }
  */

  glutInit(&argc, argv);

  configuracion::leerConfig ("War3D.conf");

  SetupGL();
  SetupRC(); //Inicia la iluminacion y algunas otras cosas

  glClearColor(0.47, 0.47, 0.47, 0.2);

  glutMouseFunc(zGlutMouseFunc);
  glutMotionFunc(zGlutMotionFunc);
  glutPassiveMotionFunc(zGlutPassiveMotionFunc);
  glutIdleFunc(zGlutIdleFunc);
  glutDisplayFunc(zGlutDisplayFunc);
  glutReshapeFunc(zGlutReshapeFunc);
  glutKeyboardFunc(zGlutKeyboardFunc);
  glutSpecialFunc(GlutKeyboardFuncS);
  
  glutMainLoop();

  alutExit();

  return 0;
}

void SetupGL()
{

  glClearDepth(1.1f);
  glEnable(GL_DEPTH_TEST);
  glDepthFunc(GL_LEQUAL);

  glHint(GL_PERSPECTIVE_CORRECTION_HINT, GL_NICEST);
  glEnable(GL_TEXTURE_2D);

  glEnable (GL_BLEND);
  glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);



  // Anti Alaising
  if (configuracion::AntiAlaising)
    {
      glEnable(GL_LINE_SMOOTH);
      glEnable(GL_POINT_SMOOTH);
      glDisable(GL_POLYGON_SMOOTH);
    }


  glEnable (GL_ALPHA_TEST);
  glAlphaFunc(GL_GREATER, 0.001);

  //-> Niebla
  glEnable(GL_FOG);
  glFogi(GL_FOG_MODE, GL_EXP2);
  GLfloat color_de_niebla[4]={1.0,1.0,1.0,1.0};
  glFogfv(GL_FOG_COLOR, color_de_niebla);
  glFogf(GL_FOG_DENSITY, 0.25);
  // <-- Niebla
}

void SetupRC()
{

  GLfloat  ambientLight0[] = { 0.3f, 0.3f, 0.3f, 1.0f };
  GLfloat  diffuseLight0[] = { 1.0f, 1.0f, 1.0f, 1.0f };
  GLfloat  specularLight0[] = { 0.0f, 0.0f, 0.0f, 0.0f };

  GLfloat lightAngulo0 = 90.0;
  GLfloat ligthEXPONENT0 = 0.0;

  GLfloat lightAten04 = .34;
  GLfloat lightAten01 = .34;
  GLfloat lightAten0c = .34;


  // Define e inicia la luz 0


  glLightfv(GL_LIGHT0,GL_AMBIENT,ambientLight0);
  glLightfv(GL_LIGHT0,GL_DIFFUSE,diffuseLight0);
  glLightfv(GL_LIGHT0,GL_SPECULAR,specularLight0);
  glLightfv(GL_LIGHT0,GL_SPOT_CUTOFF, &lightAngulo0);
  glLightfv(GL_LIGHT0,GL_SPOT_EXPONENT, & ligthEXPONENT0);
  glLightfv(GL_LIGHT0,GL_CONSTANT_ATTENUATION, &lightAten0c);
  glLightfv(GL_LIGHT0,GL_LINEAR_ATTENUATION, &lightAten01);
  glLightfv(GL_LIGHT0,GL_QUADRATIC_ATTENUATION, &lightAten04);
  glEnable(GL_LIGHT0);


  GLfloat  diffuseLight1[] = { 0.30f, 0.30f, 0.30f, 1.0f };


  GLfloat lightAngulo1 = 90.0;
  GLfloat ligthEXPONENT1 = 0.0;

  GLfloat lightAten14 = .20;
  GLfloat lightAten11 = .20;
  GLfloat lightAten1c = .20;


  // Define e inicia la luz 0



  glLightfv(GL_LIGHT1,GL_DIFFUSE,diffuseLight1);


  glLightfv(GL_LIGHT1,GL_SPOT_CUTOFF, &lightAngulo1);

  glLightfv(GL_LIGHT1,GL_SPOT_EXPONENT, & ligthEXPONENT1);
  glLightfv(GL_LIGHT1,GL_CONSTANT_ATTENUATION, &lightAten1c);
  glLightfv(GL_LIGHT1,GL_LINEAR_ATTENUATION, &lightAten11);
  glLightfv(GL_LIGHT1,GL_QUADRATIC_ATTENUATION, &lightAten14);
  glEnable(GL_LIGHT1);


  glFrontFace(GL_CW);		// Polgonos de sentido positivo hacia afuera
  glEnable(GL_CULL_FACE);		// No calcular las caras internas
  //glPolygonMode(GL_FRONT, GL_LINE);

  // Habilita la iluminacin
  glEnable(GL_LIGHTING);
  glShadeModel(GL_SMOOTH);

  // Activa el seguimiento de color
  glEnable(GL_COLOR_MATERIAL);

  // Selecciona las propiedades de material para el seguimiento de los valores de glColor
  //glColorMaterial(GL_FRONT, GL_AMBIENT_AND_DIFFUSE);
}


