//***************************************************************
//*  [[ A D V E R T E N C I A ]] =[ http://Solar-OpenSource.Org ]=
//*
//*  LICENCIA PARA LA DISTRIBUCIÓN DE WAR 3D
//*  1.- WAR 3D es un programa que podrá ser distribuido bajo los términos de la Licencia Pública General, además deberán cumplirse las siguientes condiciones.
//*  2.- Al copiar cualquier parte del código para ponerlo en un programa diferente a WAR 3D, el autor de dicho programa estará de acuerdo en que el código completo de su programa pasa a ser software libre, por lo deberá estar apegado a los términos establecidos por la licencia LGP. Es decir que, el código de WAR 3D solo puede ser tomado si se va a usar en otro proyecto de software libre. De lo contrario absténgase de usar el código o parte de el código de WAR3D.
//*  3.- Queda estrictamente prohibido modificar los nombres que aparecen en los créditos del programa, solo el grupo de desarrollo de  Solar-OpenSource podrá añadir nuevos nombres en los créditos. Si ha hecho alguna modificación y quiere que su nombre aparezca en los créditos debe ponerse en contacto con nosotros.
//*  4.- Cualquier modificación del código debe apegarse en lo posible a las normas que ha establecido el grupo de desarrollo de Solar-OpenSource, esto es para mayor claridad en el código. Dichas normas pueden encontrarse en nuestra pagina web http://www.solar-opensource.org
//*  5.- Puede copiar y distribuir el programa siempre y cuando no olvide: Acompañarlo con el código fuente completo correspondiente, legible para la máquina, así como el código escrito por usted o las modificaciones hechas al código original.
//*  6.- No debe distribuirse el ejecutable sin el código fuente.
//*  7.- Este texto no debe suprimirse. Las distribuciones deben acompañarse con la información que se recibió así como el ofrecimiento para distribuir el código fuente correspondiente.
//*
//***************************************************************

#ifndef __mouse_h__
#define __mouse_h__

#include <iostream>
#include <string>

using namespace std;

#include "singleton.h"

#include "constantes.h"

#include "zeru_mat.h"


// ------------------
typedef struct 
{
  float x;
  float y;
  float x_down;
  float y_down;
  int boton;
  int estado;
 
}strMouseState;

// ------------------
class Mouse;

// ------------------
class Mouse: public singleton<Mouse>
{

 private:

  Mouse();
  z2DVector Pantalla;
  strMouseState MouseState;
  
 public:

  static Mouse *ME() {static Mouse singleton; return &singleton;};  // Singleton
  void MouseEventos (int x, int y, int boton, int estado);

  z2DVector getPantalla() {return Pantalla;};
  void setPantalla(int x, int y) {Pantalla.x = x; Pantalla.y = y;};

  strMouseState getMouseState() {return MouseState;};
  
  z2DVector posTierra;

 private:
  
  int Mouse_dragNdrop (float x, float y, float x2, float y2, int boton);
  int Mouse_dobleClic (float x, float y, int boton);

  int Mouse_move (float x, float y);
  int Mouse_clic (float x, float y, int boton);
  int Mouse_down (float x, float y, int boton);
  int Mouse_up (float x, float y, int boton);

  
};

#endif
