//***************************************************************
//*  [[ A D V E R T E N C I A ]] =[ http://Solar-OpenSource.Org ]=
//*
//*  LICENCIA PARA LA DISTRIBUCIÓN DE WAR 3D
//*  1.- WAR 3D es un programa que podrá ser distribuido bajo los términos de la Licencia Pública General, además deberán cumplirse las siguientes condiciones.
//*  2.- Al copiar cualquier parte del código para ponerlo en un programa diferente a WAR 3D, el autor de dicho programa estará de acuerdo en que el código completo de su programa pasa a ser software libre, por lo deberá estar apegado a los términos establecidos por la licencia LGP. Es decir que, el código de WAR 3D solo puede ser tomado si se va a usar en otro proyecto de software libre. De lo contrario absténgase de usar el código o parte de el código de WAR3D.
//*  3.- Queda estrictamente prohibido modificar los nombres que aparecen en los créditos del programa, solo el grupo de desarrollo de  Solar-OpenSource podrá añadir nuevos nombres en los créditos. Si ha hecho alguna modificación y quiere que su nombre aparezca en los créditos debe ponerse en contacto con nosotros.
//*  4.- Cualquier modificación del código debe apegarse en lo posible a las normas que ha establecido el grupo de desarrollo de Solar-OpenSource, esto es para mayor claridad en el código. Dichas normas pueden encontrarse en nuestra pagina web http://www.solar-opensource.org
//*  5.- Puede copiar y distribuir el programa siempre y cuando no olvide: Acompañarlo con el código fuente completo correspondiente, legible para la máquina, así como el código escrito por usted o las modificaciones hechas al código original.
//*  6.- No debe distribuirse el ejecutable sin el código fuente.
//*  7.- Este texto no debe suprimirse. Las distribuciones deben acompañarse con la información que se recibió así como el ofrecimiento para distribuir el código fuente correspondiente.
//*
//***************************************************************


#include "PanelDeMiniFotos.h"

#include "ejercito.h"


// ---------------------------------------
void PanelDeMiniFotos::Inicia (float PosX, float PosY, float Ancho, float Alto, int ID)
{
  PanelMovible::Inicia(PosX, PosY, Ancho, Alto, ID);

  int i;	

  AddSetDeBotones ("Minifotos1");
  for (i=0 ; i<4 ; i++)
    {
      AddBoton ("Hud/Yens/bichosinfoto.tga", 2001 + i, 0);
    }

  AddSetDeBotones ("Minifotos2");
  for (i=0 ; i<16 ; i++)
    {
      AddBoton ("Hud/Yens/bichosinfoto.tga", 2001 + i, 1);
    }

  AddSetDeBotones ("Minifotos3");
  for (i=0 ; i<64 ; i++)
    {
      AddBoton ("Hud/Yens/bichosinfoto.tga", 2001 + i, 2);
    }


  AddSetDeBotones ("ListaDeEspera");
  for (i=0 ; i<6 ; i++)
    {
      AddBoton ("Hud/Yens/bichosinfoto.tga", 2001 + i, 3);
    }


  SetDeBotnesActivo = -1;
  NumBichosSeleccionados = 0;

}




// ---------------------------------------
int PanelDeMiniFotos::Mouse_down (float x, float y, int boton)
{

 int PanelBoton = PanelMovible::Mouse_down(x, y, boton);

 // Originalmente Mouse_clic regresa el ID del BotonClicqueado, pero vamos 
 // a forzar a que ahora regrese el ID del Panel.

 if (PanelBoton != 0)
   {
     return IDPanelDeMiniFotos;
   }
 else
   {
     return 0;
   }
}


// ---------------------------------------
int PanelDeMiniFotos::Mouse_clic (float x, float y, int boton)
{
  int PanelBoton = PanelMovible::Mouse_clic(x, y, boton);

  if (PanelBoton != 0)
    {
      
      if (SetDeBotnesActivo == 3)
	{
	  if (Ejercito::EdificioSelecionado != (oEdificio*)NULL)
	    {
	      Ejercito::EdificioSelecionado->cancelaBicho(PanelBoton-2001);
	    }
	}
      else
	{
	  int Contador = 1;
	  
	  if (glutGetModifiers() != GLUT_ACTIVE_CTRL) // Tecla Control presionada
	    {
	      
	      // Desseleccionamos todos menos el bicho clicado
	      vector<oSoldado*>::iterator Bicho;
	      vector<oSoldado*> *EjeX = Ejercito::TodosLosEjercitos.begin()->getEjercito();
	      for (Bicho=EjeX->begin(); Bicho != EjeX->end(); Bicho++)
		{
		  if ((*Bicho)->Seleccionado)
		    {
		      if ((PanelBoton-2000) == Contador)
			{
			  // No hacemos nada, el bicho se queda seleccionado
			}
		      else
			{
			  (*Bicho)->Seleccionado = false; 
			}
		      Contador++;
		    }
		}
	    }
	  else
	    {
	      
	      // Desseleccionamos el bicho clicado
	      vector<oSoldado*>::iterator Bicho;
	      vector<oSoldado*> *EjeX = Ejercito::TodosLosEjercitos.begin()->getEjercito();
	      for (Bicho=EjeX->begin(); Bicho != EjeX->end(); Bicho++)
		{
		  if ((*Bicho)->Seleccionado)
		    {
		      if ((PanelBoton-2000) == Contador)
			{
			  (*Bicho)->Seleccionado = false; 
			  break;
			}
		      else
			{
			  // No hacemos nada
			}
		      Contador++;
		    }
		}
	    }
	}
      return IDPanelDeMiniFotos;
    }
  else
    {
      return 0;
    }
}


// -----------------------------------------
void PanelDeMiniFotos::Dibujame()
{

  Alpha = 0.6;

  DibujameFondo();

  if (Ejercito::BichoSeleccionado != (oSoldado*)NULL)
    {
      if (NumBichosSeleccionados > 1)
	{
	  DibujameBotones();
	  DibujaBarrasDePoder();
	}
      else
	{
	  DibujameEstadisticas();
	}
      DibujaBicho();
    }
  else if (Ejercito::EdificioSelecionado != (oEdificio*)NULL)
    {
      SetDeBotnesActivo = 3;
      DibujameBotones();
      DibujaEdificio();
    }
  else if (Ejercito::BichoEnemigoSeleccionado != (oSoldado*)NULL)
    {
      DibujameEstadisticas();
      DibujaBicho();
    }

  Errores->Dibujame();
}


void PanelDeMiniFotos::setRetardo(float Retardo)
{

  this->Retardo = Retardo;
  
  // Clock 1;  
  static float Clock1 = 0.0;
  if (Clock1 > 1.0) { Clock1 = 0.0; onClock1();  } 
  else { Clock1 = Clock1 + 1/Retardo; }


}

// ---------------------------------------
void PanelDeMiniFotos::onClock1()
{

  // Esto es mal, no deberia ir aqui. ->
  static unsigned int ActualizaListaDeEspera = 0;
  if (Ejercito::EdificioSelecionado != (oEdificio*)NULL)
    {
      if (ActualizaListaDeEspera != Ejercito::EdificioSelecionado->ListaDeEspera.size())
	{
	  ActualizaListaDeEspera = Ejercito::EdificioSelecionado->ListaDeEspera.size();
	  Update();
	}
    }
  // <- Esto es mal, no deberia ir aqui.

}


// -----------------------------------------
// -----------------------------------------
// -----------------------------------------

// ---------------------------------------
void PanelDeMiniFotos::AddBoton (string Textura, int ID, int numSetDeBotones)
{

  const int Separador = 2;
  const int Cuadrito = 14;

  if (numSetDeBotones == 3) // Fotos de Bichos en lista de bichos en espera
    {
      int Lado = (int) pow(2.0, 2);
      float PosX = ((Cuadrito + Separador) * 7 * Pixel_H + Pixel_H) + 
	((Cuadrito + Separador) * (8 / Lado) * Pixel_H) * (SetDeBotones[numSetDeBotones].size() % Lado);
      float PosY = ((Cuadrito + Separador) * 3 * Pixel_V + Pixel_V) +
	((Cuadrito + Separador) * (8 / Lado) * Pixel_V) * (SetDeBotones[numSetDeBotones].size() / Lado);
      
      Boton NuevoBoton(Textura, PosX, PosY, 
		       ((Cuadrito * (8 / Lado) + Separador * ((8 / Lado)-1)) * Pixel_H),
		       ((Cuadrito * (8 / Lado) + Separador * ((8 / Lado)-1)) * Pixel_V),
		       ID);
      
      SetDeBotones[numSetDeBotones].push_back(NuevoBoton);
    }
  else // Fotos de Bichos seleccionados 
    {
      int Lado = (int) pow(2.0, numSetDeBotones+1);
      
      
      if (numSetDeBotones > -1 && numSetDeBotones < (int)SetDeBotones.size())  
	{
	  
	  float PosX = ((Cuadrito + Separador) * 7 * Pixel_H + Pixel_H) + 
	    ((Cuadrito + Separador) * (8 / Lado) * Pixel_H) * (SetDeBotones[numSetDeBotones].size() % Lado);
	  float PosY = ((Cuadrito + Separador) * 3 * Pixel_V + Pixel_V) +
	    ((Cuadrito + Separador) * (8 / Lado) * Pixel_V) * (SetDeBotones[numSetDeBotones].size() / Lado);
	  
	  Boton NuevoBoton(Textura, PosX, PosY, 
			   ((Cuadrito * (8 / Lado) + Separador * ((8 / Lado)-1)) * Pixel_H),
			   ((Cuadrito * (8 / Lado) + Separador * ((8 / Lado)-1)) * Pixel_V),
			   ID);
      
	  SetDeBotones[numSetDeBotones].push_back(NuevoBoton);
	}
      else
	{
	  War3DError ("PANELDECOMANDOS", "Intento de agregar un nuevo boton aun un set de botones inexistente");
	}
    }
}

// -------------------------------
void PanelDeMiniFotos::Update()
{

  Ejercito::TodosLosEjercitos.begin()->Update();

  NumBichosSeleccionados = 0;

  vector<oSoldado*>::iterator MiBicho;
  vector<oSoldado*> *EjeX = Ejercito::TodosLosEjercitos.begin()->getEjercito();

  for (MiBicho=EjeX->begin(); MiBicho != EjeX->end(); MiBicho++)
    {
      if ((*MiBicho)->Seleccionado == true)
	{
	  NumBichosSeleccionados ++;
	}
    }

  if (NumBichosSeleccionados > 16)
    {
      SetDeBotnesActivo = 2;
    }
  else if (NumBichosSeleccionados > 4)
    {
      SetDeBotnesActivo = 1;
    }
  else if (NumBichosSeleccionados > 0)
    {
      SetDeBotnesActivo = 0;
    }
  else
    {
      if (Ejercito::EdificioSelecionado == (oEdificio*)NULL)
	{
	  SetDeBotnesActivo = -1;
	}
      else
	{
	  SetDeBotnesActivo = 3;
	}
    }


 if (SetDeBotnesActivo == 3) // Fotos de Bichos en lista de bichos en espera
    {
      int i = 0;
      vector <int>::iterator Ite = Ejercito::EdificioSelecionado->ListaDeEspera.begin(); 

      vector<Boton>::iterator Bot;
      for (Bot = SetDeBotones[SetDeBotnesActivo].begin(); Bot != SetDeBotones[SetDeBotnesActivo].end(); Bot++)
	{
	  Bot->Activo = false;
	  if (Ite != Ejercito::EdificioSelecionado->ListaDeEspera.end())
	    {	  	  
	      for (i=0; i<Ejercito::EdificioSelecionado->getNumUnidades(); i++)
		{
		  if (*Ite == Ejercito::EdificioSelecionado->getUnidades()[i]->ID)
		    {
		      Bot->setTexturaNueva(Ejercito::EdificioSelecionado->getUnidades()[i]->MiniFoto);
		      Bot->Activo = true;
		      break;
		    }
		}
	      Ite++;
	    }
	}
    }
 else // Fotos de Bichos seleccionados.
   {
     MiBicho=EjeX->begin();

     if (SetDeBotnesActivo > -1 && SetDeBotnesActivo < (int)SetDeBotones.size())
       {
	 vector<Boton>::iterator Bot;
	 for (Bot = SetDeBotones[SetDeBotnesActivo].begin(); Bot != SetDeBotones[SetDeBotnesActivo].end(); Bot++)
	   {
	     
	     while (MiBicho != EjeX->end())
	       {
		 if ((*MiBicho)->Seleccionado == true)
		   {
		     break;
		   }
		 MiBicho++;
	       }
	     
	     if (MiBicho != EjeX->end())
	       {	      
		 Bot->setTexturaNueva((*MiBicho)->getMinifoto());
		 Bot->Activo = true;
		 MiBicho++;
	       }
	     else
	       {
		 Bot->Activo = false;
	       }
	    }
	}
    }
}

// ---------------------------
int PanelDeMiniFotos::DibujaBicho()
{
  oSoldado* Bicho;

  if (Ejercito::BichoSeleccionado != (oSoldado*)NULL)
    {
      Bicho = Ejercito::BichoSeleccionado;
    }
  else if (Ejercito::BichoEnemigoSeleccionado != (oSoldado*)NULL)
    {
      Bicho = Ejercito::BichoEnemigoSeleccionado;
    }
  else
    {
      return 0;
    }


  const int Separador = 2;
  const int Cuadrito = 14;


  float porciento =  Bicho->getSangre();
  float total = Bicho->getSangreTotal();


  miVistaGL.setVista(VistaGL_Ortogonal);

  glDisable(GL_LIGHTING);
  glDisable(GL_TEXTURE_2D);

  glPushMatrix();

 
  if (porciento > (total*0.3))
    {
      glColor4f(1.0, 1.0, 0.0, 0.6);
    }
  else
    {
      glColor4f(1.0, 0.3, 0.0, 0.7);
    }


  glTranslatef(PosicionDelPanel.x + ((Cuadrito + Separador) * 1.6 * Pixel_H), 
	       PosicionDelPanel.y + ((Cuadrito + Separador) * 9.8 * Pixel_V), -0.1);

  glLineWidth(4.5); 

  glBegin(GL_LINES);
  {
    glVertex3f(0.0, -(porciento/4000), 0.0);
    glVertex3f(0.0, 0.0, 0.0);
  }
  glEnd();

  glColor4f(0.6, 0.6, 0.6, 0.6);

  glLineWidth(4.5); 
  glBegin(GL_LINES);
  {
    glVertex3f(0.0, -(total/4000), 0.0);
    glVertex3f(0.0, -(porciento/4000), 0.0);
  }
  glEnd();

  glPopMatrix();


  // ---------------------------
  // ---------------------------
  // ---------------------------

  float zoom = Bicho->getModelo()->getRadio() / 0.0240; // Este numero se obtuvo experimentalmente

  glMatrixMode(GL_PROJECTION);
  glLoadIdentity();
  glOrtho(0, zoom, 0, zoom, -1, 1);
  glMatrixMode(GL_MODELVIEW);  // Escogemos la matriz de vista
  glLoadIdentity();
  glDisable(GL_LIGHTING);
  glEnable(GL_TEXTURE_2D);

  glPushMatrix();

  glTranslatef((PosicionDelPanel.x + (Cuadrito + Separador) * 3.5 * Pixel_H) * zoom,
	       (1.0 - (PosicionDelPanel.y + (Cuadrito + Separador) * 9.8 * Pixel_V)) * zoom, 0.1);



  AnguloDeBicho = AnguloDeBicho + 12.0/Retardo;

  glRotatef((int)AnguloDeBicho%360, 0.0, 1.0, 0.0);
  
  glColor4f(1.0, 1.0, 1.0, 1.0);
  Bicho->getModelo()->dibujame(0.0, 0.0, 0.0, Bicho->getAnima(), 0.0, 0.0); 

  glPopMatrix();
  return 1;
}


// ---------------------------
int PanelDeMiniFotos::DibujaEdificio ()
{

  if (Ejercito::EdificioSelecionado == (oEdificio*)NULL) return 0;

  const int Separador = 2;
  const int Cuadrito = 14;


  float porciento =  Ejercito::EdificioSelecionado->getSangre();
  float total = Ejercito::EdificioSelecionado->getSangreTotal();


  miVistaGL.setVista(VistaGL_Ortogonal);

  glDisable(GL_LIGHTING);
  glDisable(GL_TEXTURE_2D);

  glPushMatrix();
  
  if (porciento > (total*0.3))
    {
      glColor4f(1.0, 1.0, 0.0, 0.6);
    }
  else
    {
      glColor4f(1.0, 0.3, 0.0, 0.7);
    }


  glTranslatef(PosicionDelPanel.x + ((Cuadrito + Separador) * 1.6 * Pixel_H), 
	       PosicionDelPanel.y + ((Cuadrito + Separador) * 9.8 * Pixel_V), -0.1);

  glLineWidth(4.5); 

  glBegin(GL_LINES);
  {
    glVertex3f(0.0, -(porciento/15000), 0.0);
    glVertex3f(0.0, 0.0, 0.0);
  }
  glEnd();

  glColor4f(0.6, 0.6, 0.6, 0.6);

  glLineWidth(4.5); 
  glBegin(GL_LINES);
  {
    glVertex3f(0.0, -(total/15000), 0.0);
    glVertex3f(0.0, -(porciento/15000), 0.0);
  }
  glEnd();


  // ---------------------------
  // ---------------------------

  porciento =  Ejercito::EdificioSelecionado->getBichoTerminado()*300.0;
  total = 300.0;

  if (porciento > (total*0.3))
    {
      glColor4f(1.0, 1.0, 0.0, 0.6);
    }
  else
    {
      glColor4f(1.0, 0.3, 0.0, 0.7);
    }


  glTranslatef((Cuadrito + Separador) * 3.6 * Pixel_H, 0.0 , -0.1);

  glLineWidth(4.5); 

  glBegin(GL_LINES);
  {
    glVertex3f(0.0, -(porciento/4000), 0.0);
    glVertex3f(0.0, 0.0, 0.0);
  }
  glEnd();

  glColor4f(0.6, 0.6, 0.6, 0.5);

  glLineWidth(4.5); 
  glBegin(GL_LINES);
  {
    glVertex3f(0.0, -(total/4000), 0.0);
    glVertex3f(0.0, -(porciento/4000), 0.0);
  }
  glEnd();

  // ----

 
  // ----

  glPopMatrix();


  // ---------------------------
  // ---------------------------
  // ---------------------------
  
  float zoom = Ejercito::EdificioSelecionado->getModelo()->getRadio() / 0.0280; // Este numero se obtuvo experimentalmente

  glMatrixMode(GL_PROJECTION);
  glLoadIdentity();
  glOrtho(0, zoom, 0, zoom, -10, 10);
  glMatrixMode(GL_MODELVIEW);  // Escogemos la matriz de vista
  glLoadIdentity();
  glDisable(GL_LIGHTING);
  glEnable(GL_TEXTURE_2D);

  glPushMatrix();

  glTranslatef((PosicionDelPanel.x + (Cuadrito + Separador) * 3.0 * Pixel_H) * zoom,
	       (1.0 - (PosicionDelPanel.y + (Cuadrito + Separador) * 8.0 * Pixel_V)) * zoom, 0.1);

  glRotatef(90, 0.5, 0.8, 0.0);  

  AnguloDeBicho = AnguloDeBicho + 12.0/Retardo;
  
  glRotatef((int)AnguloDeBicho%360, 0.0, 1.0, 0.0);
  
  glColor4f(1.0, 1.0, 1.0, 1.0);
  Ejercito::EdificioSelecionado->getModelo()->dibujame(0.0, 0.0, 0.0, Ejercito::EdificioSelecionado->getAnima(), 0.0, 0.0); 
  
  glPopMatrix();

  return 1;
}

// ---------------------------
void PanelDeMiniFotos::DibujaBarrasDePoder ()
{

  miVistaGL.setVista(VistaGL_Ortogonal);
  
  glPushMatrix();
  glTranslatef(PosicionDelPanel.x, PosicionDelPanel.y, -0.1);
  
  glDisable(GL_LIGHTING);
  glDisable(GL_TEXTURE_2D);
  
  const int Separador = 2;
  const int Cuadrito = 14;
  int Contador = 0;

  int Lado = (int) pow(2.0, SetDeBotnesActivo+1);


  vector<oSoldado*>::iterator Bicho;
  
  vector<oSoldado*> *EjeX = Ejercito::TodosLosEjercitos.begin()->getEjercito();
  for (Bicho=EjeX->begin(); Bicho != EjeX->end(); Bicho++)
    {
      if ((*Bicho)->Seleccionado == true)
	{
	  
	  float PosX = ((Cuadrito + Separador) * 7 * Pixel_H + Pixel_H) + 
	    ((Cuadrito + Separador) * (8 / Lado) * Pixel_H) * (Contador % Lado);
	  float PosY = ((Cuadrito + Separador) * 3 * Pixel_V + Pixel_V) +
	    ((Cuadrito + Separador) * (8 / Lado) * Pixel_V) * (Contador / Lado);
	
	  float porciento =  (float)(*Bicho)->getSangre() / (*Bicho)->getSangreTotal();
	   
	  glColor4f(1.0, 1.0, 0.0, 0.6);

	  float Tam = ((Cuadrito * (8 / Lado) + Separador * ((8 / Lado)-1)) * Pixel_H);	  

	  glLineWidth(3.0); 
	  
	  glBegin(GL_LINES);
	  {
	    glVertex3f(PosX + (Tam*(1.0-porciento)), PosY+0.0015, 0.0);
	    glVertex3f(PosX + Tam,                   PosY+0.0015, 0.0);
	  }
	  glEnd();

	  	  
	  glColor4f(0.6, 0.6, 0.6, 0.6);

	  glLineWidth(3.0); 
	  glBegin(GL_LINES);
	  {
	    glVertex3f(PosX,                         PosY+0.0015, 0.0);
	    glVertex3f(PosX + (Tam*(1.0-porciento)), PosY+0.0015, 0.0);
	  }
	  glEnd();
	  
	  Contador ++;
	}
    }
  
  glPopMatrix();
  
}


// -----------------------------------
void  PanelDeMiniFotos::DibujameEstadisticas()
{

  oSoldado *Bicho;


  const int Separador = 2;
  const int Cuadrito = 14;

  float PosX;
  float PosY;
  string Cadena; 


  Alpha = Alpha + 0.2;

  PosX = ((Cuadrito + Separador) * 7 * Pixel_H + Pixel_H) + PosicionDelPanel.x;	 
  PosY = ((Cuadrito + Separador) * 3 * Pixel_V + Pixel_V) + PosicionDelPanel.y;


  if (Ejercito::BichoSeleccionado != (oSoldado*)NULL)
    {
      Bicho = Ejercito::BichoSeleccionado;
      Cadena = string("ID: ") + zitoa(Bicho->ID);
      TextServer.Escribe (Cadena, PosX, PosY, 5, 2, 0.7, 0.7, 1.0, Alpha);
    }
  else if (Ejercito::BichoEnemigoSeleccionado != (oSoldado*)NULL)
    {
      Bicho = Ejercito::BichoEnemigoSeleccionado;
      Cadena = string("Enemigo");
      TextServer.Escribe (Cadena, PosX, PosY, 5, 2, 1.0, 0.3, 0.3, Alpha);
    }
  else
    {
      return;
    }

  PosY = ((Cuadrito + Separador) * 4 * Pixel_V + Pixel_V) + PosicionDelPanel.y;

  Cadena = string("Vida ") + zitoa(Bicho->getSangre()) + "/" + zitoa(Bicho->getSangreTotal());
  TextServer.Escribe (Cadena, PosX, PosY, 4, 1, 1.0, 1.0, 1.0, Alpha);

  PosY = ((Cuadrito + Separador) * 5 * Pixel_V + Pixel_V) + PosicionDelPanel.y;

  Cadena = string("Poder   ") + zitoa(Bicho->getPoder());
  TextServer.Escribe (Cadena, PosX, PosY, 4, 1, 1.0, 1.0, 1.0, Alpha);

  PosY = ((Cuadrito + Separador) * 6 * Pixel_V + Pixel_V) + PosicionDelPanel.y;

  Cadena = string("Alcance ") + zitoa(Bicho->getAlcance());
  TextServer.Escribe (Cadena, PosX, PosY, 4, 1, 1.0, 1.0, 1.0, Alpha);

  PosY = ((Cuadrito + Separador) * 7 * Pixel_V + Pixel_V) + PosicionDelPanel.y;

  Cadena = string("Costo   ") + zitoa((int)Bicho->getCosto());
  TextServer.Escribe (Cadena, PosX, PosY, 4, 1, 1.0, 1.0, 1.0, Alpha);

  PosY = ((Cuadrito + Separador) * 8 * Pixel_V + Pixel_V) + PosicionDelPanel.y;

  Cadena = string("Exp     ") + zitoa(Bicho->getExperiencia());
  TextServer.Escribe (Cadena, PosX, PosY, 4, 1, 1.0, 1.0, 1.0, Alpha);

 PosY = ((Cuadrito + Separador) * 9 * Pixel_V + Pixel_V) + PosicionDelPanel.y;

  Cadena = string("Modo    ") + zitoa(Bicho->getModo());
  TextServer.Escribe (Cadena, PosX, PosY, 4, 1, 1.0, 1.0, 1.0, Alpha);

}
