//***************************************************************
//*  [[ A D V E R T E N C I A ]] =[ http://Solar-OpenSource.Org ]=
//*
//*  LICENCIA PARA LA DISTRIBUCIÓN DE WAR 3D
//*  1.- WAR 3D es un programa que podrá ser distribuido bajo los términos de la Licencia Pública General, además deberán cumplirse las siguientes condiciones.
//*  2.- Al copiar cualquier parte del código para ponerlo en un programa diferente a WAR 3D, el autor de dicho programa estará de acuerdo en que el código completo de su programa pasa a ser software libre, por lo deberá estar apegado a los términos establecidos por la licencia LGP. Es decir que, el código de WAR 3D solo puede ser tomado si se va a usar en otro proyecto de software libre. De lo contrario absténgase de usar el código o parte de el código de WAR3D.
//*  3.- Queda estrictamente prohibido modificar los nombres que aparecen en los créditos del programa, solo el grupo de desarrollo de  Solar-OpenSource podrá añadir nuevos nombres en los créditos. Si ha hecho alguna modificación y quiere que su nombre aparezca en los créditos debe ponerse en contacto con nosotros.
//*  4.- Cualquier modificación del código debe apegarse en lo posible a las normas que ha establecido el grupo de desarrollo de Solar-OpenSource, esto es para mayor claridad en el código. Dichas normas pueden encontrarse en nuestra pagina web http://www.solar-opensource.org
//*  5.- Puede copiar y distribuir el programa siempre y cuando no olvide: Acompañarlo con el código fuente completo correspondiente, legible para la máquina, así como el código escrito por usted o las modificaciones hechas al código original.
//*  6.- No debe distribuirse el ejecutable sin el código fuente.
//*  7.- Este texto no debe suprimirse. Las distribuciones deben acompañarse con la información que se recibió así como el ofrecimiento para distribuir el código fuente correspondiente.
//*
//***************************************************************

#include "Seleccion.h"

#include "eventos.h"
#include "astar_v1.h"

// Seleccion de bichos //


// -----------------------------
void Seleccion::Seleccionar(GLuint *selectBuf, int hits, int boton, bool BotonAgresivo, bool BotonBandera, bool BotonGuardia, int BotonNuevoEdificio)
{

  ReseteaBotones = true;

  this->BotonAgresivo = BotonAgresivo;
  this->BotonBandera = BotonBandera;
  this->BotonGuardia = BotonGuardia;

  this->BotonNuevoEdificio = BotonNuevoEdificio;
  
  bool BichoYaSeleccionado = SeleccionDeBichos(selectBuf, hits, boton);
  
  if (!BichoYaSeleccionado) 
    {

      bool BichoEnemigoYaSeleccionado = SeleccionDeBichosEnemigos(selectBuf, hits, boton);

      if (!BichoEnemigoYaSeleccionado)
	{

	  bool EdificioYaSeleccionado = SeleccionDeEdificios(selectBuf, hits, boton);
	  
	  if (!EdificioYaSeleccionado)
	    {

	      bool EdificioEnemigoYaSeleccionado = SeleccionDeEdificiosEnemigos(selectBuf, hits, boton);

	      if (!EdificioEnemigoYaSeleccionado)
		{

		  /*bool TerenoYaSeleccionado =*/ SeleccionDeTerreno(selectBuf, hits, boton);

		}
	    }
	}     
    }

  if (ReseteaBotones)
    {
      Eventos::ME()->ElPanelDeComandos.ResetPresionados();
    }
}

// -----------------------------
void Seleccion::Clean ()
{
  Ejercito::BichoSeleccionado = (oSoldado*)NULL;
  Ejercito::EdificioSelecionado = (oEdificio*)NULL;
  Ejercito::BichoEnemigoSeleccionado = (oSoldado*)NULL;

  for (vector <oSoldado*>::iterator Bicho=Ejercito::TodosLosEjercitos.begin()->getEjercito()->begin(); 
       Bicho != Ejercito::TodosLosEjercitos.begin()->getEjercito()->end(); 
       Bicho++)
    { // DesSeleccionamos todos.
      (*Bicho)->Seleccionado = false; 
    }

  for (vector <oEdificio*>::iterator Edificio=Ejercito::TodosLosEjercitos.begin()->getEdificios()->begin(); 
       Edificio != Ejercito::TodosLosEjercitos.begin()->getEdificios()->end(); 
       Edificio++)
    { // DesSeleccionamos todos.
      (*Edificio)->Seleccionado = false; 
    }  
}


// -----------------------------
bool Seleccion::SeleccionDeBichos(GLuint *selectBuf, int hits, int boton)
{

  vector <oSoldado*> BichosSelecionados;

  int SelectID;
  bool BichoYaSeleccionado = false;

  for(int L=1;L<=hits;L++)
    { // Iteramos por los objetos seleccionados.
      SelectID = selectBuf[4*L-1];
      
      if (SelectID % 1000 < 900 && SelectID % 1000 > 0)
	{ // Seleccion de bichos
	  
	  oSoldado* Bicho = SeleccionBicho(SelectID);
	  if (Bicho != (oSoldado*)NULL)
	    { // Tenemos almenos un bicho bajo el mouse
	      BichoYaSeleccionado = true;
	      
	      if (boton == 0)
		{
		  if (BotonAgresivo) // Bontones 
		    { // Boton de ataque presionado
		       for (vector<oSoldado*>::iterator MiBicho=Ejercito::TodosLosEjercitos.begin()->getEjercito()->begin(); 
			    MiBicho != Ejercito::TodosLosEjercitos.begin()->getEjercito()->end(); 
			    MiBicho++)
			 {
			   if ((*MiBicho)->Seleccionado == true)
			     {
			       (*MiBicho)->setModo(ModoCazador, 0.0, 0.0, Bicho->ID, 
						   (*MiBicho)->getLocalizacion().x, 
						   (*MiBicho)->getLocalizacion().y);
			     }
			 }
		       Eventos::ME()->ClicEnEnemigoFX->SetPosicion(Bicho->getLocalizacion().x,Bicho->getLocalizacion().y);
		    }
		  else if (BotonBandera)
		    { // Boton de bandera
		      
		    }
		  else if (BotonNuevoEdificio > 0)
		    { // Boton Nuevo edificio
		      BichoYaSeleccionado = false;
		      break;
		    }
		  else 
		    { // Ningun boton presionado
		      BichosSelecionados.push_back(Bicho);
		    }
		  
		}
	      else if (boton == 2)
		{
		  if (BotonAgresivo) // Bontones 
		    { // Boton de ataque presionado
		      
		    }
		  else if (BotonBandera)
		    { // Boton de bandera
		      
		    }
		  else if (BotonNuevoEdificio > 0)
		    { // Boton Nuevo edificio
		      
		    }
		  else 
		    { // Ningun boton presionado
		      
		      for (vector<oSoldado*>::iterator MiBicho=Ejercito::TodosLosEjercitos.begin()->getEjercito()->begin(); 
			    MiBicho != Ejercito::TodosLosEjercitos.begin()->getEjercito()->end(); 
			    MiBicho++)
			{
			  if ((*MiBicho)->Seleccionado == true)
			    {
			      (*MiBicho)->setModo(ModoGuardaEspaldas, 0.0, 0.0, Bicho->ID, 
						  (*MiBicho)->getLocalizacion().x, 
						  (*MiBicho)->getLocalizacion().y);
			      
			    }
			}
		      Eventos::ME()->ClicEnEnemigoFX->SetPosicion(Bicho->getLocalizacion().x,Bicho->getLocalizacion().y);
		    }
		}
	    }
	}
    }



  if (BichosSelecionados.size() != 0)
    {

      Clean();

      vector <oSoldado*>::iterator Bicho;
      Ejercito::BichoSeleccionado = (oSoldado*)NULL;
	
      for (Bicho = BichosSelecionados.begin() ; Bicho != BichosSelecionados.end() ; Bicho++)
	{ // Selecionamos solo los que nos interesan.
	  (*Bicho)->Seleccionado = true; 
	  if (Ejercito::BichoSeleccionado == (oSoldado*)NULL)
	    {
	      Ejercito::BichoSeleccionado = (*Bicho);	
	    }
	  
	  if ((*Bicho)->getCosto() > Ejercito::BichoSeleccionado->getCosto())
	    {
	      Ejercito::BichoSeleccionado = (*Bicho);
	    }
	}

      if (Ejercito::BichoSeleccionado != (oSoldado*)NULL)
	{
	  Ejercito::BichoSeleccionado->PlaySeleccionado();	
	}
    }


  // Actualizamos el bicho de mayor rango, edificio seleccionad y enemigoseleccionado
  return BichoYaSeleccionado;
}



// -----------------------------------------------
oSoldado* Seleccion::SeleccionBicho(int ID)
{
  vector<oSoldado*>::iterator Bicho;

  vector<oSoldado*> *EjeX = Ejercito::TodosLosEjercitos.begin()->getEjercito();
  for (Bicho=EjeX->begin(); Bicho != EjeX->end(); Bicho++)
    {
      if ((*Bicho)->ID == ID)
	{
	  if ((*Bicho)->getEstado() != EstadoMuertoDestruido)
	    {
	      return *Bicho;
	    }
	}
    }
  return (oSoldado*)NULL;
}


// ---------------------------------
bool Seleccion::SeleccionDeEdificios(GLuint *selectBuf, int hits, int boton)
{

  int SelectID;
  bool EdificioYaSeleccionado = false;
  oEdificio* EdificioSeleccionado = (oEdificio*) NULL;

  for(int L=1;L<=hits;L++)
    { // Iteramos por los objetos seleccionados.
      SelectID = selectBuf[4*L-1];
      
      if (SelectID % 1000 > 900 && SelectID < 10000)
	{// Seleccion de edificios
	  
	  EdificioSeleccionado = SelecionEdificio(SelectID);
	  if (EdificioSeleccionado != (oEdificio*)NULL)
	    { // Tenemos almenos un edificio bajo el mouse
	      EdificioYaSeleccionado = true;
	      
	      if (boton == 0)
		{
		  if (BotonAgresivo) // Bontones 
		    { // Boton de ataque presionado
		      for (vector<oSoldado*>::iterator MiBicho=Ejercito::TodosLosEjercitos.begin()->getEjercito()->begin(); 
			   MiBicho != Ejercito::TodosLosEjercitos.begin()->getEjercito()->end(); 
			   MiBicho++)
			{
			  if ((*MiBicho)->Seleccionado == true)
			    {
			      (*MiBicho)->setModo(ModoDestruyeEdificio, 0.0, 0.0, EdificioSeleccionado->ID, 
						  (*MiBicho)->getLocalizacion().x, 
						  (*MiBicho)->getLocalizacion().y);  
			    }
			}
		      Eventos::ME()->ClicEnEnemigoFX->SetPosicion(EdificioSeleccionado->getLocalizacion().x, EdificioSeleccionado->getLocalizacion().y);
		    }
		  else if (BotonBandera)
		    { // Boton de bandera
		      
		    }
		  else if (BotonNuevoEdificio > 0)
		    { // Boton Nuevo edificio
		      EdificioYaSeleccionado = false;
		      break;
		    }
		  else 
		    { // Ningun boton presionado
		      Clean();
		      Ejercito::EdificioSelecionado = EdificioSeleccionado;
		      EdificioSeleccionado->Seleccionado = true; 
		      break;
		    }
		}
	      else if (boton == 2)
		{
		  if (BotonAgresivo) // Bontones 
		    { // Boton de ataque presionado
		      
		    }
		  else if (BotonBandera)
		    { // Boton de bandera
		      
		    }
		  else if (BotonNuevoEdificio > 0)
		    { // Boton Nuevo edificio
		      EdificioYaSeleccionado = false;
		      break;
		    }
		  else 
		    { // Ningun boton presionado
		      EdificioYaSeleccionado = false;
		      break;
		    }
		}
	    }
	}
    }

  return EdificioYaSeleccionado;

}


// -----------------------------------------------
oEdificio* Seleccion::SelecionEdificio(int ID)
{

  vector<oEdificio*>::iterator Edificio;

  vector<oEdificio*> *Edifis = Ejercito::TodosLosEjercitos.begin()->getEdificios();
  for (Edificio = Edifis->begin(); Edificio != Edifis->end(); Edificio ++)
    {
      if ((*Edificio)->ID == ID)
	{
	  if ((*Edificio)->getEstado() != EstadoMuertoDestruido)
	    {
	      return *Edificio;
	    }
	}
    }
  return (oEdificio*)NULL;
}


// -------------------------------------------------
bool Seleccion::SeleccionDeTerreno(GLuint *selectBuf, int hits, int boton)
{

  z2DVector P;
  int SelectID;

  for(int L=1;L<=hits;L++)
    { // Iteramos por los objetos seleccionados.
      SelectID = selectBuf[4*L-1];
      
      if (SelectID > 1000)
	{
	  P = Tierra::ME()->getPunto(SelectID);
	  if (boton == 0)
	    {

	      if (BotonAgresivo) // Bontones 
		{ // Boton de ataque presionado
		  Eventos::ME()->Moviliza(P.x, P.y);
		}
	      else if (BotonBandera)
		{ // Boton de bandera
		  Ejercito::EdificioSelecionado->setBichoLocalizacion(P.x, P.y);
		}
	      else if (BotonNuevoEdificio > 0)
		{ // Boton Nuevo edificio
		  if (Ejercito::BichoSeleccionado->getTipo() != 1)
		    {
		      cout << "Bicho tipo: " << Ejercito::BichoSeleccionado->getTipo() << endl;
		      War3DError ( "EVENTOS", "SELECCION, Bicho de tipo incorrecto");
		    }
		  if(ValidaEdificio(BotonNuevoEdificio, P.x, P.y))
		    {
		      ((oSoldadoConstructor*)Ejercito::BichoSeleccionado)->
			nuevoEdificio(BotonNuevoEdificio, P.x, P.y);
		    }
		  else
		    {
		      ReseteaBotones = false;
		    }
		}
	      else 
		{ // Ningun boton presionado
		  
		}	 
	
	    }
	  else if (boton == 2)
	    {
	      if (BotonAgresivo) // Bontones 
		{ // Boton de ataque presionado
		  
		}
	      else if (BotonBandera)
		{ // Boton de bandera
		  
		}
	      else if (BotonNuevoEdificio > 0)
		{ // Boton Nuevo edificio

		}
	      else 
		{ // Ningun boton presionado
		  Eventos::ME()->Moviliza(P.x, P.y);
		}
	    }
	  break; // Solo seleccionamos un punto.
	}
    }
  return true;
}

// -------------------------------------------
bool Seleccion::ValidaEdificio(int Tipo, float x, float y)
{

  rendereable *ModeloEdificio;
  ModeloEdificio = Ejercito::TodosLosEjercitos.begin()->getArmy()->Contrucciones[Tipo-1].Modelo;

  return AStar::ME()->insertaObjeto(ModeloEdificio, x, y);
}


// ---------------------------------------
// ---------------------------------------
// ---------------------------------------

bool Seleccion::SeleccionDeBichosEnemigos(GLuint *selectBuf, int hits, int boton)
{

  int SelectID;
  bool BichoYaSeleccionado = false;

  for(int L=1;L<=hits;L++)
    { // Iteramos por los objetos seleccionados.
      SelectID = selectBuf[4*L-1];
      
      if (SelectID % 1000 < 900 && SelectID % 1000 > 0)
	{ // Seleccion de bichos
	  
	  oSoldado* Bicho = SeleccionBichoEnemigo(SelectID);
	  if (Bicho != (oSoldado*)NULL)
	    { // Tenemos almenos un bicho bajo el mouse
	      BichoYaSeleccionado = true;
	      
	      if (boton == 0)
		{
		  if (BotonAgresivo) // Bontones 
		    { // Boton de ataque presionado
		       for (vector<oSoldado*>::iterator MiBicho=Ejercito::TodosLosEjercitos.begin()->getEjercito()->begin(); 
			    MiBicho != Ejercito::TodosLosEjercitos.begin()->getEjercito()->end(); 
			    MiBicho++)
			 {
			   if ((*MiBicho)->Seleccionado == true)
			     {
			       (*MiBicho)->setModo(ModoCazador, 0.0, 0.0, Bicho->ID, 
						   (*MiBicho)->getLocalizacion().x, 
						   (*MiBicho)->getLocalizacion().y);
			     }
			 }
		       Eventos::ME()->ClicEnEnemigoFX->SetPosicion(Bicho->getLocalizacion().x,Bicho->getLocalizacion().y);
		    }
		  else if (BotonBandera)
		    { // Boton de bandera
		      
		    }
		  else if (BotonNuevoEdificio > 0)
		    { // Boton Nuevo edificio
		      BichoYaSeleccionado = false;
		      break;
		    }
		  else 
		    { // Ningun boton presionado
		      Clean();
		      Ejercito::BichoEnemigoSeleccionado = Bicho;
		    }
		  
		}
	      else if (boton == 2)
		{
		  if (BotonAgresivo) // Bontones 
		    { // Boton de ataque presionado
		      
		    }
		  else if (BotonBandera)
		    { // Boton de bandera
		      
		    }
		  else if (BotonNuevoEdificio > 0)
		    { // Boton Nuevo edificio
		      BichoYaSeleccionado = false;
		      break;
		    }
		  else 
		    { // Ningun boton presionado
		      for (vector<oSoldado*>::iterator MiBicho=Ejercito::TodosLosEjercitos.begin()->getEjercito()->begin(); 
			   MiBicho != Ejercito::TodosLosEjercitos.begin()->getEjercito()->end(); 
			   MiBicho++)
			{
			  if ((*MiBicho)->Seleccionado == true)
			    {
			      (*MiBicho)->setModo(ModoCazador, 0.0, 0.0, Bicho->ID, 
						  (*MiBicho)->getLocalizacion().x, 
						  (*MiBicho)->getLocalizacion().y);
			    }
			}
		      Eventos::ME()->ClicEnEnemigoFX->SetPosicion(Bicho->getLocalizacion().x,Bicho->getLocalizacion().y);
		    }
		}
	      break;
	    }
	}
    }

  // Actualizamos el bicho de mayor rango, edificio seleccionad y enemigoseleccionado
  return BichoYaSeleccionado;
}



// -----------------------------------------------
oSoldado* Seleccion::SeleccionBichoEnemigo(int ID)
{
  vector<Ejercito>::iterator Ejers;
  vector<oSoldado*>::iterator Bicho;
  vector<oSoldado*> *EjeX;

 for (Ejers=(Ejercito::TodosLosEjercitos.begin()+1); Ejers != Ejercito::TodosLosEjercitos.end(); Ejers++)
    {
      EjeX = Ejers->getEjercito();

      for (Bicho=EjeX->begin(); Bicho != EjeX->end(); Bicho++)
	{
	  if ((*Bicho)->ID == ID)
	    {
	      if ((*Bicho)->getEstado() != EstadoMuertoDestruido)
		{
		  cout << "enemigo seleccionado " << endl;
		  return *Bicho;
		}
	    }
	}
    }
  return (oSoldado*)NULL;
}


// ---------------------------------
bool Seleccion::SeleccionDeEdificiosEnemigos(GLuint *selectBuf, int hits, int boton)
{

  int SelectID;
  bool EdificioYaSeleccionado = false;
  oEdificio* EdificioSeleccionado = (oEdificio*) NULL;

  for(int L=1;L<=hits;L++)
    { // Iteramos por los objetos seleccionados.
      SelectID = selectBuf[4*L-1];
      
      if (SelectID % 1000 > 900 && SelectID < 10000)
	{// Seleccion de edificios
	  
	  EdificioSeleccionado = SelecionEdificioEnemigo(SelectID);
	  if (EdificioSeleccionado != (oEdificio*)NULL)
	    { // Tenemos almenos un edificio bajo el mouse
	      EdificioYaSeleccionado = true;
	      
	      if (boton == 0)
		{
		  if (BotonAgresivo) // Bontones 
		    { // Boton de ataque presionado
		      for (vector<oSoldado*>::iterator MiBicho=Ejercito::TodosLosEjercitos.begin()->getEjercito()->begin(); 
			   MiBicho != Ejercito::TodosLosEjercitos.begin()->getEjercito()->end(); 
			   MiBicho++)
			{
			  if ((*MiBicho)->Seleccionado == true)
			    {
			      (*MiBicho)->setModo(ModoDestruyeEdificio, 0.0, 0.0, EdificioSeleccionado->ID, 
						  (*MiBicho)->getLocalizacion().x, 
						  (*MiBicho)->getLocalizacion().y);  
			    }
			}
		    }
		  else if (BotonBandera)
		    { // Boton de bandera
		      
		    }
		  else if (BotonNuevoEdificio > 0)
		    { // Boton Nuevo edificio
		      EdificioYaSeleccionado = false;
		      break;
		    }
		  else 
		    { // Ningun boton presionado
		      
		    }
		}
	      else if (boton == 2)
		{
		  if (BotonAgresivo) // Bontones 
		    { // Boton de ataque presionado
		      
		    }
		  else if (BotonBandera)
		    { // Boton de bandera
		      
		    }
		  else if (BotonNuevoEdificio > 0)
		    { // Boton Nuevo edificio
		      EdificioYaSeleccionado = false;
		      break;
		    }
		  else 
		    { // Ningun boton presionado
		      for (vector<oSoldado*>::iterator MiBicho=Ejercito::TodosLosEjercitos.begin()->getEjercito()->begin(); 
			   MiBicho != Ejercito::TodosLosEjercitos.begin()->getEjercito()->end(); 
			   MiBicho++)
			{
			  if ((*MiBicho)->Seleccionado == true)
			    {
			      (*MiBicho)->setModo(ModoDestruyeEdificio, 0.0, 0.0, EdificioSeleccionado->ID, 
						  (*MiBicho)->getLocalizacion().x, 
						  (*MiBicho)->getLocalizacion().y);  
			    }
			}
		    }
		}
	    }
	}
    }

  return EdificioYaSeleccionado;

}


// -----------------------------------------------
oEdificio* Seleccion::SelecionEdificioEnemigo(int ID)
{

  vector<Ejercito>::iterator Ejers;
  vector<oEdificio*>::iterator Edificio;
  vector<oEdificio*> *Edifis;

  for (Ejers=(Ejercito::TodosLosEjercitos.begin()+1); Ejers != Ejercito::TodosLosEjercitos.end(); Ejers++)
    {
      
      Edifis = Ejers->getEdificios();
      for (Edificio = Edifis->begin(); Edificio != Edifis->end(); Edificio ++)
	{
	  if ((*Edificio)->ID == ID)
	    {
	      if ((*Edificio)->getEstado() != EstadoMuertoDestruido)
		{
		  return *Edificio;
		}
	    }
	}
    }
  return (oEdificio*)NULL;
}
