//***************************************************************
//*  [[ A D V E R T E N C I A ]] =[ http://Solar-OpenSource.Org ]=
//*
//*  LICENCIA PARA LA DISTRIBUCIÓN DE WAR 3D
//*  1.- WAR 3D es un programa que podrá ser distribuido bajo los términos de la Licencia Pública General, además deberán cumplirse las siguientes condiciones.
//*  2.- Al copiar cualquier parte del código para ponerlo en un programa diferente a WAR 3D, el autor de dicho programa estará de acuerdo en que el código completo de su programa pasa a ser software libre, por lo deberá estar apegado a los términos establecidos por la licencia LGP. Es decir que, el código de WAR 3D solo puede ser tomado si se va a usar en otro proyecto de software libre. De lo contrario absténgase de usar el código o parte de el código de WAR3D.
//*  3.- Queda estrictamente prohibido modificar los nombres que aparecen en los créditos del programa, solo el grupo de desarrollo de  Solar-OpenSource podrá añadir nuevos nombres en los créditos. Si ha hecho alguna modificación y quiere que su nombre aparezca en los créditos debe ponerse en contacto con nosotros.
//*  4.- Cualquier modificación del código debe apegarse en lo posible a las normas que ha establecido el grupo de desarrollo de Solar-OpenSource, esto es para mayor claridad en el código. Dichas normas pueden encontrarse en nuestra pagina web http://www.solar-opensource.org
//*  5.- Puede copiar y distribuir el programa siempre y cuando no olvide: Acompañarlo con el código fuente completo correspondiente, legible para la máquina, así como el código escrito por usted o las modificaciones hechas al código original.
//*  6.- No debe distribuirse el ejecutable sin el código fuente.
//*  7.- Este texto no debe suprimirse. Las distribuciones deben acompañarse con la información que se recibió así como el ofrecimiento para distribuir el código fuente correspondiente.
//*
//***************************************************************

/* ZeruGiran  zerugiran@gmail.com */


#include "W3DPlayerComandos.h"

#include "W3DServer.h"



/////////////////////////////////
W3DPlayerComandoBASE::W3DPlayerComandoBASE(string Comando, void* Padre)
{ 
  strComando = Comando; 
  this->Padre = Padre;
}

/////////////////////////////////
bool W3DPlayerComandoBASE::Accion(string Comando)
{

  vector<string> ComandoParceado;

  string Cadena = Comando;

  Cadena = Cadena.substr(0,Cadena.size()-2); //Quitamos el "\r\n"
  int fin;

  bool Primera = true;
  for (;;)
    {
      fin = Cadena.find (" ");
      if (fin != (int)string::npos)
	{
	  ComandoParceado.push_back(Cadena.substr(0, fin));
	  if (Primera)
	    {
	      if (Cadena.substr(0, fin) != strComando) 
		{
		  return false;
		}
	    }
	  Primera = false;
	}
      else
	{
	  ComandoParceado.push_back(Cadena);
	  break;
	}
      Cadena = Cadena.substr(fin+1, 999);
    }


  if ((ComandoParceado.size() > 0) && (ComandoParceado[0] == strComando))

  onAccion(ComandoParceado);
  return true;
}


///////////// SETARMY /////////////
void W3DPlayerComandoSETARMY::onAccion(vector<string> ComandoParceado)
{
  if (ComandoParceado.size() > 1)
    {
      ((W3DPlayer*)Padre)->Army = ComandoParceado[1];
      W3DServer::ME()->ServidorDeSockets.SendMulticast(string("SETARMY ") +
						       zitoa(((W3DPlayer*)Padre)->ID) + 
						       " " + 
						       ComandoParceado[1] + 
						       "\r\n", 
						       ((W3DPlayer*)Padre)->ID);
    }
}


///////////// LISTO /////////////
void W3DPlayerComandoLISTO::onAccion(vector<string> ComandoParceado)
{
  if (ComandoParceado.size() > 1)
    {
      if (ComandoParceado[1] == "TRUE")
	{
	  ((W3DPlayer*)Padre)->Listo = true;
	}
      else
	{
	  ((W3DPlayer*)Padre)->Listo = false;
	}
    }  
}


///////////// NICK /////////////
void W3DPlayerComandoNICK::onAccion(vector<string> ComandoParceado)
{

  if (ComandoParceado.size() > 1)
    {

      ((W3DPlayer*)Padre)->Nick = ComandoParceado[1];
      W3DServer::ME()->ServidorDeSockets.SendMulticast(string("NICK ") +
						       zitoa(((W3DPlayer*)Padre)->ID) + 
						       " " +
						       ComandoParceado[1] + 
						       "\r\n", 
						       ((W3DPlayer*)Padre)->ID);      
    }  
}


///////////// CHAT /////////////
void W3DPlayerComandoCHAT::onAccion(vector<string> ComandoParceado)
{

  string Mensaje;
    
  if (ComandoParceado.size() > 1)
    {

      for (unsigned int i = 1; i<ComandoParceado.size(); i++)
	{
	  Mensaje += ComandoParceado[i] + " ";
	}
      
      ((W3DPlayer*)Padre)->Nick = ComandoParceado[1];

      
      W3DServer::ME()->ServidorDeSockets.SendMulticast(string("CHAT ") +
						       zitoa(((W3DPlayer*)Padre)->ID) + 
						       " " +
						       Mensaje +
						       "\r\n", 
						       ((W3DPlayer*)Padre)->ID);      
    }  
}


///////////// START /////////////
void W3DPlayerComandoINICIA::onAccion(vector<string> ComandoParceado)
{
  bool TodosListos = true;

  if (((W3DPlayer*)Padre)->Admin)
    {
      for (vector <W3DPlayer*>::iterator Ite = W3DServer::ME()->W3DPlayers.begin(); 
	   Ite != W3DServer::ME()->W3DPlayers.end(); 
	   Ite++)
	{
	  cout << "Player[" << (*Ite)->ID << "]" << (*Ite)->Listo << " " << (*Ite)->Nick << " " << (*Ite)->Army << endl;
	  TodosListos = TodosListos && ((*Ite)->Listo && (*Ite)->Nick != "" && (*Ite)->Army != "");
	  if (!(((*Ite)->Listo && (*Ite)->Nick != "" && (*Ite)->Army != "")))
	    {
	      cout << "El jugador " << (*Ite)->ID << " aun no esta listo" << endl;
	    }
	}
      if (TodosListos)
	{
	  
	  W3DServer::ME()->Reset();
	  W3DServer::ME()->ServidorDeSockets.SendMulticast(string("INICIA") + "\r\n");

	}
    }
  else
    {
      cout << "Un cliente No Admin intento iniciar la partida" << endl;
    }
}


///////////// AGREGAEDIFICIO /////////////
void W3DPlayerComandoAGREGAEDIFICIO::onAccion(vector<string> ComandoParceado)
{
  if (ComandoParceado.size() > 4)
    {

      W3DServer::ME()->ServidorDeSockets.SendMulticast(string("AGREGAEDIFICIO ") 
						       + zitoa(((W3DPlayer*)Padre)->ID) + " " 
						       + ComandoParceado[1] + " " 
						       + ComandoParceado[2] + " " + ComandoParceado[3] + " "
						       + ComandoParceado[4] + "\r\n", ((W3DPlayer*)Padre)->ID);
    }
}


///////////// AGREGAEDIFICIO /////////////
void W3DPlayerComandoAGREGASOLDADO::onAccion(vector<string> ComandoParceado)
{
  if (ComandoParceado.size() > 4)
    {

      W3DServer::ME()->ServidorDeSockets.SendMulticast(string("AGREGASOLDADO ") 
						       + zitoa(((W3DPlayer*)Padre)->ID) + " " 
						       + ComandoParceado[1] + " " 
						       + ComandoParceado[2] + " " + ComandoParceado[3] + " "
						       + ComandoParceado[4] + "\r\n", ((W3DPlayer*)Padre)->ID);
    }
}

///////////// MODO /////////////
void W3DPlayerComandoMOD::onAccion(vector<string> ComandoParceado)
{
  if (ComandoParceado.size() > 8)
    {
      W3DServer::ME()->ServidorDeSockets.SendMulticast(string ("MOD ") 
						       + zitoa(((W3DPlayer*)Padre)->ID) + " " 
						       + ComandoParceado[1] + " " 
						       + ComandoParceado[2] + " " 
						       + ComandoParceado[3] + " " 
						       + ComandoParceado[4] + " " 
						       + ComandoParceado[5] + " "
						       + ComandoParceado[6] + " " 
						       + ComandoParceado[7] + " "
						       + ComandoParceado[8] + "\r\n", ((W3DPlayer*)Padre)->ID);
    }
}
