//***************************************************************
//*  [[ A D V E R T E N C I A ]] =[ http://Solar-OpenSource.Org ]=
//*
//*  LICENCIA PARA LA DISTRIBUCIÓN DE WAR 3D
//*  1.- WAR 3D es un programa que podrá ser distribuido bajo los términos de la Licencia Pública General, además deberán cumplirse las siguientes condiciones.
//*  2.- Al copiar cualquier parte del código para ponerlo en un programa diferente a WAR 3D, el autor de dicho programa estará de acuerdo en que el código completo de su programa pasa a ser software libre, por lo deberá estar apegado a los términos establecidos por la licencia LGP. Es decir que, el código de WAR 3D solo puede ser tomado si se va a usar en otro proyecto de software libre. De lo contrario absténgase de usar el código o parte de el código de WAR3D.
//*  3.- Queda estrictamente prohibido modificar los nombres que aparecen en los créditos del programa, solo el grupo de desarrollo de  Solar-OpenSource podrá añadir nuevos nombres en los créditos. Si ha hecho alguna modificación y quiere que su nombre aparezca en los créditos debe ponerse en contacto con nosotros.
//*  4.- Cualquier modificación del código debe apegarse en lo posible a las normas que ha establecido el grupo de desarrollo de Solar-OpenSource, esto es para mayor claridad en el código. Dichas normas pueden encontrarse en nuestra pagina web http://www.solar-opensource.org
//*  5.- Puede copiar y distribuir el programa siempre y cuando no olvide: Acompañarlo con el código fuente completo correspondiente, legible para la máquina, así como el código escrito por usted o las modificaciones hechas al código original.
//*  6.- No debe distribuirse el ejecutable sin el código fuente.
//*  7.- Este texto no debe suprimirse. Las distribuciones deben acompañarse con la información que se recibió así como el ofrecimiento para distribuir el código fuente correspondiente.
//*
//***************************************************************

/* ZeruGiran  zerugiran@gmail.com */


#include "W3DServer.h"


///////////////////////
//////  EVENTOS  //////
///////////////////////

//////////////////////////////
void zSolarSocketEventoConectado (int ID, ssServer* Server){ W3DServer::ME()->Conectado(ID, Server); }
//////////////////////////////
bool zSolarSocketEventoRecibe (string Cadena, int ID, ssServer* Server){ return W3DServer::ME()->Recive(Cadena, ID, Server); }
//////////////////////////////
void zSolarSocketEventoCierra(int ID, ssServer* Server){ W3DServer::ME()->Cierra(ID, Server); }
// ---------------------------
void zSolarSocketEventoError(int ssError, int ID, ssServer* Server){ W3DServer::ME()->Error(ssError, ID, Server); }

//////////////////////////////
void W3DServer::Conectado(int ID, ssServer* Server)
{

  if (W3DPlayers.size() < 2) 
    {
      cout << "Nuevo jugador con IP: "  << Server->getIP(ID) << endl;
      Server->Accept(); // NUEVO Aceptamos la coneccion
      
      W3DPlayer *NuevoW3DPlayer = new W3DPlayer(ID, this);
      
      NuevoW3DPlayer->sendLISTANICKS();
      NuevoW3DPlayer->sendENTRA();

      W3DPlayers.push_back(NuevoW3DPlayer);

      NuevoW3DPlayer->sendPOSINI();

      NuevoW3DPlayer->sendADMIN();

    }
  else
    {
      // TODO ZG. Aceptar la conexion, enviar un mensaje de partida 
      // llena y desconectar.
      cout << "Solo se admiten partidasd de Dos Jugadores" << endl;
    }
}

//////////////////////////////
void W3DServer::Cierra(int ID, ssServer* Server)
{
  cout << "El W3DPlayer " << ID << " avandona la partida." << endl;
  // !!TODO!! Guardar en la base de datos las estadisticas del Jugador

  //MutexW3DPlayers.Lock();  
  
  for (vector<W3DPlayer*>::iterator Ite = W3DPlayers.begin(); Ite != W3DPlayers.end(); Ite++)
    {
      if ((*Ite)->ID == ID)
	{
	  ServidorDeSockets.SendMulticast(string("SALIDA 00 ") +  zitoa(ID) + "\r\n", ID);
	  W3DPlayers.erase(Ite);
	  break;
	}
    }
  //MutexW3DPlayers.UnLock(); 
}

////////////////////////////////////
void W3DServer::Error(int ssError, int ID, ssServer* Server)
{
}

////////////////////////////////////
bool W3DServer::Recive(string Cadena, int ID, ssServer* Server)
{
  //MutexW3DPlayers.Lock();  
  vector <W3DPlayer*>::iterator Ite;
  for (Ite = W3DPlayers.begin(); Ite != W3DPlayers.end(); Ite++)
    {
      if ((*Ite)->ID == ID)
	{
	  (*Ite)->ConexionRecive(Cadena);
	}
    }

  //MutexW3DPlayers.UnLock();  
  Retardo();
  return true;


}



/////////////////////////////////////
///////       COMANDOS        ///////
/////////////////////////////////////


/////////////////////////
void W3DServer::sendCLIMA(bool Dia, int Duracion)
{
  if (Dia) 
    ServidorDeSockets.SendMulticast( string("CLIMA DIA ") +  zitoa(Duracion) + "\r\n");
  else
    ServidorDeSockets.SendMulticast( string("CLIMA NOCHE ") +  zitoa(Duracion) + "\r\n");
}

/////////////////////////
void W3DServer::sendRECURSOS(int x, int y, int cantidad)
{
  ServidorDeSockets.SendMulticast( string("RECURSOS")  
				   + " " + zitoa(x) 
				   + " " + zitoa(y)
				   + " " + zitoa(cantidad)
				   + "\r\n");  
} 


///////////////////////
//////  METODOS  //////
///////////////////////

//////// ISLASERVER ///////////
W3DServer::W3DServer()
{
  //char TMP[256]; sprintf(TMP, "BufferDeComandos[%d]", (int)this);
  //MutexW3DPlayers.Create(TMP);
}

//////////////////////////////
void W3DServer::Inicializa()
{

  // Le decimoda que funcion hay que llamar cuando ocurra el evento Recive
  ServidorDeSockets.setOnDataArrival(zSolarSocketEventoRecibe);
  // Le decimos a que funcion hay que llamar cuando ocurra el evento Connect
  ServidorDeSockets.setOnConnect(zSolarSocketEventoConectado);
  // Le decimos a que funcion hay que llamar cuando ocurra el evento Close
  ServidorDeSockets.setOnClose(zSolarSocketEventoCierra);
  //  Le decimos a que funcion hay que llamar cuando ocurra el evento Error
  ServidorDeSockets.setOnError(zSolarSocketEventoError);
  // Simulamos lag de X Milisegundos
  ServidorDeSockets.setLag(0);
  // Lo ponemos a escuchar por el puerto.
  ServidorDeSockets.Listen(W3DDedicadoPuerto);

  Tiempo = glutGet(GLUT_ELAPSED_TIME); 


}

//////////////////////////////
void W3DServer::Reset()
{
  Tiempo = glutGet(GLUT_ELAPSED_TIME); 
  sendCLIMA(false, DiaNoche_Noche);
  sendCLIMA(true, DiaNoche_Dia - DiaNoche_Adelanto);
  
}

//////////////////////////////
void W3DServer::Retardo()
{
  // Ocurre cada cierto tiempo.
  
  long int TiempoDesde = glutGet(GLUT_ELAPSED_TIME) - Tiempo;

  static long int TiempoAnterior; 
  long int TiempoInclemento = TiempoDesde - TiempoAnterior;
  TiempoAnterior = TiempoDesde;  

  Clima(TiempoInclemento);  

}

//////////////////////////////
void W3DServer::Clima(int TIncremento)
{

  static bool Dia_Noche = true;
  static bool PutRecursos = true;

  static long int ClockDiaNoche = DiaNoche_Adelanto * 1000;
  ClockDiaNoche = ClockDiaNoche + TIncremento;

  cout << "Time: " << ClockDiaNoche << " " << DiaNoche_Dia * 1000 << endl;


  if (ClockDiaNoche > (DiaNoche_Dia + DiaNoche_Noche) * 1000)
  {

    PutRecursos = true;
    ClockDiaNoche = 0;
    return;
  }
  if (ClockDiaNoche >= DiaNoche_Dia*1000)
    {
      if (Dia_Noche)
	{
	  sendCLIMA(false, DiaNoche_Noche);
	  Dia_Noche = false;
	}
      if (PutRecursos)
	{
	  putRecursos();
	  PutRecursos = false;
	}
      return;
    }
  if (ClockDiaNoche >= 0)
    {
      if (!Dia_Noche)
	{
	  sendCLIMA(true, DiaNoche_Dia);
	  Dia_Noche = true;
	}
      return;
    }
}

//////////////////////////////
void W3DServer::putRecursos()
{
  vector <W3DPlayer*>::iterator Ite;
  for (Ite = W3DPlayers.begin(); Ite != W3DPlayers.end(); Ite++)
    {
      
      float x;
      float y;
      
      float xx;
      float yy;
      
      float Radio1 = 330;
      float Radio2 = (int)(Radio1 * 1.5 * 1.5);
      
      do 
	{
	  x = 0.14 * (rand() % 1000);
	  y = 0.14 * (rand() % 1000);
	  
	  xx = (x-(*Ite)->PosIniX/100) * (x-(*Ite)->PosIniX/100);
	  yy = (y-(*Ite)->PosIniY/100) * (y-(*Ite)->PosIniY/100);
    cout << "PUTRECURSOS: " << x << " " << y << endl;
	  
	} while (!((xx+yy >= Radio1) && (xx+yy <= Radio2)));
      
      
      float x2;
      float y2;

      
      cout << "PUTRECURSOS: " << x << " " << y << endl;
      
      for (int i = 0 ; i<10 ; i++)
	{
	  
	  x2 = 0.004 * (rand() % 1000);
	  y2 = 0.004 * (rand() % 1000);
    cout << "PUTRECURSOS: " << x << " " << y << endl;
	  
	  sendRECURSOS((int)((x+x2)*100), (int)((y+y2)*100), 20);
	    
	} 
    }
}
