//***************************************************************
//*  [[ A D V E R T E N C I A ]] =[ http://Solar-OpenSource.Org ]=
//*
//*  LICENCIA PARA LA DISTRIBUCIÓN DE WAR 3D
//*  1.- WAR 3D es un programa que podrá ser distribuido bajo los términos de la Licencia Pública General, además deberán cumplirse las siguientes condiciones.
//*  2.- Al copiar cualquier parte del código para ponerlo en un programa diferente a WAR 3D, el autor de dicho programa estará de acuerdo en que el código completo de su programa pasa a ser software libre, por lo deberá estar apegado a los términos establecidos por la licencia LGP. Es decir que, el código de WAR 3D solo puede ser tomado si se va a usar en otro proyecto de software libre. De lo contrario absténgase de usar el código o parte de el código de WAR3D.
//*  3.- Queda estrictamente prohibido modificar los nombres que aparecen en los créditos del programa, solo el grupo de desarrollo de  Solar-OpenSource podrá añadir nuevos nombres en los créditos. Si ha hecho alguna modificación y quiere que su nombre aparezca en los créditos debe ponerse en contacto con nosotros.
//*  4.- Cualquier modificación del código debe apegarse en lo posible a las normas que ha establecido el grupo de desarrollo de Solar-OpenSource, esto es para mayor claridad en el código. Dichas normas pueden encontrarse en nuestra pagina web http://www.solar-opensource.org
//*  5.- Puede copiar y distribuir el programa siempre y cuando no olvide: Acompañarlo con el código fuente completo correspondiente, legible para la máquina, así como el código escrito por usted o las modificaciones hechas al código original.
//*  6.- No debe distribuirse el ejecutable sin el código fuente.
//*  7.- Este texto no debe suprimirse. Las distribuciones deben acompañarse con la información que se recibió así como el ofrecimiento para distribuir el código fuente correspondiente.
//*
//***************************************************************

#ifndef __ServidorDeDisparos_h__
#define __ServidorDeDisparos_h__


#include <iostream>
#include <string>
#include <vector>

using namespace std;

#include "singleton.h"

#include "constantes.h"
#include "texturas.h"

#include "zeru_mat.h"

#define ProyectilTipoBala         001
#define ProyectilTipoBolaDeFuego  002
#define ProyectilTipoMisil        003
#define ProyectilTipoLaser        004
#define ProyectilTipoEspiral      005

#define NumTiposDeProyectil    2


// ---------------------------
class TipoProyectil_Base
{
 private:

 public:
  TipoProyectil_Base(){velocidad = 0.005;};
  virtual ~TipoProyectil_Base(){};

  float velocidad;
  virtual void setRetardo(float Retardo) = 0;
  virtual void Dibujame (z3DVector Localizacion, z3DVector Direccion) = 0;
  virtual void onBlanco (z3DVector Fin) = 0;
};


// ---------------------------
class Proyectil
{
 private:

  z3DVector Localizacion;
  z3DVector Fin;
  z3DVector Direccion;
  TipoProyectil_Base *MyProyectil;
  bool TrayectoriaFinalizada;
 
 public:

  Proyectil(z3DVector Inicio, z3DVector Fin, TipoProyectil_Base *MyProyectil);
  ~Proyectil ();

  bool Desapareceme() {return TrayectoriaFinalizada;};

  void setRetardo(float Retardo);
  void Dibujame();
  void onBlanco ();
};


// ---------------------------
class ServidorDeDisparos: public singleton<ServidorDeDisparos>
{

 public: 

  ServidorDeDisparos();

  bool Inicializada;
  TipoProyectil_Base **TiposDeProyectil;
  vector<Proyectil*> ListaDeProyectiles;

 public:
  void Nuevo(z3DVector Inicio, z3DVector Fin, int Tipo);
  void setRetardo(float Retardo);
  void Dibujame();
};





// ---------------------------
class TipoProyectilBALA: public TipoProyectil_Base
{
 private:

 public:
  
  TipoProyectilBALA();
  ~TipoProyectilBALA();

  void setRetardo(float Retardo);
  void Dibujame (z3DVector Localizacion, z3DVector Direccion);
  void onBlanco (z3DVector Fin);
};


// ---------------------------
class TipoProyectilBOLA: public TipoProyectil_Base
{
 private:

 public:
  
  TipoProyectilBOLA();
  ~TipoProyectilBOLA();

  void setRetardo(float Retardo);
  void Dibujame (z3DVector Localizacion, z3DVector Direccion);
  void onBlanco (z3DVector Fin);
};


// ---------------------------
class TipoProyectilMISIL: public TipoProyectil_Base
{
 private:

 public:
  
  TipoProyectilMISIL();
  ~TipoProyectilMISIL();

  void setRetardo(float Retardo);
  void Dibujame (z3DVector Localizacion, z3DVector Direccion);
  void onBlanco (z3DVector Fin);
};

#endif
