//***************************************************************
//*  [[ A D V E R T E N C I A ]] =[ http://Solar-OpenSource.Org ]=
//*
//*  LICENCIA PARA LA DISTRIBUCIÓN DE WAR 3D
//*  1.- WAR 3D es un programa que podrá ser distribuido bajo los términos de la Licencia Pública General, además deberán cumplirse las siguientes condiciones.
//*  2.- Al copiar cualquier parte del código para ponerlo en un programa diferente a WAR 3D, el autor de dicho programa estará de acuerdo en que el código completo de su programa pasa a ser software libre, por lo deberá estar apegado a los términos establecidos por la licencia LGP. Es decir que, el código de WAR 3D solo puede ser tomado si se va a usar en otro proyecto de software libre. De lo contrario absténgase de usar el código o parte de el código de WAR3D.
//*  3.- Queda estrictamente prohibido modificar los nombres que aparecen en los créditos del programa, solo el grupo de desarrollo de  Solar-OpenSource podrá añadir nuevos nombres en los créditos. Si ha hecho alguna modificación y quiere que su nombre aparezca en los créditos debe ponerse en contacto con nosotros.
//*  4.- Cualquier modificación del código debe apegarse en lo posible a las normas que ha establecido el grupo de desarrollo de Solar-OpenSource, esto es para mayor claridad en el código. Dichas normas pueden encontrarse en nuestra pagina web http://www.solar-opensource.org
//*  5.- Puede copiar y distribuir el programa siempre y cuando no olvide: Acompañarlo con el código fuente completo correspondiente, legible para la máquina, así como el código escrito por usted o las modificaciones hechas al código original.
//*  6.- No debe distribuirse el ejecutable sin el código fuente.
//*  7.- Este texto no debe suprimirse. Las distribuciones deben acompañarse con la información que se recibió así como el ofrecimiento para distribuir el código fuente correspondiente.
//*
//***************************************************************

#include "ServidorDeSprites.h"

// --------------------------------------------------
// --------------------------------------------------
// --------------------------------------------------

vector <Textura> ServidorDeSprites::Sprites;
bool ServidorDeSprites::Inicializada = false;
vector<FX_Explocioncita> ServidorDeSprites::Explosiones;


int ServidorDeSprites::NumFrames;
float ServidorDeSprites::Saltos;
int ServidorDeSprites::tiempoAnterior;

// ---------------------------
ServidorDeSprites::ServidorDeSprites()
{

}


// ---------------------------
void ServidorDeSprites::Inicia ()
{
  if (!ServidorDeSprites::Inicializada)
    {

      Textura Nueva;
      Nueva = ServidorDeTexturas::ME()->Nueva("Efectos/Sprites/Explosiones/Explosion01.tga");
      Sprites.push_back(Nueva);
      
      Textura Nueva2;
      Nueva2 = ServidorDeTexturas::ME()->Nueva("Efectos/Sprites/Explosiones/Explosion02.tga");
      Sprites.push_back(Nueva2);

      Textura Nueva3;
      Nueva3 = ServidorDeTexturas::ME()->Nueva("Efectos/Sprites/Explosiones/Estela01.tga");
      Sprites.push_back(Nueva3);

      ServidorDeSprites::NumFrames = 16;
      ServidorDeSprites::Saltos = 1.0/16;

      ServidorDeSprites::Inicializada = true;

    }
  else
    {
      War3DWarning ("EXPLOSION", "El objeto ya estaba inicializado");
    }
}

// ---------------------------
void ServidorDeSprites::Nueva(float x, float y, float z, unsigned int tipo, float size)
{


  if (tipo > Sprites.size())
    {
      tipo = 0;
      War3DWarning ("FX_EXPLOSIONES","Tipo de explosion no disponible");
    }

  FX_Explocioncita Nueva;

  Nueva.x = x;
  Nueva.y = y + 0.0;
  Nueva.z = z;
  Nueva.frame = 0.0;
  Nueva.tipo = tipo;
  Nueva.size = size*14;
  
  Explosiones.push_back(Nueva);
 
}


// ---------------------------
void ServidorDeSprites::Dibujame(float Angulo)
{
  // Rotamo la barra Angulo grados para que siempre quede de frente a la camara.

  int GluTiempo = glutGet(GLUT_ELAPSED_TIME); 

  vector<FX_Explocioncita>::iterator Ite;


  for (Ite = Explosiones.begin(); Ite != Explosiones.end(); Ite++)
    {
      if ((Ite->frame+0.5) <= ServidorDeSprites::NumFrames)
	{
	  Ite->frame = Ite->frame + ((GluTiempo - ServidorDeSprites::tiempoAnterior)/80.0);
	}
    }


  for (Ite = Explosiones.begin(); Ite != Explosiones.end(); Ite++)
    {
      if ((Ite->frame+0.5) > ServidorDeSprites::NumFrames)
	{
	  Explosiones.erase(Ite);
	  break;
	}
    }


  for (Ite = Explosiones.begin(); Ite != Explosiones.end(); Ite++)
    {
      if (ServidorDeSprites::Inicializada)
	{
	  if ((Ite->frame+0.5) <= ServidorDeSprites::NumFrames)
	    {
	      glPushMatrix();
	           
	      int FRAME = (int)Ite->frame;
	      
	      glTranslatef(Ite->x, Ite->y, Ite->z);
	      
	      
	      glRotatef(Angulo, 0.0, 1.0, 0.0);
	      
	      glDisable(GL_LIGHTING);
	      glEnable(GL_TEXTURE_2D);
	      
	      Sprites[Ite->tipo].usaGLTextura(TextAltaCalidad);
	      
	      
	      glColor4f(1.0, 1.0, 1.0, 0.9);
	      glBegin(GL_QUADS);
	      {
		glTexCoord2f(0, 1.0-(FRAME*Saltos+Saltos));
		glVertex3f(-0.25*Ite->size, -0.10*Ite->size, 0.15*Ite->size);
		glTexCoord2f(0, 1.0-(FRAME*Saltos));
		glVertex3f(-0.25*Ite->size, 0.40*Ite->size, 0.0);
		glTexCoord2f(1, 1.0-(FRAME*Saltos));
		glVertex3f( 0.25*Ite->size, 0.40*Ite->size, 0.0);
		glTexCoord2f(1, 1.0-(FRAME*Saltos+Saltos));
		glVertex3f( 0.25*Ite->size, -0.10*Ite->size, 0.15*Ite->size);
	      }
	      glEnd();
	      glPopMatrix();
	    }
	}
      else
	{
	  War3DWarning("EXPLOSIONES", "No esta inicializado");
	}
    }

    ServidorDeSprites::tiempoAnterior = GluTiempo;
}


