// Solar3DWidGets (c) Solar-OpenSource
// Solar3DWidGets (c) Solar-OpenSource

//***************************************************************
//*  [[ A D V E R T E N C I A ]] =[ http://Solar-OpenSource.Org ]=
//*
//*  LICENCIA PARA LA DISTRIBUCIÓN DE WAR 3D
//*  1.- WAR 3D es un programa que podrá ser distribuido bajo los términos de la Licencia Pública General, además deberán cumplirse las siguientes condiciones.
//*  2.- Al copiar cualquier parte del código para ponerlo en un programa diferente a WAR 3D, el autor de dicho programa estará de acuerdo en que el código completo de su programa pasa a ser software libre, por lo deberá estar apegado a los términos establecidos por la licencia LGP. Es decir que, el código de WAR 3D solo puede ser tomado si se va a usar en otro proyecto de software libre. De lo contrario absténgase de usar el código o parte de el código de WAR3D.
//*  3.- Queda estrictamente prohibido modificar los nombres que aparecen en los créditos del programa, solo el grupo de desarrollo de  Solar-OpenSource podrá añadir nuevos nombres en los créditos. Si ha hecho alguna modificación y quiere que su nombre aparezca en los créditos debe ponerse en contacto con nosotros.
//*  4.- Cualquier modificación del código debe apegarse en lo posible a las normas que ha establecido el grupo de desarrollo de Solar-OpenSource, esto es para mayor claridad en el código. Dichas normas pueden encontrarse en nuestra pagina web http://www.solar-opensource.org
//*  5.- Puede copiar y distribuir el programa siempre y cuando no olvide: Acompañarlo con el código fuente completo correspondiente, legible para la máquina, así como el código escrito por usted o las modificaciones hechas al código original.
//*  6.- No debe distribuirse el ejecutable sin el código fuente.
//*  7.- Este texto no debe suprimirse. Las distribuciones deben acompañarse con la información que se recibió así como el ofrecimiento para distribuir el código fuente correspondiente.

// Solar3DWidGets (c) Solar-OpenSource
// Solar3DWidGets (c) Solar-OpenSource

#include "Solar3DWidGetBoton.h"


// -----------------------------------------
Solar3DWidGetBoton::Solar3DWidGetBoton()
  :Solar3DWidGetBase()
{
  
}


// -----------------------------------------
Solar3DWidGetBoton::Solar3DWidGetBoton(string Nombre, float izq, float arriba, float ancho, float alto, string caption)
  :Solar3DWidGetBase(Nombre, izq, arriba, ancho, alto)
{
  this->caption = caption;
}


// -----------------------------------------
void Solar3DWidGetBoton::renderFondo()
{

  float Inc;
  const int FontSize = 5;
  SolarColor FontColor;
  FontColor.setColor(0.8, 0.8, 1.0, 1.0);


  if (TexturaDeFondo.isInicializada)
    {
      // Si el Widget tiene textura la usamos.
    
      ColorDeFondo.usaColor();
      glEnable(GL_TEXTURE_2D);
      TexturaDeFondo.usaGLTextura(TextAltaCalidad);
    }
  else
    {
      // Si el Widget no tiene textura desabilitamos las texturas.
      glDisable(GL_TEXTURE_2D);
    }

  if (IsMouseOver && Enable) Inc = 0.005; else Inc = 0.000;

  ColorNoEnable.usaColor();  
 
  glBegin (GL_QUADS);
  { 

    // Si el Widget tiene textura la usamos.
    if (!TexturaDeFondo.isInicializada && Enable) glColor4f(0.0, 0.0, 0.0, 0.9);

    if (TexturaDeFondo.isInicializada) glTexCoord2f(0,1);
    glVertex2f(izq + 00000 - Inc, arriba + 0000 - Inc);

    if (!TexturaDeFondo.isInicializada && Enable) glColor4f(0.4, 0.4, 1.0, 0.4);

    if (TexturaDeFondo.isInicializada) glTexCoord2f(1,1);
    glVertex2f(izq + ancho+ Inc, arriba + 0000 - Inc); 

    if (TexturaDeFondo.isInicializada) glTexCoord2f(1,0);
    glVertex2f(izq + ancho + Inc, arriba + alto + Inc);

    if (TexturaDeFondo.isInicializada) glTexCoord2f(0,0);
    glVertex2f(izq + 00000 - Inc, arriba + alto + Inc); 
  }
  glEnd();

  glDisable(GL_TEXTURE_2D);
  glBegin (GL_LINE_LOOP);
  {
    glColor4f(0.0, 0.0, 0.0, 1.0);
    glVertex2f(izq + 00000, arriba + 0000);

    glColor4f(0.2, 0.2, 0.4, 1.0);
    glVertex2f(izq + ancho, arriba + 0000); 
    glVertex2f(izq + ancho, arriba + alto);
    glVertex2f(izq + 00000, arriba + alto); 
  }
  glEnd();



  caption = caption.substr(0,ancho/(FontSize*0.0025));
  float YCentrada = (alto - FontSize * 0.0040)/2.0;
  float XCentrada = (ancho - caption.length()*(FontSize*0.0025))/2.0;



  if (!TexturaDeFondo.isInicializada)
    {
      TextServer.Escribe(caption, getIzqAbsoluto() + XCentrada, getArribaAbsoluto() + YCentrada, FontSize, 
			 1, FontColor.R, FontColor.G, FontColor.B, FontColor.A); 
    }



}
