//***************************************************************
//*  [[ A D V E R T E N C I A ]] =[ http://Solar-OpenSource.Org ]=
//*
//*  LICENCIA PARA LA DISTRIBUCIN DE WAR 3D
//*  1.- WAR 3D es un programa que podr ser distribuido bajo los trminos de la Licencia Pblica General, adems debern cumplirse las siguientes condiciones.
//*  2.- Al copiar cualquier parte del cdigo para ponerlo en un programa diferente a WAR 3D, el autor de dicho programa estar de acuerdo en que el cdigo completo de su programa pasa a ser software libre, por lo deber estar apegado a los trminos establecidos por la licencia LGP. Es decir que, el cdigo de WAR 3D solo puede ser tomado si se va a usar en otro proyecto de software libre. De lo contrario abstngase de usar el cdigo o parte de el cdigo de WAR3D.
//*  3.- Queda estrictamente prohibido modificar los nombres que aparecen en los crditos del programa, solo el grupo de desarrollo de  Solar-OpenSource podr aadir nuevos nombres en los crditos. Si ha hecho alguna modificacin y quiere que su nombre aparezca en los crditos debe ponerse en contacto con nosotros.
//*  4.- Cualquier modificacin del cdigo debe apegarse en lo posible a las normas que ha establecido el grupo de desarrollo de Solar-OpenSource, esto es para mayor claridad en el cdigo. Dichas normas pueden encontrarse en nuestra pagina web http://www.solar-opensource.org
//*  5.- Puede copiar y distribuir el programa siempre y cuando no olvide: Acompaarlo con el cdigo fuente completo correspondiente, legible para la mquina, as como el cdigo escrito por usted o las modificaciones hechas al cdigo original.
//*  6.- No debe distribuirse el ejecutable sin el cdigo fuente.
//*  7.- Este texto no debe suprimirse. Las distribuciones deben acompaarse con la informacin que se recibi as como el ofrecimiento para distribuir el cdigo fuente correspondiente.
//*
//***************************************************************

#include  "SoundServer.h"

bool SoundServer::Activo = true;

//------------------------------------------
SoundServer::~SoundServer()
{
	
}


//------------------------------------------
SoundServer::SoundServer()
{
 
#ifdef _WIN32 // Windows
   
  alutInit(0,NULL);
  alGetError();
  
#else

  ALCdevice *Device;

  if (( Device = alcOpenDevice (( ALubyte* ) "alsa" )) == NULL ){
    War3DWarning ("SOUNDSERVER","No existe alsa Backend");
    if (( Device = alcOpenDevice (( ALubyte* ) "native" )) == NULL ){
      War3DWarning ("SOUNDSERVER","No existe native Backend");
      if (( Device = alcOpenDevice ((ALubyte* ) "waveOut" )) == NULL){
	War3DWarning ("SOUNDSERVER","No existe WaveOut Backend");   
	if (( Device = alcOpenDevice ((ALubyte* ) "oss" )) == NULL){
	  War3DWarning ("SOUNDSERVER","No existe oss Backend");
	  if (( Device = alcOpenDevice (( ALubyte* ) "arts" )) == NULL ){
	    War3DWarning ("SOUNDSERVER","No existe arts Backend");
	    if (( Device = alcOpenDevice (( ALubyte* ) "esd" )) == NULL ){
	      War3DWarning ("SOUNDSERVER","No existe esd Backend");
	      if (( Device = alcOpenDevice (( ALubyte* ) "SDL" )) == NULL ){
		War3DWarning ("SOUNDSERVER","No existe SDL Backend");
		if (( Device = alcOpenDevice ( NULL )) == NULL ){
		  War3DWarning ("SOUNDSERVER","No hay disponible ningun dispositivo de audio");
		  SoundServer::Activo = false;
		  return;
		}
	      }
	    }
	  }
	}
      }
    }
  }

  context_id = alcCreateContext( Device, NULL);
  if(context_id == NULL) {
    alcCloseDevice( Device );

    War3DWarning ("SOUNDSERVER", "CreateContext");
    SoundServer::Activo = false;
    return;
  }
  alcMakeContextCurrent( context_id );

#endif
  



  int i;
  alGenBuffers(NUM_BUFFERS,buffer);
  for (i=0;i<NUM_BUFFERS;i++)
    {
      if (!alIsBuffer(buffer[i]))
	{
	  cout << "Error al crear los buffers de sonido!!" << endl;
	  cout << "[ERROR][SOUNDSERVER] Posiblemente tu tarjeta de audio no esta soportada por OpenAL o esta mal configurada." << endl;
	  SoundServer::Activo = false;
	  return;
	}
    }
  
  
  // Creamos muchas fuentes.
  alGenSources(NUM_FUENTES,fuente);
  for (i=0;i<NUM_FUENTES;i++)
    {
      if (!alIsSource(fuente[i]))

	{
	  War3DWarning ("SOUNDSERVER","Error al crear la fuente de sonido.");
	  War3DWarning ("SOUNDSERVER","Posiblemente tu tarjeta de audio no esta soportada por OpenAL o esta mal configurada.");
	  SoundServer::Activo = false;
	  return;
	}
    }
  
  ALfloat listenerPos[] = {0,0,0};
  ALfloat listenerVel[] = {0,0,0};
  ALfloat listenerOri[] = {0,0,1,0,1,0};
  
  /* defino propiedades oyente*/
  alListenerfv(AL_POSITION,listenerPos);
  alListenerfv(AL_ORIENTATION,listenerOri);
  alListenerfv(AL_VELOCITY,listenerVel);
  
}

//------------------------------------------
void SoundServer::YoEstoyEn (float x ,float y, float z, float angulo)
{

  angulo = (int)angulo%360;
  // cout << "Listener X:" << x << "   Y:" << y << "   Z:" << z << endl; 
  
  float directionvect[6];
  static ALfloat listpos[3];
  listpos[0]=x;
  listpos[1]=y;
  listpos[2]=z;
  alListenerfv(AL_POSITION,listpos);
  angulo += 180;

  directionvect[0] = (float) zsin(angulo);
  directionvect[1] = 0;
  directionvect[2] = (float) zcos(angulo);
  directionvect[3] = 0;
  directionvect[4] = 1;
  directionvect[5] = 0;
  alListenerfv(AL_ORIENTATION, directionvect);
	

}

//------------------------------------------

void  SoundServer::Reproducir (float x ,float y, float z, ALBuffer &S)
{
  
  int i;
  int estado;
  
  
  for (i=0;i<NUM_FUENTES;i++)
    {
      alGetSourcei(fuente[i],AL_SOURCE_STATE, &estado); 
      if (estado != AL_PLAYING)
	{
	  break;
	}
    }
  
  // cout << "Fuente numero: " << i << endl;
  
  if (i >= NUM_FUENTES)
    {

      War3DWarning ("SOUNDSERVER","Se acabaron las fuentes, solo hay " + NUM_FUENTES);
      return;
    }

  S.fuente = fuente[i];
  S.x=x;
  S.y=y;
  S.z=z;
  
  
  ALfloat fuenteVel[]={0.0, 0.0, 0.0};  
  
  alSourcef(S.fuente,AL_GAIN,1.0f);
  alSource3f(S.fuente,AL_POSITION,x,y,z);
  alSourcefv(S.fuente,AL_VELOCITY,fuenteVel); // velocidad
  alSourcei(S.fuente, AL_BUFFER, S.buffer);
  alSourcei(S.fuente,AL_LOOPING,AL_FALSE);
  
  // cout << "Fuente  X:" << x << "   Y:" << y << "   Z:" << z << endl; 
  
  alSourcePlay(S.fuente); 
  
}

//-----------------------------------------------------

void SoundServer::PlayWav(float x ,float y, float z, string ArchivoWav)
{

  if (SoundServer::Activo && configuracion::Musica)
    {
      vector<ALBuffer>::iterator Ite;  
      for (Ite = ALBuffers.begin(); Ite != ALBuffers.end(); Ite++)
	{
	  if (Ite->Archivo == ArchivoWav)
	    {
	      // El archivo ya estaba abierto, solo hay que reproducirlo.
	      
	      Reproducir (x,y,z,*Ite);
	      return;
	    }
	  
	}
      
      // Este archivo no estaba abierto, vamos a abrirlo.
      
      cout << "Abriendo archivo " << ArchivoWav << endl; 
      
      
      // Vamos a pillar un buffer que no se use.
      int estado;
      int i;
      
      for (i=0; i<NUM_BUFFERS ; i++)
	{
	  alGetBufferi(buffer[i],AL_SIZE, &estado); 
	  if (estado == 0)
	    {
	      break;
	    }
	}
      
      if (i >= NUM_BUFFERS)
	{
	  War3DWarning ("SOUNDSERVER", "Se acabaron los buffers, solo hay " + NUM_BUFFERS);
	  return;
	}	
      
      cout << "Buffer numero: " << i << endl;
  
      ALBuffer S;	
  
      S.Archivo = ArchivoWav;
      S.buffer = buffer[i];
      S.x=x;
      S.y=y;
      S.z=z;
  
  
      int format;
      ALsizei size, freq, bits;
      void *data=NULL;
      char Arc[150];
      strcpy(Arc,S.Archivo.c_str());
      // Cargamos el archivo WAV.
  
#ifdef _WIN32 // Windows

      ALboolean loop = AL_FALSE;

      ALenum error = alGetError(); // Limpiamos

      alutLoadWAVFile(Arc,&format,&data,&size,&freq,&loop); // Cargamos el archivo WAV

	  if (size == 0)
	  {

		War3DWarning ("SOUNDSERVER", "No se encuentra el archivo: " +  string(Arc));
		return;
	  }

      cout << "Open Wav Windows" << endl;
#else
      if(AL_FALSE == alutLoadWAV(Arc, &data, &format, &size, &bits, &freq)) 
	{
	  War3DWarning ("SOUNDSERVER", "No se encuentra el archivo: " +  string(Arc));
	  return;
	}
      cout << "Open Wav Linux" << endl;

#endif
  
      // Pasamos el archivo WAV al buffer.
      alBufferData(S.buffer,format,data,size,freq);
      // Descargamos el Wav y leveramos memoria.
      alutUnloadWAV(format,data,size,freq);
  
      // Y a reproducirlo.
      Reproducir (x,y,z,S);
  
  
      ALBuffers.push_back (S);
    }
  else
    {
  
    }

}


//----------------------------------------------
void SoundServer::PlayOgg(float x ,float y, float z, string ArchivoOgg)
{

  if (SoundServer::Activo && configuracion::Musica)
    {

      vector<ALBuffer>::iterator Ite;  
      for (Ite = ALBuffers.begin(); Ite != ALBuffers.end(); Ite++)
	{
	  if (Ite->Archivo == ArchivoOgg)
	    {
	      // El archivo ya estaba abierto, solo hay que reproducirlo.
	      Reproducir (x,y,z,*Ite);
	      return;
	    }

	}

      // Este archivo no estaba abierto, vamos a abrirlo.

      cout << "Abriendo archivo " << ArchivoOgg << endl; 


      // Vamos a pillar un buffer que no se use.
      int estado;
      int i;

      for (i=0; i<NUM_BUFFERS ; i++)
	{
	  alGetBufferi(buffer[i],AL_SIZE, &estado); 
	  if (estado == 0)
	    {
	      break;
	    }
	}
      if (i >= NUM_BUFFERS)
	{
	  War3DWarning ("SOUNDSERVER", "Se acabaron los buffers, solo hay " + NUM_BUFFERS);
	  return;
	}	
	
      cout << "Buffer numero: " << i << endl;
		
      ALBuffer S;	

      S.Archivo = ArchivoOgg;
      S.buffer = buffer[i];
      S.x=x;
      S.y=y;
      S.z=z;

      int format;
      unsigned int size, freq;

      unsigned char *data=NULL;
      char Arc[150];
      strcpy(Arc,S.Archivo.c_str());
      // Cargamos el archivo OGG. //alutLoadWAVFile (Arc,&format,&data,&size,&freq);
		
      OggVorbis_File vf;
      vorbis_info *vi;
		
      if(!Arc){	return;	}

      FILE *oggf=fopen(Arc,"rb");
      if(!oggf){	return;	}
      ov_open(oggf,&vf,NULL,0);
      vi=ov_info(&vf,-1);

      if(vi->channels>1){	format=AL_FORMAT_MONO16;	} else {	format=AL_FORMAT_STEREO16;	}

      size=(unsigned long)ov_time_total(&vf,-1)*vi->rate*vi->channels*2;

      freq=vi->rate/2;

      int sec=0,ret=1;	unsigned long pos=0;

      data=new unsigned char[size];
      memset(data,0,size*sizeof(char));
      ov_read(&vf,(char*)data,size,0,2,1,&sec);
      while(ret && pos<size)
	{
	  ret=ov_read(&vf,(char*)data+pos,size-pos,0,2,1,&sec);
	  pos+=ret;
	}
		
      // Pasamos el archivo OGG al buffer.
      alBufferData(S.buffer,format,data,size,freq);
      // Descargamos el OGG y liveramos memoria. //alutUnloadWAV(format,data,size,freq);
	
      delete [] data;

      // Y a reproducirlo.
      Reproducir (x,y,z,S);

		
      ALBuffers.push_back (S);
    }
  else
    {

    }
}


