#ifndef _SPRITE_H_
#define _SPRITE_H_

#include "texturas.h"

#include "zeru_mat.h"

//byK TypeDefs
typedef unsigned char uchar;
typedef signed char schar;
typedef unsigned short ushort;
typedef signed short sshort;
typedef unsigned long ulong;
typedef signed long slong;
typedef unsigned int uint;
typedef signed int sint;
typedef unsigned __int64 uint64;
typedef signed __int64 sint64;

// GL_Sprite
class GL_Sprite
{
public:
	GL_Sprite(); //constructor dft
	GL_Sprite(const GL_Sprite &src); //copy constructor

	//Variables
	Textura *pFrames;
	uint numOfFrames,currentFrame;
	uchar Alpha;
	float Angle,Scale,ControlPoint[2];
	z3DVector Pos;
	float framesPerSecond;

	//Funciones
	void SetNumOfFrames(int nf){	numOfFrames=nf;	pFrames=new Textura[numOfFrames];	};
	void SetAlpha(uchar a){	Alpha=a;	};
	void SetControlPoint(float x,float y){	ControlPoint[0]=x;	ControlPoint[1]=y;	};
	void SetAngle(float fangle){	Angle=fangle;	};
	void SetPosicion(float x,float y,float z){	Pos.x=x;	Pos.y=y;	Pos.z=z;	};
	void SetScale(float fscale){	Scale=fscale;	};
	void MakeFromModel(Model &model,float angulo);
	void Animar(void);
	void Draw(int nf);

	~GL_Sprite(); //deconstructor
};

#endif /*_SPRITE_H_*/
