// Hacele caso a tu sedEx
#include "SpriteEx.h"

#define byKSafeDelete(x)	{	if(x){	delete[] x;	x=NULL;	}	}

/* GL_SpriteEx --> */
GL_SpriteEx::GL_SpriteEx()
{
  currentFrame = 0;
  Scale = 0.05;
  framesPerSecond=30;
}

// --------------------------------------
void GL_SpriteEx::LoadFrames(void)
{
  Textura NuevaTextura;

  vector<string>::iterator Ite;
  for (Ite = sFrames.begin(); Ite != sFrames.end(); Ite++)
    {
      NuevaTextura = ServidorDeTexturas::ME()->Nueva(Ite->c_str());
      tFrame.push_back(NuevaTextura);
    }


}

// --------------------------------------
void GL_SpriteEx::Animar(void)
{
  static int lastTime=glutGet(GLUT_ELAPSED_TIME);

  int currentTime=glutGet(GLUT_ELAPSED_TIME);
	
  float t=(currentTime-lastTime)*framesPerSecond;
  if(t>=1.0f)
    {
      currentFrame=(currentFrame+1>=numOfFrames) ? 0 : currentFrame++;
      lastTime=currentTime;
    }

  Draw(currentFrame);
}

// --------------------------------------
void GL_SpriteEx::Draw(int nf)
{

  z3DVector pa,pb,pc,pd,right,up;
  
  float mat[16];	glGetFloatv(GL_MODELVIEW_MATRIX,(float*)&mat);
  right.x=mat[0];	right.y=mat[4];	right.z=mat[8];
  up.x=mat[1];	up.y=mat[5];	up.z=mat[9];
	
  pa.x=Pos.x-(right.x+up.x)*Scale;
  pa.y=Pos.y-(right.y+up.y)*Scale;
  pa.z=Pos.z-(right.z+up.z)*Scale;

  pb.x=Pos.x+(right.x-up.x)*Scale;
  pb.y=Pos.y+(right.y-up.y)*Scale;
  pb.z=Pos.z+(right.z-up.z)*Scale;

  pc.x=Pos.x+(right.x+up.x)*Scale;
  pc.y=Pos.y+(right.y+up.y)*Scale;
  pc.z=Pos.z+(right.z+up.z)*Scale;

  pd.x=Pos.x-(right.x-up.x)*Scale;
  pd.y=Pos.y-(right.y-up.y)*Scale;
  pd.z=Pos.z-(right.z-up.z)*Scale;

  glPushMatrix();

  glColor4f(1.0, 1.0, 1.0, 1.0);

  glEnable(GL_TEXTURE_2D);

  tFrame[nf].usaGLTextura(TextAltaCalidad);
  glBegin(GL_QUADS);
  {
    glNormal3f(1.0f,1.0f,1.0f);         
    glTexCoord2f(0.0, 1.0);	glVertex3fv((float*)&pd);
    glTexCoord2f(1.0, 1.0);	glVertex3fv((float*)&pc);
    glTexCoord2f(1.0, 0.0);	glVertex3fv((float*)&pb);
    glTexCoord2f(0.0, 0.0);	glVertex3fv((float*)&pa);
  }
  glEnd();

  glPopMatrix();

}

// --------------------------------------
GL_SpriteEx::~GL_SpriteEx()
{
}
/* <-- GL_SpriteEx */




// ZG --------------------------
//Metodos heredados de los objetos tipo rendereable.
// ZG --------------------------

// ----------------------------
void GL_SpriteEx::dibujame(float x, float y, float z, float frame, float angulo, float armaAngulo)
{
  SetAngle(angulo);
  SetPosicion(x, y, z);
  Animar();
}

// ----------------------------
void GL_SpriteEx::dibujame(float x, float y, float z, float frame, float angulo, z3DVector Normal, float armaAngulo)
{
  dibujame(x, y, z, frame, angulo, armaAngulo);
}

// ----------------------------
void GL_SpriteEx::dibujameSelect(float x, float y, float z, float frame, float angulo)
{
  dibujame(x, y, z, frame, angulo, 0);
}

// ----------------------------
float GL_SpriteEx::getRadio()
{
  // !!TODO!!
  return 0.01;
}

// ----------------------------
Animacion GL_SpriteEx::getFrames(string anim)
{
  // !!TODO!!
  // Ejemplo  .getFrames("Disparando");
  Animacion TMP;
  return TMP;
}

// ----------------------------
inline bool* GL_SpriteEx::getIAMaya()
{
  // !!TODO!!
  // Espacio utilizado por el bicho en el suelo del mapa

  bool *MayaIA;

  MayaIA = new bool[TamMayaIA*TamMayaIA];

  for (int i=0; i<TamMayaIA*TamMayaIA ;i++)
    {
      MayaIA[i] = false;
    }
  return MayaIA;
}
