#ifndef _SPRITEEX_H_
#define _SPRITEEX_H_

#include <vector>
#include <string>
using namespace std;

#include "texturas.h"

#include "zeru_mat.h"

#include "rendereable.h"

//byK TypeDefs
typedef unsigned char uchar;
typedef signed char schar;
typedef unsigned short ushort;
typedef signed short sshort;
typedef unsigned long ulong;
typedef signed long slong;
typedef unsigned int uint;
typedef signed int sint;

// GL_SpriteEx
class GL_SpriteEx: public rendereable
{
public:
  GL_SpriteEx(); //constructor dft
  GL_SpriteEx(const GL_SpriteEx &src); //copy constructor
  
  //Variables
  vector<Textura> tFrame;
  uint numOfFrames,numOfFramesPerTex,numOfTexs,currentFrame;
  vector<string>sFrames;
  ushort frameWidth,frameHeight;
  uchar Alpha;
  float Angle,Scale,ControlPoint[2];
  z3DVector Pos;
  float framesPerSecond;
  
  //Funciones
  void SetFrameSize(ushort w,ushort h){	frameWidth=w;	frameHeight=h;	};
  void PushFrame(string szArchivo){	sFrames.push_back(szArchivo);	};
  void LoadFrames(void);
  void SetAlpha(uchar a){	Alpha=a;	};
  void SetControlPoint(float x,float y){	ControlPoint[0]=x;	ControlPoint[1]=y;	};
  void SetAngle(float fangle){	Angle=fangle;	};
  void SetPosicion(float x,float y,float z){	Pos.x=x;	Pos.y=y;	Pos.z=z;	};
  void SetScale(float fscale){	Scale=fscale;	};
  void Animar(void);
  void Draw(int nf);
  
  ~GL_SpriteEx(); //deconstructor


  // ZG --------------------------
  //Metodos heredados de los objetos tipo rendereable.
  // ZG --------------------------

  void dibujame(float x, float y, float z, float frame, float angulo, float armaAngulo);
  void dibujame(float x, float y, float z, float frame, float angulo, z3DVector Normal, float armaAngulo);
  void dibujameSelect(float x, float y, float z, float frame, float angulo);
  float getRadio();
  Animacion getFrames(string anim);
  inline bool* getIAMaya();


};

#endif /*_SPRITE_H_*/
