//***************************************************************
//*  [[ A D V E R T E N C I A ]] =[ http://Solar-OpenSource.Org ]=
//*
//*  LICENCIA PARA LA DISTRIBUCIN DE WAR 3D
//*  1.- WAR 3D es un programa que podr ser distribuido bajo los trminos de la Licencia Pblica General, adems debern cumplirse las siguientes condiciones.
//*  2.- Al copiar cualquier parte del cdigo para ponerlo en un programa diferente a WAR 3D, el autor de dicho programa estar de acuerdo en que el cdigo completo de su programa pasa a ser software libre, por lo deber estar apegado a los trminos establecidos por la licencia LGP. Es decir que, el cdigo de WAR 3D solo puede ser tomado si se va a usar en otro proyecto de software libre. De lo contrario abstngase de usar el cdigo o parte de el cdigo de WAR3D.
//*  3.- Queda estrictamente prohibido modificar los nombres que aparecen en los crditos del programa, solo el grupo de desarrollo de  Solar-OpenSource podr aadir nuevos nombres en los crditos. Si ha hecho alguna modificacin y quiere que su nombre aparezca en los crditos debe ponerse en contacto con nosotros.
//*  4.- Cualquier modificacin del cdigo debe apegarse en lo posible a las normas que ha establecido el grupo de desarrollo de Solar-OpenSource, esto es para mayor claridad en el cdigo. Dichas normas pueden encontrarse en nuestra pagina web http://www.solar-opensource.org
//*  5.- Puede copiar y distribuir el programa siempre y cuando no olvide: Acompaarlo con el cdigo fuente completo correspondiente, legible para la mquina, as como el cdigo escrito por usted o las modificaciones hechas al cdigo original.
//*  6.- No debe distribuirse el ejecutable sin el cdigo fuente.
//*  7.- Este texto no debe suprimirse. Las distribuciones deben acompaarse con la informacin que se recibi as como el ofrecimiento para distribuir el cdigo fuente correspondiente.
//*
//***************************************************************

#include "animaSoldado.h"

void animaSoldado::setAnimacionDefault()
{
  if (Tipo == "CAMINAR")
    {
      Estatico = Modelo->getFrames("quieto_estatico");
      return;
    }
  else if(Tipo == "VEHICULO")
    {
      Estatico = Modelo->getFrames("quieto_estatico");
      return;
    }
  cout << "No se pudo asignar una animacion por default al modelo" << endl;
}

// ------------------------------
// ------------------------------

void animaSoldado::AminacionFinalizada(string AnimacionActual, float Sobrante)
{
  if (Tipo == "CAMINAR")
    {
      AminacionFinalizadaCAMINAR(AnimacionActual, Sobrante);
    }
  else if (Tipo == "VEHICULO")
    { 
      AminacionFinalizadaVEHICULO(AnimacionActual, Sobrante);
    }
}

// ------------------------------
void animaSoldado::AminacionFinalizadaCAMINAR(string AnimacionActual, float Sobrante)
{

  if (AnimacionActual == "corriendo_izquierda")
    {
      Actual = Modelo->getFrames("corriendo_derecha");
      FRAME = Actual.Inicio + Sobrante;

      //EstadoName = "NULL"; // No nesesario aqui
      return;  
    }
  
  
  if (AnimacionActual == "corriendo_derecha")
    {
      Actual = Modelo->getFrames("corriendo_izquierda");
      FRAME = Actual.Inicio + Sobrante;

      //  EstadoName = "NULL"; // No nesesario aqui
      return;
    }


  if (AnimacionActual == "quieto_estatico")
    {
      // Actual se conseva igual
      FRAME = Actual.Inicio + Sobrante;

      //  EstadoName = "NULL"; // No nesesario aqui
      return;
    }
  
  if (AnimacionActual == "quieto_gesto" || AnimacionActual == "quieto_atencion")
    {

      Actual = Modelo->getFrames("quieto_estatico");
      FRAME = Actual.Inicio;
      
      EstadoName = "NULL";
      return;
    }

  
  if (AnimacionActual == "muriendo_herido")
    {
      Actual = Estatico;
      FRAME = Actual.Inicio;

      EstadoName = "NULL";
      return;
    }

  if (AnimacionActual == "atacando_disparando")
    {
      
      Actual = Modelo->getFrames("atacando_posicion");
      FRAME =  Actual.Fin;
      Actual = Estatico;      

      EstadoName = "NULL";
      return;
    }

  if (AnimacionActual == "muriendo_muerte")
    {
      Actual = Modelo->getFrames("muriendo_estatico");
      FRAME = Actual.Inicio;

      // EstadoName = "NULL"; // No nesesario aqui
      return;
    }

  if (AnimacionActual == "muriendo_estatico")
    {
      // Actual se conseva igual
      FRAME = Actual.Inicio + Sobrante;
      EstadoName = "NULL";
      return;
    }

  if (AnimacionActual == "NULL")
    {
      return;
    }

  cout << "Fin de animacion no considerado: " << AnimacionActual << endl;

  Actual.Reset(); // Borrar esta linea cuando este listo.
  EstadoName = "NULL";

}

void animaSoldado::AminacionFinalizadaVEHICULO(string AnimacionActual, float Sobrante)
{
  if (AnimacionActual == "rodando")
    {
      Actual = Modelo->getFrames("rodando");
      FRAME = Actual.Inicio + Sobrante;
      //EstadoName = "NULL"; // No nesesario aqui
      return;  
    }

   if (AnimacionActual == "quieto_estatico")
    {
      // Actual se conseva igual
      FRAME = Actual.Inicio;
      EstadoName = "NULL"; // No nesesario aqui
      return;
    }

  if (AnimacionActual == "NULL")
    {
      return;
    }


  cout << "Fin de animacion no considerado: " << AnimacionActual << endl;

  Actual.Reset(); // Borrar esta linea cuando este listo.
  EstadoName = "NULL";
}


// ------------------------------
// ------------------------------

void animaSoldado::setAnimacion(string Animacion)
{
  if (Tipo == "CAMINAR")
    {
      setAnimacionTipoCAMINAR(Animacion);
    }
  else if(Tipo == "VEHICULO")
	{
      setAnimacionTipoVEHICULO(Animacion);
    }
}


// ------------------------------
void animaSoldado::setAnimacionTipoCAMINAR(string Animacion)
{


  EstadoName = Animacion;

  // [Caminar]
  if (Animacion == "camina")
    {
      UsaVelocidadCorrer = true;
      Actual = Modelo->getFrames("corriendo_izquierda");
      FRAME = Actual.Inicio;
      return;
    }
  else
    {
      UsaVelocidadCorrer = false;
    }
  
  // [Alto]
  if (Animacion == "alto")
    {
      Actual = Modelo->getFrames("quieto_estatico");
      FRAME = Actual.Inicio;
      return;
    }

  // [Herido]
  if (Animacion == "herido")
    {
      Actual = Modelo->getFrames("muriendo_herido");
      FRAME = Actual.Inicio;
      return;
    }

  // [Ocioso]
  if (Animacion == "ocioso")
    {

      if (rand() % 2 == 1)
	{
	  Actual = Modelo->getFrames("quieto_gesto");
	}
      else
	{
	  Actual = Modelo->getFrames("quieto_atencion");
	}
      
       FRAME = Actual.Inicio;
       return;
    }


  // [Dispara]
  if (Animacion == "dispara")
    {
      Actual = Modelo->getFrames("atacando_disparando");
      FRAME = Actual.Inicio;
      return;
    }


  // [Dispara]
  if (Animacion == "muerto")
    {
      Actual = Modelo->getFrames("muriendo_muerte");
      FRAME = Actual.Inicio;
      return;
    }


  Actual = Estatico;
  EstadoName = "NULL";

  cout << "[Warning] Este tipo de unidad no tiene la animacion: " << Animacion << endl; 
}


void animaSoldado::setAnimacionTipoVEHICULO(string Animacion)
{
EstadoName = Animacion;

  // [Caminar]
  if (Animacion == "camina")
    {
      UsaVelocidadCorrer = true;
      Actual = Modelo->getFrames("rodando");
      FRAME = Actual.Inicio;
      return;
    }
  else
    {
      UsaVelocidadCorrer = false;
    }
  
  // [Alto]
  if (Animacion == "alto")
    {
      Actual = Modelo->getFrames("quieto_estatico");
      FRAME = Actual.Inicio;
      return;
    }

  // [Herido]
  if (Animacion == "herido")
    {
      Actual = Modelo->getFrames("quieto_estatico");
      FRAME = Actual.Inicio;
      return;
    }

  // [Ocioso]
  if (Animacion == "ocioso")
    {
      Actual = Modelo->getFrames("quieto_estatico");
      FRAME = Actual.Inicio;
       return;
    }


  // [Dispara]
  if (Animacion == "dispara")
    {
      Actual = Modelo->getFrames("quieto_estatico");
      FRAME = Actual.Inicio;      
      return;
    }


  // [Dispara]
  if (Animacion == "muerto")
    {
      Actual = Modelo->getFrames("quieto_estatico");
      FRAME = Actual.Inicio;
      return;
    }


  Actual = Estatico;
  EstadoName = "NULL";

  cout << "[Warning] Este tipo de unidad no tiene la animacion: " << Animacion << endl; 
}

