//***************************************************************
//*  [[ A D V E R T E N C I A ]] =[ http://Solar-OpenSource.Org ]=
//*
//*  LICENCIA PARA LA DISTRIBUCIN DE WAR 3D
//*  1.- WAR 3D es un programa que podr ser distribuido bajo los trminos de la Licencia Pblica General, adems debern cumplirse las siguientes condiciones.
//*  2.- Al copiar cualquier parte del cdigo para ponerlo en un programa diferente a WAR 3D, el autor de dicho programa estar de acuerdo en que el cdigo completo de su programa pasa a ser software libre, por lo deber estar apegado a los trminos establecidos por la licencia LGP. Es decir que, el cdigo de WAR 3D solo puede ser tomado si se va a usar en otro proyecto de software libre. De lo contrario abstngase de usar el cdigo o parte de el cdigo de WAR3D.
//*  3.- Queda estrictamente prohibido modificar los nombres que aparecen en los crditos del programa, solo el grupo de desarrollo de  Solar-OpenSource podr aadir nuevos nombres en los crditos. Si ha hecho alguna modificacin y quiere que su nombre aparezca en los crditos debe ponerse en contacto con nosotros.
//*  4.- Cualquier modificacin del cdigo debe apegarse en lo posible a las normas que ha establecido el grupo de desarrollo de Solar-OpenSource, esto es para mayor claridad en el cdigo. Dichas normas pueden encontrarse en nuestra pagina web http://www.solar-opensource.org
//*  5.- Puede copiar y distribuir el programa siempre y cuando no olvide: Acompaarlo con el cdigo fuente completo correspondiente, legible para la mquina, as como el cdigo escrito por usted o las modificaciones hechas al cdigo original.
//*  6.- No debe distribuirse el ejecutable sin el cdigo fuente.
//*  7.- Este texto no debe suprimirse. Las distribuciones deben acompaarse con la informacin que se recibi as como el ofrecimiento para distribuir el cdigo fuente correspondiente.
//*
//***************************************************************

#include "animaciones.h"



animaciones::animaciones(rendereable *Modelo, string Tipo)
{
  this->Modelo = Modelo; 
  this->Tipo = Tipo;

  EstadoName = "NULL";

  VelocidadCorrer = -1;
  UsaVelocidadCorrer = false;

}


// -------------------------
void animaciones::AminacionFinalizada(string AnimacionActual, float Sobrante)
{
   FRAME = Actual.Inicio + Sobrante;
   War3DWarning("ANIMACIONES", "Se repite la animacion porque falta 'ocultar' la funcion AminacionFinalizada");
}


// -------------------------
void animaciones::setAnimacion(string Animacion)
{
  Actual = Estatico;
  EstadoName = "NULL";
  War3DWarning("ANIMACIONES", "Se asigna la animacio defaut porque falta 'ocultar' la funcion setAnimacion");
}


// -------------------------
void animaciones::setAnimacionDefault()
{
  Estatico.Nombre = "NULL";
  Estatico.Inicio = 1;
  Estatico.Fin = 1;
      
  War3DWarning("ANIMACIONES", "Se asigna la animacio defaut porque falta 'ocultar' la funcion setAnimacionDefault");
  
  return;
}

// -------------------------
void animaciones::setRetardo(float Retardo)
{
  this->Retardo = Retardo;


  // Miramos si ya termino la animacion
  if (FRAME < Actual.Fin)
    {
      // Incrementamos la variable FRAME, que se encarga de decirnos cual es el
      // frame actual.
      if (UsaVelocidadCorrer && VelocidadCorrer > 0)
	{
	  // Para correr usamos la velocidad del Bicho

	  FRAME = FRAME + (12.0/Retardo)*VelocidadCorrer;

	}
      else
	{
	  // Para las otras animaciones es constante.
	  FRAME = FRAME + (12.0/Retardo);

	} 
    }
  else
    {
      AminacionFinalizada(Actual.Nombre, FRAME-Actual.Fin);
    }
}


// ------------------------------
int animaciones::getEstadoPorciento()
{
  int  Porciento; 

  float todo = Actual.Fin-Actual.Inicio;
  float delta = FRAME-Actual.Inicio;

  if (todo == 0) return 100;
  if (delta < 0 || delta>todo) return 100;

  Porciento = (int)(((delta)/(todo))*100);

  return Porciento;

}



// ------------------------------
float animaciones::getEstadoFrame()
{
  if (Actual.Inicio == -1)
    {
      FRAME = 1.0;
    }
  return FRAME;
}



// ------------------------------
string animaciones::getEstadoName()
{
  return EstadoName;
}
