//***************************************************************
//*  [[ A D V E R T E N C I A ]] =[ http://Solar-OpenSource.Org ]=
//*
//*  LICENCIA PARA LA DISTRIBUCIN DE WAR 3D
//*  1.- WAR 3D es un programa que podr ser distribuido bajo los trminos de la Licencia Pblica General, adems debern cumplirse las siguientes condiciones.
//*  2.- Al copiar cualquier parte del cdigo para ponerlo en un programa diferente a WAR 3D, el autor de dicho programa estar de acuerdo en que el cdigo completo de su programa pasa a ser software libre, por lo deber estar apegado a los trminos establecidos por la licencia LGP. Es decir que, el cdigo de WAR 3D solo puede ser tomado si se va a usar en otro proyecto de software libre. De lo contrario abstngase de usar el cdigo o parte de el cdigo de WAR3D.
//*  3.- Queda estrictamente prohibido modificar los nombres que aparecen en los crditos del programa, solo el grupo de desarrollo de  Solar-OpenSource podr aadir nuevos nombres en los crditos. Si ha hecho alguna modificacin y quiere que su nombre aparezca en los crditos debe ponerse en contacto con nosotros.
//*  4.- Cualquier modificacin del cdigo debe apegarse en lo posible a las normas que ha establecido el grupo de desarrollo de Solar-OpenSource, esto es para mayor claridad en el cdigo. Dichas normas pueden encontrarse en nuestra pagina web http://www.solar-opensource.org
//*  5.- Puede copiar y distribuir el programa siempre y cuando no olvide: Acompaarlo con el cdigo fuente completo correspondiente, legible para la mquina, as como el cdigo escrito por usted o las modificaciones hechas al cdigo original.
//*  6.- No debe distribuirse el ejecutable sin el cdigo fuente.
//*  7.- Este texto no debe suprimirse. Las distribuciones deben acompaarse con la informacin que se recibi as como el ofrecimiento para distribuir el cdigo fuente correspondiente.
//*
//***************************************************************

#include "army.h"
#include "pPantallas.h"

#include "modelosMS3D.h"
#include "SpriteEx.h"

//**************************
//**        ARMY          **
//**************************

// ------------------------------------------------
Army::Army()
{
  NumUnidades = 0;
  NumConstrucciones = 0;
 
}


// -----------------------------------------------
void Army::LeerArmy(string Archivo)
{

  int i;	

  char	szLine[256];

  // Abrimos el archivo
  FILE *file = fopen (Archivo.c_str(), "rt");
  if (!file)
    {
      War3DError ("ARMY", "Al abrir el Army |" + Archivo + "|");
      return;
    }
  
  // Leemos los comentarios
  fgets (szLine, 256, file);
  if (strlen(szLine) >= 1)
    {
      //cout << "ARMY Comentarios: "  << szLine;
    }

 // ---------------------------------------------
  fgets (szLine, 256, file); // Una linea de separacion

  fgets (szLine, 256, file); // Encabezado sin Valor
  if (!(string(szLine) != "Constructor"))
    {
      War3DError ("ARMY", "Al abrir el Army |" + Archivo + "|" );
      return;
    }
  

  UnidadArmy * Costructor;
  Costructor = new UnidadArmy;
  
  if (!LeerCampo(file, "__Nombre", Costructor->nombre)) return; 
  if (!LeerCampo(file, "tipo", Costructor->tipo)) return; 
  if (!LeerCampo(file, "mes", Costructor->mes)) return; 
  if (!LeerCampo(file, "mesSkin", Costructor->mesSkin)) return; 
  if (!LeerCampo(file, "arma", Costructor->arma)) return; 
  if (!LeerCampo(file, "armaSkin", Costructor->armaSkin)) return; 
  if (!LeerCampo(file, "escala", Costructor->escala)) return; 
  if (!LeerCampo(file, "tipomovimiento", Costructor->tipomovimiento)) return;
  if (!LeerCampo(file, "tiposer", Costructor->tiposer)) return;
  if (!LeerCampo(file, "sonidos", Costructor->sonidos)) return; 
  if (!LeerCampo(file, "sangre", Costructor->sangre)) return; 
  if (!LeerCampo(file, "armadura", Costructor->armadura)) return; 
  if (!LeerCampo(file, "danio", Costructor->danio)) return; 
  if (!LeerCampo(file, "velocidad", Costructor->velocidad)) return; 
  if (!LeerCampo(file, "alcance", Costructor->alcance)) return; 
  if (!LeerCampo(file, "veldedisparo", Costructor->veldedisparo)) return;

  Costructor->ArmyPadre = this;
  Costructor->ID = 1;


  VerificacionDeArmy(Costructor);
  
  Costructor->AbreModelo();  
  
  Costructor->costo = (int)(Costructor->alcance*60 + 
			    Costructor->danio * 10 + 
			    Costructor->veldedisparo * 10 + 
			    Costructor->velocidad*40 + 
			    Costructor->sangre +
			    (0.2 - Costructor->Modelo->getRadio())*150)/15;
  
  if (Costructor->tipomovimiento == "VOLAR")
    {
      Costructor->costo = (int)(Costructor->costo * 1.5);
    }


  
  fgets (szLine, 256, file); // Una linea de separacion
  
  if (!LeerCampo(file, "Unidades", NumUnidades))
    {
      War3DError ("ARMY", "Al abrir el Army |" + Archivo + "|");
      return;
    }

  NumUnidades++;

  Unidades = new UnidadArmy[NumUnidades];
  Unidades[0] = *Costructor;
  //delete Costructor;
  
  // Leemos cada una de las unidades:
  for(i=1; i<NumUnidades; i++)
    {

      if (!LeerCampo(file, "__Nombre", Unidades[i].nombre)) return; 
      if (!LeerCampo(file, "tipo", Unidades[i].tipo)) return; 
      if (!LeerCampo(file, "mes", Unidades[i].mes)) return; 
      if (!LeerCampo(file, "mesSkin", Unidades[i].mesSkin)) return; 
      if (!LeerCampo(file, "arma", Unidades[i].arma)) return; 
      if (!LeerCampo(file, "armaSkin", Unidades[i].armaSkin)) return; 
      if (!LeerCampo(file, "escala", Unidades[i].escala)) return; 
      if (!LeerCampo(file, "tipomovimiento", Unidades[i].tipomovimiento)) return;
      if (!LeerCampo(file, "tiposer", Unidades[i].tiposer)) return;
      if (!LeerCampo(file, "sonidos", Unidades[i].sonidos)) return; 
      if (!LeerCampo(file, "sangre", Unidades[i].sangre)) return; 
      if (!LeerCampo(file, "armadura", Unidades[i].armadura)) return; 
      if (!LeerCampo(file, "danio", Unidades[i].danio)) return; 
      if (!LeerCampo(file, "velocidad", Unidades[i].velocidad)) return; 
      if (!LeerCampo(file, "alcance", Unidades[i].alcance)) return; 
      if (!LeerCampo(file, "veldedisparo", Unidades[i].veldedisparo)) return;

      Unidades[i].ArmyPadre = this;
      Unidades[i].ID = i+1;

      VerificacionDeArmy(&Unidades[i]);

      Unidades[i].AbreModelo();  

      Unidades[i].costo = (int)(Unidades[i].alcance * 60 + 
				Unidades[i].danio * 10 + 
				Unidades[i].veldedisparo * 10 + 
				Unidades[i].velocidad * 40 + 
				Unidades[i].sangre +
				(0.2 - Unidades[i].Modelo->getRadio())*150)/15;
      
      if (Unidades[i].tipomovimiento == "VOLAR")
	{
	  Unidades[i].costo = (int)(Unidades[i].costo * 1.5);
	}



      /*
      pPantallas::BarraDeCarga.Avance = 100*(float(i)/NumUnidades)+0;
      pPantallas::BarraDeCarga.Cadena = "Cargando Armys";
      pPantallas::PantallaActiva->Dibujame();
      */

    }

  cout << endl << "-[ *** ]- Contrucciones" << endl;



 // ---------------------------------------------
  fgets (szLine, 256, file); // Una linea de separacion

  fgets (szLine, 256, file); // Encabezado sin Valor
  if (!(string(szLine) != "EdificioConstructor"))
    {
      War3DError ("ARMY", "Al abrir el Army " + Archivo);
      return;
    }

  EdificioConstructor = new ConstruArmy;

  if (!LeerCampo(file, "__Nombre", EdificioConstructor->nombre)) return; 
  if (!LeerCampo(file, "tipo", EdificioConstructor->tipo)) return; 
  if (!LeerCampo(file, "mes", EdificioConstructor->mes)) return; 
  if (!LeerCampo(file, "mesSkin", EdificioConstructor->mesSkin)) return; 
  if (!LeerCampo(file, "escala", EdificioConstructor->escala)) return; 
  if (!LeerCampo(file, "sonidos", EdificioConstructor->sonidos)) return; 
  if (!LeerCampo(file, "sangre", EdificioConstructor->sangre)) return; 
  if (!LeerCampo(file, "armadura", EdificioConstructor->armadura)) return; 
  if (!LeerCampo(file, "unidades", EdificioConstructor->unidades)) return; 
  EdificioConstructor->ArmyPadre = this;

  EdificioConstructor->AbreModelo();


  //----------------------------------------------
  
  fgets (szLine, 256, file); // Una linea de separacion


  fgets (szLine, 256, file); // Encabezado sin Valor
  if (!(string(szLine) != "GranjaSolar"))
    {
      War3DError ("ARMY", "Al abrir el Army " + Archivo);
      return;
    }

  ConstruArmy * GranjaSolar = new ConstruArmy;

  if (!LeerCampo(file, "__Nombre", GranjaSolar->nombre)) return; 
  if (!LeerCampo(file, "tipo", GranjaSolar->tipo)) return; 
  if (!LeerCampo(file, "mes", GranjaSolar->mes)) return; 
  if (!LeerCampo(file, "mesSkin", GranjaSolar->mesSkin)) return; 
  if (!LeerCampo(file, "escala", GranjaSolar->escala)) return; 
  if (!LeerCampo(file, "sonidos", GranjaSolar->sonidos)) return; 
  if (!LeerCampo(file, "sangre", GranjaSolar->sangre)) return; 
  if (!LeerCampo(file, "armadura", GranjaSolar->armadura)) return; 
  if (!LeerCampo(file, "unidades", GranjaSolar->unidades)) return; 

  GranjaSolar->ID = 1;

  GranjaSolar->ArmyPadre = this;

  GranjaSolar->AbreModelo();

  GranjaSolar->costo = (int)(GranjaSolar->alcance*80 + 
			     GranjaSolar->danio * 15 + 
			     GranjaSolar->veldedisparo * 15 + 
			     GranjaSolar->sangre / 2 +
			     GranjaSolar->Modelo->getRadio()*150)/12;
  
  fgets (szLine, 256, file); // Una linea de separacion

  //----------------------------------------------

  fgets (szLine, 256, file); // Encabezado sin Valor
  if (!(string(szLine) != "Estancia"))
    {
      War3DError ("ARMY", "Al abrir el Army " + Archivo);
      return;
    }

  ConstruArmy * Estancia = new ConstruArmy;

  if (!LeerCampo(file, "__Nombre", Estancia->nombre)) return; 
  if (!LeerCampo(file, "tipo", Estancia->tipo)) return; 
  if (!LeerCampo(file, "mes", Estancia->mes)) return; 
  if (!LeerCampo(file, "mesSkin", Estancia->mesSkin)) return; 
  if (!LeerCampo(file, "escala", Estancia->escala)) return; 
  if (!LeerCampo(file, "sonidos", Estancia->sonidos)) return; 
  if (!LeerCampo(file, "sangre", Estancia->sangre)) return; 
  if (!LeerCampo(file, "armadura", Estancia->armadura)) return; 
  if (!LeerCampo(file, "unidades", Estancia->unidades)) return; 

  Estancia->ID = 2;

  Estancia->ArmyPadre = this;

  Estancia->AbreModelo();

  Estancia->costo = (int)(Estancia->alcance*80 + 
			     Estancia->danio * 15 + 
			     Estancia->veldedisparo * 15 + 
			     Estancia->sangre / 2 +
			     Estancia->Modelo->getRadio()*150)/12;
  
  fgets (szLine, 256, file); // Una linea de separacion


  // ---------------------------------------------



  if (!LeerCampo(file, "Construcciones", NumConstrucciones))
    {
	  War3DError ("ARMY", "Al abrir el Army |" + Archivo + "|" );
      return;
    }

  NumConstrucciones++;
  NumConstrucciones++;
  
  Contrucciones = new ConstruArmy[NumConstrucciones];

  Contrucciones[0] = *GranjaSolar;
  Contrucciones[1] = *Estancia;

  // Leemos cada una de las unidades:
  for(i=2; i<NumConstrucciones; i++)
    {

      if (!LeerCampo(file, "__Nombre", Contrucciones[i].nombre)) return; 
      if (!LeerCampo(file, "tipo", Contrucciones[i].tipo)) return; 
      if (!LeerCampo(file, "mes", Contrucciones[i].mes)) return; 
      if (!LeerCampo(file, "mesSkin", Contrucciones[i].mesSkin)) return; 
      if (!LeerCampo(file, "escala", Contrucciones[i].escala)) return; 
      if (!LeerCampo(file, "sonidos", Contrucciones[i].sonidos)) return; 
      if (!LeerCampo(file, "sangre", Contrucciones[i].sangre)) return; 
      if (!LeerCampo(file, "armadura", Contrucciones[i].armadura)) return; 
      if (!LeerCampo(file, "unidades", Contrucciones[i].unidades)) return; 
      if (!LeerCampo(file, "danio", Contrucciones[i].danio)) return; 
      if (!LeerCampo(file, "alcance", Contrucciones[i].alcance)) return; 
      if (!LeerCampo(file, "veldedisparo", Contrucciones[i].veldedisparo)) return;

      Contrucciones[i].ArmyPadre = this;
      Contrucciones[i].ID = i+1;

      //VerificacionDeArmy(&Unidades[i]);

      Contrucciones[i].AbreModelo();
      Contrucciones[i].parcerUnidades();


      Contrucciones[i].costo = (int)(Contrucciones[i].alcance*80 + 
				Contrucciones[i].danio * 15 + 
				Contrucciones[i].veldedisparo * 15 + 
				Contrucciones[i].sangre / 2 +
				Contrucciones[i].Modelo->getRadio()*150)/12;



    for (int ii=0 ; ii<Contrucciones[i].getNumUnidades() ; ii++)
	{
	  Contrucciones[i].costo = Contrucciones[i].costo + Contrucciones[i].Unidades[ii]->costo / 3;
	}

	  
    if (Contrucciones[i].danio > 0)
	{
	  Contrucciones[i].costo = (int)(Contrucciones[i].costo * 1.5);
	}

  }

 // ---------------------------------------------
  fgets (szLine, 256, file); // Una linea de separacion


  fgets (szLine, 256, file); // Encabezado sin Valor
 if (!(string(szLine) != "Bandera"))
    {
      War3DError ("ARMY", "Al abrir el Army |" + Archivo + "|" );
      return;
    }
  
  LaBandera = new Banderita[1];

  // Leemos cada una de las unidades:
  for(i=0; i<1; i++) // :P Solo itera una vez, pero lo pongo par compativilidad
    {
      if (!LeerCampo(file, "__Nombre", LaBandera[i].nombre)) return; 
      if (!LeerCampo(file, "mes", LaBandera[i].mes)) return; 
      if (!LeerCampo(file, "skin", LaBandera[i].mesSkin)) return; 
      if (!LeerCampo(file, "escala", LaBandera[i].escala)) return; 

      LaBandera[i].ArmyPadre = this;

      //VerificacionDeArmy(&Unidades[i]);

      LaBandera[i].AbreModelo();

    }

  fclose(file);

}

// ------------------------------------------------
void Army::VerificacionDeArmy(UnidadArmy *Unidad)
{
  if (Unidad->sangre > 500) 
    { 

      War3DError ("ARMY", "La Sangre de los bichos no debe ser mayor a 500");
      Unidad->sangre = 500; 
    }
  if (Unidad->armadura > 500) 
    { 
      War3DError ("ARMY","El armadura de los bichos no debe ser mayor a 500");
      Unidad->armadura = 500; 
    }
  if (Unidad->danio > 100) 
    { 
      War3DError ("ARMY", "El dao de los bichos debe ser menor a 100");
      Unidad->danio = 100; 
    }

  if (Unidad->velocidad > 2.0) 
    { 
      War3DError ("ARMY", "La velocidad de los bichos no debe ser mayor a 2.0");
      Unidad->velocidad = 2.0; 
    }

  if (Unidad->alcance > 1.5) 
    { 
      War3DError ("ARMY", "El Alcance de los bichos no debe ser mayor a 1.5");
      Unidad->alcance = 1.5; 
    }

  if (Unidad->veldedisparo > 10) 
    { 
      War3DError ("ARMY", "La Velocidad de disparo de los bichos no debe ser mayor a 10");
      Unidad->veldedisparo = 10; 
    }

}

// ------------------------------------------------
bool Army::LeerCampo(FILE *file, string Campo, float &Valor)
{

  char	szLine[256];
  fgets (szLine, 256, file);
  Campo = Campo + ": %f"; 

  // Leemos el numero de unidaddes:
  if (sscanf (szLine, Campo.c_str(), &Valor) == 1)
    {
     
      if (Valor < 0.0)
	{
	  War3DError ("ARMY", "No se admiten numeros menores a 0.0 en el campo: " + Campo);
	  return false;
	}
      return true;
    }
  else
    {
      War3DError ("Army", "Error en el formato, Campo: " + Campo);
    }

  return false;

}


// ------------------------------------------------
bool Army::LeerCampo(FILE *file, string Campo, int &Valor)
{

  char	szLine[256];
  fgets (szLine, 256, file);
  Campo = Campo + ": %i"; 

  // Leemos el numero de unidaddes:
  if (sscanf (szLine, Campo.c_str(), &Valor) == 1)
    {
           
      if (Valor < 0)
	{

	  War3DError ("ARMY", "No se admiten numeros menores a 0 en el campo: " + Campo);
	  return false;
	}
      return true;
    }
  else
    {
      War3DError ("ARMY", "Error en el formato, Campo: " + Campo);
      return false;
    }
}

// ------------------------------------------------
bool Army::LeerCampo(FILE *file, string Campo, string &Valor)
{

  char szLine[256];

  fgets (szLine, 256, file);

  string Leida = szLine;

 
  int FinDeLineaR;	  
  int FinDeLineaN;	 	
  
  int FinDeLinea;	 	
  
  FinDeLineaR = Leida.find ("\r");	 	
  FinDeLineaN = Leida.find ("\n");	 	
  
  FinDeLinea = FinDeLineaR;	 	
  if (FinDeLinea == (int)string::npos)	 	
    {	 	
      FinDeLinea = FinDeLineaN;	 	
    }


  if ((FinDeLineaN != (int)string::npos && FinDeLineaR != (int)string::npos) && FinDeLineaN<FinDeLineaR)	  	
   {	 	
     FinDeLinea = FinDeLineaN;	 	
   }


  if (FinDeLinea == (int)string::npos)
    {
      War3DError ("ARMY", "No se encontro fin de linea en al campo: " + Campo);
    }

  Leida = Leida.substr (0, FinDeLinea);

  Campo = Campo + ": ";
  if (Leida.substr(0, Campo.length()) == Campo)
    {
      Valor = Leida.substr(Campo.length(), 999);
      return true;
    }
  else
    {
      War3DError ("ARMY", "Error en el formato, Campo: " + Campo);
      return false;
    }
}

// ------------------------------------------------
UnidadArmy *Army::getBichoID (string Nombre)
{
  int i;

  for(i=0; i<NumUnidades; i++)
    {
      if (Unidades[i].nombre == Nombre)
	{
	  return &Unidades[i];
	}
    }

  War3DError ("ARMY", "getBichoID: bicho no existente: " + Nombre);
  return NULL;
}


// ------------------------------------------------
UnidadArmyBase::UnidadArmyBase()
{
  ArmyPadre = NULL;
  
  tipo = "";
  string nombre = "";
  string sonidos = "";
  costo = 0;
  sangre = 0;
  armadura = 0;

  alcance = 0.0;
  danio = 0;
  veldedisparo = 0;
}


//**************************
//**     UNIDAD ARMY      **
//**************************

// ------------------------------------------------
UnidadArmy::UnidadArmy(Army *ArmyPadre)
{
  this->ArmyPadre = ArmyPadre;
}

// ------------------------------------------------
UnidadArmy::~UnidadArmy()
{
  delete Modelo;
}

// ------------------------------------------------
void UnidadArmy::AbreModelo()
{

  War3DAccion("ARMY", string("[  ***  ] Abriendo Modelo: ") + nombre);
  
  string _Mes = "UnidadesDeCombate/" + tipo + "/Mesh/" + mes + "/unidad";
  string _MesSkin = "UnidadesDeCombate/" + tipo + "/Mesh/" + mes + "/" + mesSkin; 
  string _Arma = "UnidadesDeCombate/" + tipo + "/Arma/" + arma + "/arma";
  string _ArmaSkin = "UnidadesDeCombate/" + tipo + "/Arma/"  + arma + "/" + armaSkin;
  string _Animacion = "UnidadesDeCombate/" + tipo + "/Arma/"  + arma + "/animacion";
  
  string _MiniFoto = "UnidadesDeCombate/" + tipo + "/Mesh/" + mes + "/pic_" + mesSkin + ".tga"; 

  if (!configuracion::War2D)  
    {

      Modelo = new Model;    
      if (arma != "SinArma")
	{
	  ((Model*)Modelo)->Inicia(_Mes.c_str(),
				   _MesSkin.c_str(),
				   _Arma.c_str(),
				   _ArmaSkin.c_str(),
				   _Animacion.c_str(),
				   escala);
	}
      else
	{
	  ((Model*)Modelo)->Inicia(_Mes.c_str(),
				   _MesSkin.c_str(),
				   _Animacion.c_str(),
				   escala);
	}
    }
  else
    {
      Modelo = new GL_SpriteEx;
      ((GL_SpriteEx*)Modelo)->SetFrameSize(32, 32);
      ((GL_SpriteEx*)Modelo)->PushFrame(_MiniFoto);
      ((GL_SpriteEx*)Modelo)->LoadFrames();
    }

    MiniFoto = ServidorDeTexturas::ME()->Nueva(_MiniFoto.c_str());

}



//**************************
//**    EDIFICIO ARMY      **
//**************************
ConstruArmy::ConstruArmy(Army *ArmyPadre)
{
  this->ArmyPadre = ArmyPadre;
  NumUnidades = 0;

  danio = 0;
  alcance = 0; 
  veldedisparo = 0;

}

// ------------------------------------------------
ConstruArmy::~ConstruArmy()
{
  delete Modelo;
}

// ------------------------------------------------
void ConstruArmy::parcerUnidades()
{

  int fin;
  int i;

  // Reservamos memoria;
  Unidades = new UnidadArmy* [10];

  if (unidades != "NULL")
    {
      //Y volvemos a recorrrer la cadena, pero ahora ya sabemos cuantos elementos tiene;
      for (i=0; i<10 ;i++)
	{
	  NumUnidades ++;
	  fin = unidades.find (" ");
	  if (fin > 0)
	    {
	      Unidades[i] = ArmyPadre->getBichoID(unidades.substr(0, fin));
	      if (Unidades[i] == NULL)
		{
		  War3DError ("ConstruArmy", "La unidad " + unidades.substr(0, fin) +  " solicitada por el edificio no existe");
		}
	    }
	  else
	    {
	      Unidades[i] = ArmyPadre->getBichoID(unidades.substr(0, 999));
	      if (Unidades[i] == NULL)
		{
		  War3DError ("ConstruArmy", "La unidad " + unidades.substr(0, fin) +  " solicitada por el edificio no existe");
		}
	      return;
	    }
	  unidades = unidades.substr(fin+1, 99);
	}
    }
}

// ------------------------------------------------
void ConstruArmy::AbreModelo()
{

  War3DAccion("ARMY", string("[  ***  ] Abriendo Modelo: ") + nombre);
  
  string _Mes = "Edificios/" + tipo + "/Mesh/" + mes + "/edificio";
  string _MesSkin = "Edificios/" + tipo + "/Mesh/" + mes + "/" + mesSkin; 
  string  _Animacion = "Edificios/" + tipo + "/Mesh/" + mes + "/animacion";
  
  string _MiniFoto = "Edificios/" + tipo + "/Mesh/" + mes + "/pic_" + mesSkin + ".tga"; 

  if (!configuracion::War2D)  
    {
      Modelo = new Model;
      
      ((Model*)Modelo)->Inicia(_Mes.c_str(),
			       _MesSkin.c_str(),
			       _Animacion.c_str(),
			       escala);  
      
    }
  else
    {
      Modelo = new GL_SpriteEx;
      ((GL_SpriteEx*)Modelo)->SetFrameSize(32, 32);
      ((GL_SpriteEx*)Modelo)->PushFrame(_MiniFoto);
      ((GL_SpriteEx*)Modelo)->LoadFrames();

    }

  MiniFoto = ServidorDeTexturas::ME()->Nueva(_MiniFoto.c_str());
}
  




//**************************
//**     BANDERA      **
//**************************
Banderita::Banderita(Army *ArmyPadre)
{
  this->ArmyPadre = ArmyPadre;
}

// ------------------------------------------------
Banderita::~Banderita()
{
  delete Modelo;
}

// ------------------------------------------------
void Banderita::AbreModelo()
{

  War3DAccion("ARMY", string("[  ***  ] Abriendo Bandera: ") + nombre);
  
  string _Mes = "Objetos/Banderas/" + mes + "/bandera";
  string _MesSkin = "Objetos/Banderas/" + mes + "/" + mesSkin; 
  string _Animacion =  "Objetos/Banderas/" + mes + "/bandera";
  
  
  if (!configuracion::War2D)  
    {
      Modelo = new Model;    
      ((Model*)Modelo)->Inicia(_Mes.c_str(),
			       _MesSkin.c_str(),
			       _Animacion.c_str(),
			       escala);  
    }
  else
    {
      Modelo = new GL_SpriteEx;
      ((GL_SpriteEx*)Modelo)->SetFrameSize(128, 128);
      ((GL_SpriteEx*)Modelo)->PushFrame(_MesSkin + ".tga");
      ((GL_SpriteEx*)Modelo)->LoadFrames();
    }
}
  
