/*=[[ Solar OpenSource Org (c) 2003 ]]=*/

//***************************************************************
//*  [[ A D V E R T E N C I A ]] =[ http://Solar-OpenSource.Org ]=
//*
//*  LICENCIA PARA LA DISTRIBUCIN DE WAR 3D
//*  1.- WAR 3D es un programa que podr ser distribuido bajo los trminos de la Licencia Pblica General, adems debern cumplirse las siguientes condiciones.
//*  2.- Al copiar cualquier parte del cdigo para ponerlo en un programa diferente a WAR 3D, el autor de dicho programa estar de acuerdo en que el cdigo completo de su programa pasa a ser software libre, por lo deber estar apegado a los trminos establecidos por la licencia LGP. Es decir que, el cdigo de WAR 3D solo puede ser tomado si se va a usar en otro proyecto de software libre. De lo contrario abstngase de usar el cdigo o parte de el cdigo de WAR3D.
//*  3.- Queda estrictamente prohibido modificar los nombres que aparecen en los crditos del programa, solo el grupo de desarrollo de  Solar-OpenSource podr aadir nuevos nombres en los crditos. Si ha hecho alguna modificacin y quiere que su nombre aparezca en los crditos debe ponerse en contacto con nosotros.
//*  4.- Cualquier modificacin del cdigo debe apegarse en lo posible a las normas que ha establecido el grupo de desarrollo de Solar-OpenSource, esto es para mayor claridad en el cdigo. Dichas normas pueden encontrarse en nuestra pagina web http://www.solar-opensource.org
//*  5.- Puede copiar y distribuir el programa siempre y cuando no olvide: Acompaarlo con el cdigo fuente completo correspondiente, legible para la mquina, as como el cdigo escrito por usted o las modificaciones hechas al cdigo original.
//*  6.- No debe distribuirse el ejecutable sin el cdigo fuente.
//*  7.- Este texto no debe suprimirse. Las distribuciones deben acompaarse con la informacin que se recibi as como el ofrecimiento para distribuir el cdigo fuente correspondiente.
//*
//***************************************************************

#ifndef __army_h__
#define __army_h__

#include <iostream>
#include <string>

using namespace std;

#include "constantes.h"
#include "texturas.h"
#include "rendereable.h"

class Army;


class UnidadArmyBase
{
 private:

 public:

  UnidadArmyBase();
  UnidadArmyBase (Army *ArmyPadre);
  virtual ~UnidadArmyBase (){};

  int ID;

  string mes;
  string mesSkin;

  float escala;

  Army *ArmyPadre;

  string tipo;
  string nombre;
  string sonidos;
  int costo;
  int sangre;
  int armadura;

  float alcance;
  int danio;
  int veldedisparo;

  //--MODELO--
  rendereable * Modelo;
  Textura MiniFoto;

  virtual void AbreModelo () = 0;

};


//----------------
class UnidadArmy: public UnidadArmyBase
{

 private:

 public:
 
  string arma;
  string armaSkin;

  string tipomovimiento;
  string tiposer;

  float velocidad;
  
  UnidadArmy () {ArmyPadre = NULL;};
  UnidadArmy (Army *ArmyPadre);
  
  ~UnidadArmy ();


  void AbreModelo();
  
};


//----------------
class ConstruArmy: public UnidadArmyBase
{

 private:

  int NumUnidades;


 public:

  string unidades;

  UnidadArmy **Unidades;
  int getNumUnidades() {return NumUnidades;};


  //--MODELO--
  Textura MiniFoto;

  void parcerUnidades();

  ConstruArmy() {NumUnidades = 0; ArmyPadre = NULL;};
  ConstruArmy(Army *ArmyPadre);
  ~ConstruArmy();

  void AbreModelo();
};

//----------------
class Banderita: public UnidadArmyBase
{

 private:

 public:

  Banderita () {ArmyPadre = NULL;};
  Banderita (Army *ArmyPadre);
  ~Banderita();

  void AbreModelo();
};


//----------------

class Army
{
 private:

  bool LeerCampo(FILE *file, string Campo, string &Valor);
  bool LeerCampo(FILE *file, string Campo, int &Valor);
  bool LeerCampo(FILE *file, string Campo, float &Valor);

  int NumUnidades;
  int NumConstrucciones;

 public:
  UnidadArmy * Unidades;
  ConstruArmy * EdificioConstructor;
  ConstruArmy *Contrucciones; 
  Banderita * LaBandera;
  

  Army();
  void LeerArmy(string Archivo);

  int getNumUnidades() {return NumUnidades;};
  int getNumConstrucciones() {return NumConstrucciones;};

  void VerificacionDeArmy(UnidadArmy *Unidad);

  UnidadArmy *getBichoID (string Nombre);

};

#endif
