//***************************************************************
//*  [[ A D V E R T E N C I A ]] =[ http://Solar-OpenSource.Org ]=
//*
//*  LICENCIA PARA LA DISTRIBUCIN DE WAR 3D
//*  1.- WAR 3D es un programa que podr ser distribuido bajo los trminos de la Licencia Pblica General, adems debern cumplirse las siguientes condiciones.
//*  2.- Al copiar cualquier parte del cdigo para ponerlo en un programa diferente a WAR 3D, el autor de dicho programa estar de acuerdo en que el cdigo completo de su programa pasa a ser software libre, por lo deber estar apegado a los trminos establecidos por la licencia LGP. Es decir que, el cdigo de WAR 3D solo puede ser tomado si se va a usar en otro proyecto de software libre. De lo contrario abstngase de usar el cdigo o parte de el cdigo de WAR3D.
//*  3.- Queda estrictamente prohibido modificar los nombres que aparecen en los crditos del programa, solo el grupo de desarrollo de  Solar-OpenSource podr aadir nuevos nombres en los crditos. Si ha hecho alguna modificacin y quiere que su nombre aparezca en los crditos debe ponerse en contacto con nosotros.
//*  4.- Cualquier modificacin del cdigo debe apegarse en lo posible a las normas que ha establecido el grupo de desarrollo de Solar-OpenSource, esto es para mayor claridad en el cdigo. Dichas normas pueden encontrarse en nuestra pagina web http://www.solar-opensource.org
//*  5.- Puede copiar y distribuir el programa siempre y cuando no olvide: Acompaarlo con el cdigo fuente completo correspondiente, legible para la mquina, as como el cdigo escrito por usted o las modificaciones hechas al cdigo original.
//*  6.- No debe distribuirse el ejecutable sin el cdigo fuente.
//*  7.- Este texto no debe suprimirse. Las distribuciones deben acompaarse con la informacin que se recibi as como el ofrecimiento para distribuir el cdigo fuente correspondiente.
//*
//***************************************************************

#include  "astar_v1.h"

// ----------------------
IACamino::IACamino()
{
  //static int i = 0;
  //cout << "IACamino_Costructor: " << i << endl; i++;
  path = new IAminiNodo[MaxNodos];
  //cout << (int) path << endl;
}

// ----------------------
IACamino::IACamino(const IACamino& pobj) //Clonar	
{

  //static int i = 0;
  //cout << "IACamino_Copia: " << i << endl; i++;

  //cout << (int) pobj.path << "  ->  ";

  memcpy(this, &pobj, sizeof(IACamino));

  this->path = new IAminiNodo[MaxNodos];
  memcpy(path, pobj.path, MaxNodos * sizeof(IAminiNodo));

  //cout << (int) path << endl;

}

// ----------------------
IACamino::~IACamino()
{

  static int i = 0;
  cout << "IACamino_Destructor: " << i << endl; i++;
  // cout << (int)path << endl;

  delete [] path;
  path = NULL;
}


// ----------------------------------------------
AStar::AStar()
{
  Inicializado = false;
  alto=0; // Altura del mapa
  ancho=0; // Ancho del mapa
  size=0; // Tamao de *mapa
}


// -----------------------------------------------
void AStar::Clean()
{
  if(AStar::Nodos)
    {
      delete[] AStar::Nodos;
      AStar::Nodos=NULL;
    }
  if(AStar::mapa)
    {
      delete[] AStar::mapa;
      AStar::mapa=NULL;
    }
  AStar::Inicializado = false;
  AStar::alto=0; // Altura del mapa
  AStar::ancho=0; // Ancho del mapa
  AStar::size=0; // Tamao de *mapa
}


// -----------------------------------------------
void AStar::SetPoint(int x,int y,bool value)
{
  if(!AStar::Inicializado){	return;	}
  if(x<0 || x>ancho){	return;	}
  if(y<0 || y>alto) {	return;	}

  unsigned char mask[8]={128,64,32,16,8,4,2,1};

  int b=(y*ancho+x)/8;
  if(value)
    {
      mapa[b] = mapa[b] | mask[(y*ancho+x)%8];
    }
  else 
    {	
      mapa[b] = mapa[b] & mask[(y*ancho+x)%8];
    } 
}



// -----------------------------------------------
bool AStar::GetPoint(int x,int y)
{
 if(!AStar::Inicializado)
   {
     War3DError("[ASTAR]", "IA map no inicializado");
     return false;
   }
  if(x<0 || x>ancho){	return true ;	}
  if(y<0 || y>alto) {	return true ;	}

  unsigned char mask[8]={128,64,32,16,8,4,2,1};

  int b=(y*ancho+x)/8;
  if(mapa[b] & mask[(y*ancho+x)%8])
    {
      return true;
    }
  else 
    {
      return false;
    }
}


 
// -----------------------------------------------
void AStar::Crear()
{
  
  if(AStar::Inicializado)
    {
      War3DError("[ASTAR]", "ASTAR previamente inicializado, hay que llamr a Clean() antes de inicializad de nuevo");
      return;
   }


  AStar::Inicializado = true;

  Nodos = new nodo [MaxNodos];
   
  ancho = Tierra::ME()->getAncho()*4;
  alto = Tierra::ME()->getAlto()*4;



  if(ancho*alto%8)
    {
      size=(ancho*alto)/8+1;
    } 
  else
    {
      size=(ancho*alto)/8;
    }

  mapa=new unsigned char[size];	
  memset(mapa,0,size);

  int x, y;



  verticeTierra *v=(verticeTierra *)Tierra::ME()->getVertices();

  

  for(x=0; x<Tierra::ME()->getAncho(); x++)
    {
      for (y=0; y<Tierra::ME()->getAlto(); y++)
	{
	  if (v[y*Tierra::ME()->getAncho()+x].ObjetosMap != NULL)
	    {

  
	      if (v[y*Tierra::ME()->getAncho()+x].ObjetosMap->Tipo != "Hierba")
		{
		  putObjeto(v[y*Tierra::ME()->getAncho()+x].ObjetosMap->getModelo(), x/Densidad, y/Densidad);
		}

	    }

	}
    }
		  cout << "ANCHO:" << ancho << endl;  
 
}


// -----------------------------------------------
void AStar::putObjeto(rendereable *Objeto, float X, float Y)
{

  X = X * Densidad * 4;
  Y = Y * Densidad * 4;

  if(!AStar::Inicializado)
    {
      War3DError("[ASTAR]", "IA map no inicializado");
      return;
    }

  int x,y;

  for (y=1; y<TamMayaIA-1 ; y++)
    {
      for (x=1; x<TamMayaIA-1 ; x++)
	{
	  if (Objeto->getIAMaya()[(y+0)*TamMayaIA+(x+1)] ||
	      Objeto->getIAMaya()[(y+0)*TamMayaIA+(x+0)] ||
	      Objeto->getIAMaya()[(y+0)*TamMayaIA+(x-1)] ||
	      Objeto->getIAMaya()[(y+1)*TamMayaIA+(x+0)] ||   
	      Objeto->getIAMaya()[(y-1)*TamMayaIA+(x+0)])   
	    {
	      SetPoint((int)X + (x-TamMayaIA/2),
		       (int)Y + (y-TamMayaIA/2),
		       true);
	    }
	}
    }
}

// -----------------------------------------------
bool AStar::insertaObjeto(rendereable *Objeto, float X, float Y)
{

  X = X * Densidad * 4;
  Y = Y * Densidad * 4;

 if(!AStar::Inicializado)
   {
     War3DError("[ASTAR]", "IA map no inicializado");
     return false;
   }

  int x,y;

  for (y=1; y<TamMayaIA-1 ; y++)
    {
      for (x=1; x<TamMayaIA-1 ; x++)
	{
	  if (Objeto->getIAMaya()[(y+0)*TamMayaIA+(x+1)] ||
	      Objeto->getIAMaya()[(y+0)*TamMayaIA+(x+0)] ||
	      Objeto->getIAMaya()[(y+0)*TamMayaIA+(x-1)] ||
	      Objeto->getIAMaya()[(y+1)*TamMayaIA+(x+0)] ||   
	      Objeto->getIAMaya()[(y-1)*TamMayaIA+(x+0)])   
	    {
	      if (GetPoint((int)X + (x-TamMayaIA/2),
			   (int)Y + (y-TamMayaIA/2)))
		{
		  return false;
		}
			   
	    }
	}
    }
  return true;
}


//-----------------------------------------------

float AStar::Distancia (int x1,int y1,int x2,int y2,int tipo)
{


  int X = abs(x1-x2);
  int Y = abs(y1-y2);
  // Vamos a obtener la distancia entre dos puntos
  // pero existen tres tipos de metrica, curiosamente me las
  // acaban de ensear en la escuela. ChessBoard, Manhattan y Euclideana
   
  switch (tipo)
    {
    case (dChessBoard):
      return ( X>Y ? X:Y );
      break;
    case (dManhattan):
      return(X+Y);
      break;
    case(dEuclideana):
      return(zDistancia(x1, y1, x2, y2));
      break;
    }
  return -1;
}



// ----------------------------------------------------
void AStar::getPath(float iniX, float iniY, float finX, float finY, IACamino *Camino, float radio)
{

  Camino->p = 0;

  if(!AStar::Inicializado)
    {
      War3DError("[ASTAR]", "IA map no inicializado");
      return;
   }

  // Convetimos las coordenadas reales a coordenadas en el mapa de la IA
  int inix = (int)(4 * Densidad * iniX);
  int iniy = (int)(4 * Densidad * iniY);
  int finx = (int)(4 * Densidad * finX);
  int finy = (int)(4 * Densidad * finY);

  int s = 0;
  // Miramos si el punto en el que hemos cliqueado esta ocupado por algun obstaculo.

  if (GetPointConRadio(finx, finy, radio))
    {
      //si es asi bucaremos el punto mas cercano que no sea obtaculo;
      for (;;)
	{
	  s++;
	  // para ellos miramo cuatro puntos en deredor y nos vamos alejando poco a poco
	  if (!GetPointConRadio(finx+s, finy+s, radio))
	    {
	      finx = finx+s; finy = finy+s;
	      break;
	    }
	  if (!GetPointConRadio(finx+s,finy-s, radio))
	    {
	      finx = finx+s; finy = finy-s;
	      break;
	    }
	  if (!GetPointConRadio(finx-s, finy+s, radio))
	    {
	      finx = finx-s; finy = finy+s;
	      break;
	    }
	  if (!GetPointConRadio(finx-s, finy-s, radio))
	    {
	      finx = finx-s; finy = finy-s;
	      break;
	    }
	}
    }

  // Si estamos parados sobre el destino no hacemos nada.
  if (inix == finx && iniy == finy)
    {
      Camino->Pasos = 0;
      return;
    }

  int Contador = 0;

  nodo *nodoMin;
	
  nodo *existe;
  nodo Hijos[8];

  nodo Padre;

  // Paso 1: El nodo padre, ponemos su g a cero, y h igual a la distancia entre el y la meta.  cout << "(" << finx << "," << finy << ")" << endl;
  Padre.x = inix;
  Padre.y = iniy;
  Padre.g = 0;
  Padre.h = 1.1 * Distancia(Padre.x, Padre.y, finx, finy, dEuclideana);
  Padre.abierto = true;
  Padre.padre = NULL;

  // Paso 2: Agregamos el nodo a la lista de abiertos.

  Nodos[0] = Padre;  
  
  // Paso 3: Iteramos en la lista de nodos abiertos. Pero anteshasta que quede vacia.
  while (1 > 0)  // Esta liena esta MAL
    {
      // Paso 4: Buscamos el f mas pequeo. f = h+g
      nodoMin = Minimo(Nodos, Contador);
      
      // Paso 5: El nodo con el que estamos trabajando lo ponemos en la lista de nodos cerrados.
      nodoMin->abierto = false;
      
      // Paso 6: Generamos los 8 hijos, podrian ser solo 4 dependiendo de la topologia usada.
      Hijos[0].x = nodoMin->x+0; Hijos[0].y = nodoMin->y+1;
      Hijos[1].x = nodoMin->x+1; Hijos[1].y = nodoMin->y+1;
      Hijos[2].x = nodoMin->x+1; Hijos[2].y = nodoMin->y+0;
      Hijos[3].x = nodoMin->x+1; Hijos[3].y = nodoMin->y-1;
      Hijos[4].x = nodoMin->x+0; Hijos[4].y = nodoMin->y-1;
      Hijos[5].x = nodoMin->x-1; Hijos[5].y = nodoMin->y-1;
      Hijos[6].x = nodoMin->x-1; Hijos[6].y = nodoMin->y+0;
      Hijos[7].x = nodoMin->x-1; Hijos[7].y = nodoMin->y+1;
      
      //Paso 7: Para cada Hijo, Calculamos sus g y h y lo enlazamos con su padre.
      for (int i=0 ; i<8 ; i++)
	{
	  // Si el nodo es la meta nos detenemos
	  if ((Hijos[i].x == finx) &&  (Hijos[i].y == finy))
	    {
	      Camino->TodoCalculado = true;
	      Hijos[i].padre = nodoMin;
	      Recontruccion (Hijos[i], Nodos, inix, iniy, Camino);
	      return;
	    }
	  
	  if (Contador >= MaxNodos-1)
	    {
	      Camino->TodoCalculado = false;
	      Hijos[i].padre = nodoMin;
	      Recontruccion (Hijos[i], Nodos, inix, iniy, Camino);
	      return;
	    }

	  // g = La distancia entre el y su padre. En las diagonales podria se raiz de 2. 
	  if (GetPointConRadio(Hijos[i].x,Hijos[i].y, radio))
	    {
	      Hijos[i].g = 100;
	    }
	  else
	    {
	      if (i%2 == 1)
		{
		  Hijos[i].g = nodoMin->g + 1.41; 
		}
	      else
		{
		  Hijos[i].g = nodoMin->g + 1.0; 
		}
	    }
					
	  // h = La distancia entre el y el destino
	  Hijos[i].h = 1.1 * Distancia(Hijos[i].x, Hijos[i].y, finx, finy, dEuclideana);
					
	  // Lo enlazamos con su padre
	  Hijos[i].padre = nodoMin;
					
	  // Paso 8: Buscamos un nodo con las misma x y y, en la lista de nodos
					
	  existe = YaExiste(Hijos[i], Nodos, Contador);
	  if (existe != NULL)
	    {
	      if (existe->abierto == true)
		{
		  // 8a: Si existe. Miramos cual tiene menor f, y conservamos los valores de la menos f
		  if ((Hijos[i].h + Hijos[i].g) < (existe->h + existe->g))
		    {
		      existe->h = Hijos[i].h;
		      existe->g = Hijos[i].g;
		      existe->padre = Hijos[i].padre;
		    }
		}
	    }
	  else 
						
	    {
	      // Paso 10: Si no existe en ninguna de las dos listas lo agregamos a la lista de Nodos					

	      Contador ++;

	      Hijos[i].abierto = true;
	      Nodos[Contador] = Hijos[i];
							
	    }
	}
    }
}


// ---------------------------------------------
bool AStar::GetPointConRadio(int x, int y, float radio)
{


  if (radio == 0)
    {
      return false;
    }

  if (radio <= 0.06)
    {
      return GetPoint(x, y);
    }
  else if (radio > 0.06 && radio <= 0.10)
    {
      return 
	GetPoint(x+0, y+0) ||
 	GetPoint(x+0, y+1) ||
	GetPoint(x+0, y-1) ||
	GetPoint(x-1, y+0) ||
	GetPoint(x+1, y-0);
    }

  else if (radio > 0.10 && radio <= 0.30)
    {
      return 
 	GetPoint(x+0, y+1) ||
	GetPoint(x+0, y-1) ||
	GetPoint(x-1, y+0) ||
	GetPoint(x+1, y-0) ||
	GetPoint(x+0, y+0) ||
 	GetPoint(x+1, y+1) ||
	GetPoint(x+1, y-1) ||
	GetPoint(x-1, y+1) ||
	GetPoint(x-1, y-1);
    }
  War3DError("[ASTAR]", "Radio exesivo");
  return false;

}



// ---------------------------------------------
nodo *AStar::Minimo(nodo *NodosAbiertos, int Contador)
{
  // Buscamos la f mas pequea

  nodo nodoTMP;
  nodoTMP.g = 10000;
  nodoTMP.h = 10000;

  nodo *nodoMin = &nodoTMP;

  for (int i=0  ; i<=Contador ; i++)
    {
      if (NodosAbiertos[i].abierto)
	{
	  if ((NodosAbiertos[i].g + NodosAbiertos[i].h) < (nodoMin->g + nodoMin->h))
	    {
	      nodoMin = &NodosAbiertos[i];
	    }
	}
    }

  return nodoMin;
}


// ---------------------------------------------
nodo *AStar::YaExiste(nodo Hijo, nodo *Nodos, int Contador)
{
  //Buscamos un Nodo con las mismas X y Y;

  for (int i=0 ; i<=Contador ; i++)
    {
      if (Hijo.x == Nodos[i].x)
	{
	  if (Hijo.y == Nodos[i].y)
	    {
	      return &Nodos[i];
	    }
	}
    }

  return NULL;
}

// ------------------------------------------------
void AStar::Recontruccion (nodo Hijo, nodo *NodosCerrados, int inix, int iniy, IACamino *Camino)

{
  
  int Cont = 0;
  nodo *Padre = &Hijo;
  
  do
    {
      // Guardamos los pasos siguientes
      Camino->path[Cont].x =  Padre->x/4.0/Densidad;
      Camino->path[Cont].y =  Padre->y/4.0/Densidad;
      Padre = Padre->padre; 
      Cont ++;

    }   while ((Padre->x != inix) || (Padre->y != iniy));
  Camino->path[Cont].x =  Padre->x/4.0/Densidad;
  Camino->path[Cont].y =  Padre->y/4.0/Densidad;


  Camino->Pasos = Cont;
 
  // Invertimos todo, ya que el camino re recorrio de atras hacia adelante.

  IAminiNodo tmp;
  for (int i=0; i<Camino->Pasos/2 ; i++)
    {
      tmp = Camino->path[i]; 
      Camino->path[i] = Camino->path[Cont-i];
      Camino->path[Cont-i]=tmp;
    }



}
