//***************************************************************
//*  [[ A D V E R T E N C I A ]] =[ http://Solar-OpenSource.Org ]=
//*
//*  LICENCIA PARA LA DISTRIBUCIÓN DE WAR 3D
//*  1.- WAR 3D es un programa que podrá ser distribuido bajo los términos de la Licencia Pública General, además deberán cumplirse las siguientes condiciones.
//*  2.- Al copiar cualquier parte del código para ponerlo en un programa diferente a WAR 3D, el autor de dicho programa estará de acuerdo en que el código completo de su programa pasa a ser software libre, por lo deberá estar apegado a los términos establecidos por la licencia LGP. Es decir que, el código de WAR 3D solo puede ser tomado si se va a usar en otro proyecto de software libre. De lo contrario absténgase de usar el código o parte de el código de WAR3D.
//*  3.- Queda estrictamente prohibido modificar los nombres que aparecen en los créditos del programa, solo el grupo de desarrollo de  Solar-OpenSource podrá añadir nuevos nombres en los créditos. Si ha hecho alguna modificación y quiere que su nombre aparezca en los créditos debe ponerse en contacto con nosotros.
//*  4.- Cualquier modificación del código debe apegarse en lo posible a las normas que ha establecido el grupo de desarrollo de Solar-OpenSource, esto es para mayor claridad en el código. Dichas normas pueden encontrarse en nuestra pagina web http://www.solar-opensource.org
//*  5.- Puede copiar y distribuir el programa siempre y cuando no olvide: Acompañarlo con el código fuente completo correspondiente, legible para la máquina, así como el código escrito por usted o las modificaciones hechas al código original.
//*  6.- No debe distribuirse el ejecutable sin el código fuente.
//*  7.- Este texto no debe suprimirse. Las distribuciones deben acompañarse con la información que se recibió así como el ofrecimiento para distribuir el código fuente correspondiente.
//*
//***************************************************************

#include "comandos.h"

#include "comunicaciones.h"

/////////////////////////////////
comComandoBASE::comComandoBASE(string Comando, void* Padre)
{ 
  strComando = Comando; 
  this->Padre = Padre;
}


/////////////////////////////////
bool comComandoBASE::Accion(string Comando)
{

  vector<string> ComandoParceado;

  string Cadena = Comando;

  Cadena = Cadena.substr(0,Cadena.size()-2); //Quitamos el "\r\n"
  int fin;

  bool Primera = true;
  for (;;)
    {
      fin = Cadena.find (" ");
      if (fin != (int)string::npos)
	{

	  /*
	  cout << ComandoParceado.size() << " - " << Cadena <<  endl;
	  cout << "fin: " << fin << " " << string::npos  << endl;
	  zSleep(1000);
	  */

	  ComandoParceado.push_back(Cadena.substr(0, fin));
	  if (Primera)
	    {
	      if (Cadena.substr(0, fin) != strComando) 
		{
		  return false;
		}
	    }
	  Primera = false;
	}
      else
	{
	  ComandoParceado.push_back(Cadena);
	  if (Primera)
	    {
	      if (Cadena.substr(0, fin) != strComando) 
		{
		  return false;
		}
	    }
	  break;
	}
      Cadena = Cadena.substr(fin+1, 999);
    }

  onAccion(ComandoParceado);
  return true;
}






//////////// PI /////////////
void comComandoPOSINI::onAccion(vector<string> ComandoParceado)
{
  int InternetID = atoi(ComandoParceado[1].c_str());
  float x = atoi(ComandoParceado[2].c_str()) / 1000.0;
  float y = atoi(ComandoParceado[3].c_str()) / 1000.0;
  ((comunicaciones*)Padre)->onPOSINI(InternetID, x, y);
}


//////////// CH /////////////
void comComandoCHAT::onAccion(vector<string> ComandoParceado)
{
  string strMensaje;
  int InternetID = atoi(ComandoParceado[1].c_str());

  for (vector<string>::iterator Ite = ComandoParceado.begin()+2; Ite != ComandoParceado.end(); Ite++)
    {
      strMensaje += *Ite + " ";
    }
  ((comunicaciones*)Padre)->onCHAT(InternetID, strMensaje);
}


//////////// RO /////////////
void comComandoADMIN::onAccion(vector<string> ComandoParceado)
{
  ((comunicaciones*)Padre)->onADMIN();
}


//////////// NJ /////////////
void comComandoENTRA::onAccion(vector<string> ComandoParceado)
{
  int InternetID = atoi(ComandoParceado[1].c_str());
  ((comunicaciones*)Padre)->onENTRA(InternetID);
}

//////////// LI /////////////
void comComandoLISTANICKS::onAccion(vector<string> ComandoParceado)
{
  int InternetID = atoi(ComandoParceado[1].c_str());
  string strNick = ComandoParceado[2];
  string strSrmy = ComandoParceado[3];
  ((comunicaciones*)Padre)->onLISTANICKS(InternetID, strNick, strSrmy);
}

//////////// AR /////////////
void comComandoSETARMY::onAccion(vector<string> ComandoParceado)
{
  int InternetID = atoi(ComandoParceado[1].c_str());
  ((comunicaciones*)Padre)->onSETARMY(InternetID, ComandoParceado[2]);
}

//////////// NI /////////////
void comComandoNICK::onAccion(vector<string> ComandoParceado)
{
  int InternetNICK = atoi(ComandoParceado[1].c_str());
  ((comunicaciones*)Padre)->onNICK(InternetNICK, ComandoParceado[2]);
}

/*
//////////// RD /////////////
void comComandoRD::onAccion(vector<string> ComandoParceado)
{
  ((comunicaciones*)Padre)->onRD();
}
*/

//////////// CL /////////////
void comComandoCLIMA::onAccion(vector<string> ComandoParceado)
{
  int Duracion = atoi(ComandoParceado[2].c_str());
  ((comunicaciones*)Padre)->onCLIMA(ComandoParceado[1], Duracion);
}

//////////// ST /////////////
void comComandoINICIA::onAccion(vector<string> ComandoParceado)
{
  ((comunicaciones*)Padre)->onINICIA();
}

//////////// AE /////////////
void comComandoAGREGAEDIFICIO::onAccion(vector<string> ComandoParceado)
{
  int InternetID = atoi(ComandoParceado[1].c_str());
  int tipo = atoi(ComandoParceado[2].c_str());
  float x = atoi(ComandoParceado[3].c_str()) / 1000.0;
  float y = atoi(ComandoParceado[4].c_str()) / 1000.0;
  int ID = atoi(ComandoParceado[5].c_str());
  ((comunicaciones*)Padre)->onAGREGAEDIFICIO(InternetID, tipo, x, y, ID);
}

//////////// AD /////////////
void comComandoAGREGASOLDADO::onAccion(vector<string> ComandoParceado)
{
  int InternetID = atoi(ComandoParceado[1].c_str());
  int tipo = atoi(ComandoParceado[2].c_str());
  float x = atoi(ComandoParceado[3].c_str()) / 1000.0;
  float y = atoi(ComandoParceado[4].c_str()) / 1000.0;
  int ID = atoi(ComandoParceado[5].c_str());
  ((comunicaciones*)Padre)->onAGREGASOLDADO(InternetID, tipo, x, y, ID);
}

//////////// RE /////////////
void comComandoRECURSOS::onAccion(vector<string> ComandoParceado)
{
  float x = atoi(ComandoParceado[1].c_str()) / 1000.0;
  float y = atoi(ComandoParceado[2].c_str()) / 1000.0;
  ((comunicaciones*)Padre)->onRECURSOS(x, y);
}


//////////// MD /////////////
void comComandoMOD::onAccion(vector<string> ComandoParceado)
{
  int MiInternetID = atoi(ComandoParceado[1].c_str());
  int Modo = atoi(ComandoParceado[2].c_str());
  int MiBichoID = atoi(ComandoParceado[3].c_str());
  float x = atoi(ComandoParceado[4].c_str())/ 1000.0;
  float y = atoi(ComandoParceado[5].c_str())/ 1000.0;
  float xRedundante = atoi(ComandoParceado[8].c_str())/ 1000.0; 
  float yRedundante = atoi(ComandoParceado[9].c_str())/ 1000.0;


  int EnemigoID;
  int EnemigoInternetID;

  if(ComandoParceado[6] == "N") EnemigoID = -1;
  else EnemigoID = atoi(ComandoParceado[6].c_str()); 

  if(ComandoParceado[7] == "N") EnemigoInternetID = -1;
  else EnemigoInternetID = atoi(ComandoParceado[7].c_str());


  ((comunicaciones*)Padre)->onMOD(MiInternetID, Modo, MiBichoID, x, y, 
				  xRedundante, yRedundante, EnemigoID, EnemigoInternetID);
}

//////////// SA /////////////
void comComandoSALIDA::onAccion(vector<string> ComandoParceado)
{
  int InternetID = atoi(ComandoParceado[2].c_str());
  ((comunicaciones*)Padre)->onSALIDA(InternetID);
}
