//***************************************************************
//*  [[ A D V E R T E N C I A ]] =[ http://Solar-OpenSource.Org ]=
//*
//*  LICENCIA PARA LA DISTRIBUCIÓN DE WAR 3D
//*  1.- WAR 3D es un programa que podrá ser distribuido bajo los términos de la Licencia Pública General, además deberán cumplirse las siguientes condiciones.
//*  2.- Al copiar cualquier parte del código para ponerlo en un programa diferente a WAR 3D, el autor de dicho programa estará de acuerdo en que el código completo de su programa pasa a ser software libre, por lo deberá estar apegado a los términos establecidos por la licencia LGP. Es decir que, el código de WAR 3D solo puede ser tomado si se va a usar en otro proyecto de software libre. De lo contrario absténgase de usar el código o parte de el código de WAR3D.
//*  3.- Queda estrictamente prohibido modificar los nombres que aparecen en los créditos del programa, solo el grupo de desarrollo de  Solar-OpenSource podrá añadir nuevos nombres en los créditos. Si ha hecho alguna modificación y quiere que su nombre aparezca en los créditos debe ponerse en contacto con nosotros.
//*  4.- Cualquier modificación del código debe apegarse en lo posible a las normas que ha establecido el grupo de desarrollo de Solar-OpenSource, esto es para mayor claridad en el código. Dichas normas pueden encontrarse en nuestra pagina web http://www.solar-opensource.org
//*  5.- Puede copiar y distribuir el programa siempre y cuando no olvide: Acompañarlo con el código fuente completo correspondiente, legible para la máquina, así como el código escrito por usted o las modificaciones hechas al código original.
//*  6.- No debe distribuirse el ejecutable sin el código fuente.
//*  7.- Este texto no debe suprimirse. Las distribuciones deben acompañarse con la información que se recibió así como el ofrecimiento para distribuir el código fuente correspondiente.
//*
//***************************************************************

// Propiedad intelentual de Solar OpenSource y sus miembros
// www.solar-opensource.org

#include "comunicaciones.h"

#include "pantallaInicio.h"
#include "pantallaClienteP2P.h"


// ----------------------------------
bool SocketDataArrivalCliente (string Cadena) { return (comunicaciones::RefMe->ConexionRecive(Cadena)); }
// ----------------------------------
void SocketConectadoCliente () { comunicaciones::RefMe->ConexionConectado(); }
// ----------------------------------
void SocketNoConectadoCliente (int iErr) { comunicaciones::RefMe->ConexionNoConectado(iErr); }


// ------------------------------
void comunicaciones::ConexionConectado()
{
  cout << "Conectado !!" << endl;
  pantallaInicio::ME()->AddText("Conectado !!");
}

// ------------------------------
void comunicaciones::ConexionNoConectado(int iErr)
{
  static int Intentos = 0;
  if (Intentos < 3)
    {
      pantallaInicio::ME()->AddText("Conexion rechazada.");
      pantallaInicio::ME()->AddText(string("Intentando de nuevo con ") + pantallaClienteP2P::ME()->Texto + "..."); 
      zSleep(5000);
      Intentos++;
      Conectar(pantallaClienteP2P::ME()->Texto);
    }
  else
    {
      char str[20];
      sprintf(str,"%i", Puerto);

      pantallaInicio::ME()->AddText("ERROR. Posiblemente el creador de la partida esta detras de un Firewall o red NAT. El creador de la partida debera abrir o redireccionar el puerto " + string(str) + " usado por War3D");
      Intentos = 0;
    }
}

//////////////////////////////
bool comunicaciones::ConexionRecive(string Cadena)
{
  bool Itera = false;
  
  // comunicaciones::Ocupado.Lock();

  //if (Cadena == "") return true;

  static string Comandos;

  // Concatenamos
  Comandos = Comandos + Cadena;

  int fin;
  string CadenaCompleta;

  // Buscamos en return
  fin = Comandos.find("\r\n");

  // Si no lo encontramos no hacemos nada, en espera de que lleguen mas datos.
  if (fin == (int)string::npos) return true;

  // Si encontramos un Fin de linea o return, cortamos hasta encontrar el return
  CadenaCompleta = Comandos.substr(0, fin+2);
  // Y el resto lo dejamos para la siguente.

  Comandos = Comandos.substr(fin+2, 999);

  cout << "Comando: " << CadenaCompleta  << endl;

  Ocupado.Lock();     
  BufferDeComandos.push_back(CadenaCompleta);
  Ocupado.UnLock();

  fin = Comandos.find("\r\n");
  Itera = fin != (int)string::npos;

  // comunicaciones::Ocupado.UnLock();

  if (Itera) ConexionRecive("");

  return true;
}

//////////////////////////////////
void comunicaciones::getEventos()
{

  Ocupado.Lock();

  vector<string>::iterator Com;
  vector<comComandoBASE*>::iterator Ite;
  for (Com = BufferDeComandos.begin(); Com != BufferDeComandos.end() ; Com++)
    {
      for (Ite = comComandos.begin(); Ite != comComandos.end(); Ite++)
	{
	  (*Ite)->Accion(*Com);
	}
    }
  BufferDeComandos.clear();
  Ocupado.UnLock();
}


//////////////////////////////////
//////  VARIABLES ESTATICAS //////
//////////////////////////////////

comunicaciones *comunicaciones::RefMe = NULL;

///////////////////////
//////  METODOS  //////
///////////////////////

comunicaciones::comunicaciones()
{

  RefMe = this;
  
  char TMP[256]; sprintf(TMP, "BufferDeComandos[%d]", (int)this);
  Ocupado.Create(TMP);


  //Le decimod a que funcion hay que llamar cuando ocurra el evento Recibe
  ServidorSocket.setOnDataArrival(SocketDataArrivalCliente);
  // Le decimod a que funcion hay que llamar cuando ocurra el evento Connect
  ServidorSocket.setOnConnect(SocketConectadoCliente);

  ServidorSocket.setOnError(SocketNoConectadoCliente);

  // Agregamos los comandos.
  comComandos.push_back(new comComandoPOSINI((void*)this));
  comComandos.push_back(new comComandoCHAT((void*)this));
  comComandos.push_back(new comComandoADMIN((void*)this));
  comComandos.push_back(new comComandoENTRA((void*)this));
  comComandos.push_back(new comComandoLISTANICKS((void*)this));
  comComandos.push_back(new comComandoSETARMY((void*)this));
  comComandos.push_back(new comComandoNICK((void*)this));
  //  comComandos.push_back(new comComandoRD((void*)this)); // DEPRECATED ZG
  comComandos.push_back(new comComandoCLIMA((void*)this));
  comComandos.push_back(new comComandoINICIA((void*)this));
  comComandos.push_back(new comComandoAGREGAEDIFICIO((void*)this));
  comComandos.push_back(new comComandoAGREGASOLDADO((void*)this));
  comComandos.push_back(new comComandoRECURSOS((void*)this));
  comComandos.push_back(new comComandoMOD((void*)this));
  comComandos.push_back(new comComandoSALIDA((void*)this));

}


//////// CONECTAR ///////////
void comunicaciones::Conectar(string Server)
{
  strServer = Server;
  ServidorSocket.Connect(strServer, Puerto);  
}


//////////////////////////////
///////// ACCIONES ///////////
//////////////////////////////

// --------------------
void comunicaciones::sendLISTO(bool Value)
{
  if (Value)
    ServidorSocket.Send("LISTO TRUE\r\n");
  else
    ServidorSocket.Send("LISTO FALSE\r\n");
}

// --------------------
void comunicaciones::sendMOD(int Modo, int MiBichoID, float x, float y,
			    float xRedundante, float yRedundante,
			    int EnemigoID, int EnemigoInternetID)
{
  ServidorSocket.Send(string("MOD 0") + zitoa(Modo) + " "
		      + zitoa(MiBichoID%1000) + " "
		      + zitoa((int)(x*1000.0)) + " "
		      + zitoa((int)(y*1000.0)) + " " 
		      + zitoa(EnemigoID%1000) + " " 
		      + zitoa(EnemigoInternetID%1000) + " "
		      + zitoa((int)(xRedundante*1000.0)) + " "
		      + zitoa((int)(yRedundante*1000.0)) + "\r\n");
}

// --------------------
void comunicaciones::sendCHAT(string Mensaje)
{
  ServidorSocket.Send(string("CHAT ") + Mensaje + "\r\n");
}

// --------------------
void comunicaciones::sendINICIA()
{
  ServidorSocket.Send("INICIA\r\n");
}

// --------------------
void comunicaciones::sendSETARMY(string strArmy)
{
  ServidorSocket.Send(string("SETARMY ") + strArmy + "\r\n");
}

// --------------------
void comunicaciones::sendAGREGASOLDADO(int tipo, float x, float y, int ID)
{
  char strT[20], strX[20], strY[20], strBichoID[20];
  
  sprintf(strT,"%i",tipo);
  sprintf(strX,"%i",(int)(1000 * x));
  sprintf(strY,"%i",(int)(1000 * y));
  sprintf(strBichoID, "%i", (int)(ID % 1000));
  ServidorSocket.Send(string("AGREGASOLDADO ") + strT + " " +  strX + " " + strY + " " + strBichoID + "\r\n");
}

// --------------------
void comunicaciones::sendAGREGAEDIFICIO(int tipo, float x, float y, int ID)
{
  char strX[20], strY[20], strBichoID[20], strT[20];
  
  sprintf(strT,"%i",tipo);
  sprintf(strX,"%i",(int)(1000 * x));
  sprintf(strY,"%i",(int)(1000 * y));
  sprintf(strBichoID, "%i", (int)(ID % 1000));
  ServidorSocket.Send(string("AGREGAEDIFICIO ") + strT + " " +  strX + " " + strY + " " + strBichoID + "\r\n");
}

// --------------------
void comunicaciones::sendNICK(string Nick)
{
  ServidorSocket.Send(string("NICK ") + Nick + "\r\n");
}
