//***************************************************************
//*  [[ A D V E R T E N C I A ]] =[ http://Solar-OpenSource.Org ]=
//*
//*  LICENCIA PARA LA DISTRIBUCIÓN DE WAR 3D
//*  1.- WAR 3D es un programa que podrá ser distribuido bajo los términos de la Licencia Pública General, además deberán cumplirse las siguientes condiciones.
//*  2.- Al copiar cualquier parte del código para ponerlo en un programa diferente a WAR 3D, el autor de dicho programa estará de acuerdo en que el código completo de su programa pasa a ser software libre, por lo deberá estar apegado a los términos establecidos por la licencia LGP. Es decir que, el código de WAR 3D solo puede ser tomado si se va a usar en otro proyecto de software libre. De lo contrario absténgase de usar el código o parte de el código de WAR3D.
//*  3.- Queda estrictamente prohibido modificar los nombres que aparecen en los créditos del programa, solo el grupo de desarrollo de  Solar-OpenSource podrá añadir nuevos nombres en los créditos. Si ha hecho alguna modificación y quiere que su nombre aparezca en los créditos debe ponerse en contacto con nosotros.
//*  4.- Cualquier modificación del código debe apegarse en lo posible a las normas que ha establecido el grupo de desarrollo de Solar-OpenSource, esto es para mayor claridad en el código. Dichas normas pueden encontrarse en nuestra pagina web http://www.solar-opensource.org
//*  5.- Puede copiar y distribuir el programa siempre y cuando no olvide: Acompañarlo con el código fuente completo correspondiente, legible para la máquina, así como el código escrito por usted o las modificaciones hechas al código original.
//*  6.- No debe distribuirse el ejecutable sin el código fuente.
//*  7.- Este texto no debe suprimirse. Las distribuciones deben acompañarse con la información que se recibió así como el ofrecimiento para distribuir el código fuente correspondiente.
//*
//***************************************************************

#ifndef __comunicaciones_h__
#define __comunicaciones_h__

#include <iostream>
#include <string>
#include <vector>

using namespace std;

#include "singleton.h"

#include "constantes.h"

#include "zeru_mat.h"

#include "comandos.h"

#ifndef SolarSocketsDebug
#include <SolarSockets/SolarSockets.h> // Libreria http://solar-opensource.org
#else
#include "../SolarSockets/include/SolarSockets.h" // Libreria http://solar-opensource.org
#endif

#define Puerto 6300

class comunicaciones/*: public singleton<comunicaciones>*/
{
  
 public:
  
  static comunicaciones * RefMe;

 protected:
  comunicaciones();
 public:
 
 private:
  ssClient ServidorSocket;

  // Inicializa
 public:
  virtual ~comunicaciones(){};
  void Conectar(string Server);
  void DesConectar() {ServidorSocket.Close(); cout << "TODO!! comunicaciones.cpp DesConectar" << endl;};
  void getEventos();

 private:
  vector<string> BufferDeComandos;

  // Eventos de Socket
 public:
  bool ConexionRecive(string Mensaje);
  void ConexionNoConectado(int iErr);
  void ConexionConectado();

  vector<comComandoBASE*> comComandos;

  //Variables
 private:
  string strServer; 
  ssMutex Ocupado;

  //// EVENTOS ////
 public:
  virtual void onPOSINI(int InternetID, float x, float y) = 0;   //onPI
  virtual void onCHAT(int InternetID, string strMensaje) = 0;    //onCH
  virtual void onADMIN( ) = 0;                                   //onRO  
  virtual void onENTRA(int InternetID) = 0;                      //onNJ
  virtual void onLISTANICKS(int InternetID, string strNick, string strArmy) = 0;  //onLI
  virtual void onSETARMY(int InternetID, string strArmy) = 0;    //onAR
  virtual void onNICK(int InternetID, string strNick) = 0;       //onNI
  // virtual void onRD( ) = 0; DEPRECATED ZG
  virtual void onCLIMA(string Condicion, int Duracion) = 0;      //onCL
  virtual void onINICIA( ) = 0;                                  //onST
  virtual void onAGREGAEDIFICIO(int InternetID, int tipo, float x, float y, int ID) = 0; //onAE
  virtual void onAGREGASOLDADO(int InternetID, int tipo, float x, float y, int ID) = 0;  //onAD
  virtual void onRECURSOS(float x, float y) = 0;                                         //onRE
  virtual void onMOD(int MiInternetID, int Modo, int MiBichoID, 
		    float x, float y, float xRedundante, float yRedundante,
		    int EnemigoID, int EnemigoInternetID) = 0;                           //onMD
  virtual void onSALIDA(int InternetID) = 0;                     //onSA
  
  //// ACCIONES ////
  
  void sendLISTO(bool Value);                                    //sendRD
  void sendMOD(int Modo, int MiBichoID, float x, float y,        //sendMD
	      float xRedundante, float yRedundante,
	      int EnemigoID, int EnemigoInternetID);
  void sendCHAT(string Mensaje);                                 //sendCH
  void sendINICIA();                                             //sendST
  void sendSETARMY(string strArmy);                              //sendAR
  void sendAGREGASOLDADO(int tipo, float x, float y, int ID);    //sendAD
  void sendAGREGAEDIFICIO(int tipo, float x, float y, int ID);   //sendAE
  void sendNICK(string Nick);                                    //sendNI
  
};


#endif
