//***************************************************************
//*  [[ A D V E R T E N C I A ]] =[ http://Solar-OpenSource.Org ]=
//*
//*  LICENCIA PARA LA DISTRIBUCIN DE WAR 3D
//*  1.- WAR 3D es un programa que podr ser distribuido bajo los trminos de la Licencia Pblica General, adems debern cumplirse las siguientes condiciones.
//*  2.- Al copiar cualquier parte del cdigo para ponerlo en un programa diferente a WAR 3D, el autor de dicho programa estar de acuerdo en que el cdigo completo de su programa pasa a ser software libre, por lo deber estar apegado a los trminos establecidos por la licencia LGP. Es decir que, el cdigo de WAR 3D solo puede ser tomado si se va a usar en otro proyecto de software libre. De lo contrario abstngase de usar el cdigo o parte de el cdigo de WAR3D.
//*  3.- Queda estrictamente prohibido modificar los nombres que aparecen en los crditos del programa, solo el grupo de desarrollo de  Solar-OpenSource podr aadir nuevos nombres en los crditos. Si ha hecho alguna modificacin y quiere que su nombre aparezca en los crditos debe ponerse en contacto con nosotros.
//*  4.- Cualquier modificacin del cdigo debe apegarse en lo posible a las normas que ha establecido el grupo de desarrollo de Solar-OpenSource, esto es para mayor claridad en el cdigo. Dichas normas pueden encontrarse en nuestra pagina web http://www.solar-opensource.org
//*  5.- Puede copiar y distribuir el programa siempre y cuando no olvide: Acompaarlo con el cdigo fuente completo correspondiente, legible para la mquina, as como el cdigo escrito por usted o las modificaciones hechas al cdigo original.
//*  6.- No debe distribuirse el ejecutable sin el cdigo fuente.
//*  7.- Este texto no debe suprimirse. Las distribuciones deben acompaarse con la informacin que se recibi as como el ofrecimiento para distribuir el cdigo fuente correspondiente.
//*
//***************************************************************

// La clase efectos, contiene unas serie de efectillo visuales medio warros.


#include "efectos.h"


/* --------------------- */
/* ESPIRAL DE PARTICULAS */
/* --------------------- */


// --------------------------------------------
FX_EspiralDeParticulas::FX_EspiralDeParticulas(int noParticulas)
{
  this->noParticulas = noParticulas;
  Particulas = new z3DVector[noParticulas];


  for (int i=0 ; i<noParticulas ; i++)
    {
      Particulas[i].x = rand() % 360; // ang
      Particulas[i].y = (rand()%10) *  0.005; // dist
      Particulas[i].z = 0.02 + (rand()%50)*0.002; // alt
    }
}

// --------------------------------------------
FX_EspiralDeParticulas::~FX_EspiralDeParticulas ()
{
  delete (Particulas);
}


// --------------------------------------------
void FX_EspiralDeParticulas::Dibujame(float x , float y, float z, float radio)
{

  int angulo=(glutGet(GLUT_ELAPSED_TIME)/10) % 360;

  glPushMatrix();
  glDisable(GL_LIGHTING);
  glDisable(GL_TEXTURE_2D);
  
  glPointSize( 3.0 );
  glBegin(GL_POINTS);


  
  for (int i=0 ; i<noParticulas ; i++)
    {

      float ang = Particulas[i].x;
      float dis = Particulas[i].y;
      float alt = Particulas[i].z;

      glVertex3f(x + ((radio+dis)*zcos(angulo+ang)), y + alt, z + ((radio+dis)*zsin(angulo+ang)));

    }

  glEnd();
  glPopMatrix();
}



/* --------------------- */
/*       SELECCION       */
/* --------------------- */


// --------------------------------------------
FX_Seleccion::FX_Seleccion()
{
  
}

// --------------------------------------------
FX_Seleccion::~FX_Seleccion ()
{
  
}


// --------------------------------------------
void FX_Seleccion::Dibujame(float x , float y, float z, float radio)
{

  float delta = 0.01 + radio*0.3;
  y = y + 0.03 + 0.02*(0.5 + zsin(360*(glutGet(GLUT_ELAPSED_TIME)%2000)/2000.0));

  glPushMatrix();
  glDisable(GL_LIGHTING);
  glDisable(GL_TEXTURE_2D);
  
  glLineWidth(1.5); 

  glBegin(GL_LINES);


  glVertex3f(x+radio,y,z+radio);
  glVertex3f(x+radio-delta,y,z+radio);
  glVertex3f(x+radio,y,z+radio);
  glVertex3f(x+radio,y,z+radio-delta);


  glVertex3f(x+radio,y,z-radio);
  glVertex3f(x+radio-delta,y,z-radio);
  glVertex3f(x+radio,y,z-radio);
  glVertex3f(x+radio,y,z-radio+delta);


  glVertex3f(x-radio,y,z-radio);
  glVertex3f(x-radio+delta,y,z-radio);
  glVertex3f(x-radio,y,z-radio);
  glVertex3f(x-radio,y,z-radio+delta);


  glVertex3f(x-radio,y,z+radio);
  glVertex3f(x-radio+delta,y,z+radio);
  glVertex3f(x-radio,y,z+radio);
  glVertex3f(x-radio,y,z+radio-delta);


  glEnd();
  glPopMatrix();
}


//-------------------------------------------------------------
FX_BarraEnergia::FX_BarraEnergia()
{
  
}

// --------------------------------------------
FX_BarraEnergia::~FX_BarraEnergia ()
{
  
}


// --------------------------------------------
void FX_BarraEnergia::Dibujame(float x , float y, float z,float porciento, float total , float Angulo)
{

  // Rotamo la barra Angulo grados para que siempre quede de frente a la camara.
  
  glPushMatrix();


  
  glTranslatef(x, y, z);


  glRotatef(Angulo, 0.0, 1.0, 0.0);

  glDisable(GL_LIGHTING);
  glDisable(GL_TEXTURE_2D);
  
  //glPointSize( 3.0 );

  if (porciento > (total*0.3))
    {
      glColor4f(1.0, 1.0, 0.0, 0.6);
    }
  else
    {
      glColor4f(1.0, 0.3, 0.0, 0.9);
    }

  glLineWidth(2.0); 

  glBegin(GL_LINE_LOOP);
  {
  glVertex3f(-(porciento/3000),0.15,0);
  glVertex3f(-(porciento/3000),0.18,0);
  glVertex3f((porciento/3000),0.18,0);
  glVertex3f((porciento/3000),0.15,0);
  }
  glEnd();

  glColor4f(0.0,0.0,0.0,0.6);

  glLineWidth(1.5); 
  glBegin(GL_LINE_LOOP);
  {
  glVertex3f(-0.004-(total/3000),0.145,0);
  glVertex3f(-0.004-(total/3000),0.185,0);
  glVertex3f(0.004+(total/3000),0.185,0);
  glVertex3f(0.004+(total/3000),0.145,0);
  }
  glEnd();

  glPopMatrix();
}





//-------------------------------------------------------------
FX_ClicEnTerreno::FX_ClicEnTerreno(int noParticulas)
{
  this->noParticulas = noParticulas;
  Particulas = new z3DVector[noParticulas];


  for (int i=0 ; i<noParticulas ; i++)
    {
      Particulas[i].x = rand() % 360; // ang
      Particulas[i].y = (rand()%10) *  0.005; // dist
      Particulas[i].z = 0.02 + (rand()%50)*0.002; // alt
    }  

  x = 0; 
  z = 0;

  vida = 0;
  radio = 0.01;

}

// --------------------------------------------
FX_ClicEnTerreno::~FX_ClicEnTerreno()
{
  
}

// --------------------------------------------
void FX_ClicEnTerreno::SetPosicion(float x , float y)
{
  this->x = x;
  this->z = y;  // En cordenadas realies es Z

  tiempoAnterior = glutGet(GLUT_ELAPSED_TIME);
  vida = 3000;
  radio = 0.01;

}

// --------------------------------------------
z2DVector FX_ClicEnTerreno::getPosicion()
{
  z2DVector Pos;
  Pos.x = x;
  Pos.y = z;
  return Pos;

}

// --------------------------------------------
void FX_ClicEnTerreno::Dibujame(float y)
{


  if (vida > 0)
    {

      int GluTiempo = glutGet(GLUT_ELAPSED_TIME);   

      int angulo=(GluTiempo/3) % 360;
      
      vida = vida - (GluTiempo - tiempoAnterior);
      tiempoAnterior = GluTiempo;

      glPushMatrix();
      glDisable(GL_LIGHTING);
      glDisable(GL_TEXTURE_2D);
      glColor4f(vida/3000.0, vida/3000.0, 1.0, vida/3000.0);
      radio = 0.01 + (0.1-vida/20000.0);
      
      
	  glPointSize( 4.0 );


      glBegin(GL_POINTS);
      
      
      
      for (int i=0 ; i<noParticulas ; i++)
	{
	  
	  float ang = Particulas[i].x;
	  float dis = Particulas[i].y;
	  float alt = Particulas[i].z;
	  
	  glVertex3f(x + ((radio+dis)*zcos(angulo+ang)), y + alt, z + ((radio+dis)*zsin(angulo+ang)));
	  
	}
      
      glEnd();
      glPopMatrix(); 
    }
}





// ------------------------------------------------
//-------------------------------------------------


FX_ClicEnEnemigo::FX_ClicEnEnemigo(int noParticulas)
{
  this->noParticulas = noParticulas;
  Particulas = new z3DVector[4];


  Particulas[0].x = 0;
  Particulas[0].z = 0.0;
  Particulas[0].y = 0;

  Particulas[1].x = 180;
  Particulas[1].z = 0.0;
  Particulas[1].y = 0;
 

  x = 0; 
  z = 0;
  
  vida = 0;
  radio = 0.01;

}

// --------------------------------------------
FX_ClicEnEnemigo::~FX_ClicEnEnemigo()
{
  
}

// --------------------------------------------
void FX_ClicEnEnemigo::SetPosicion(float x , float y)
{
  this->x = x;
  this->z = y;  // En cordenadas realies es Z

  tiempoAnterior = glutGet(GLUT_ELAPSED_TIME);
  vida = 3000;
  radio = 0.02;

}

// --------------------------------------------
z2DVector FX_ClicEnEnemigo::getPosicion()
{
  z2DVector Pos;
  Pos.x = x;
  Pos.y = z;
  return Pos;

}

// --------------------------------------------
void FX_ClicEnEnemigo::Dibujame(float y)
{


  if (vida > 0)
    {

      int GluTiempo = glutGet(GLUT_ELAPSED_TIME);   

      int angulo=(GluTiempo/5) % 360;
      
      vida = vida - (GluTiempo - tiempoAnterior);
      tiempoAnterior = GluTiempo;

      glPushMatrix();
      glDisable(GL_LIGHTING);
      glDisable(GL_TEXTURE_2D);
     
      //radio = 0.02 + (0.1-vida/20000.0);
      
      glPointSize( 2.5 );

      glLineWidth(4.0); 

      glBegin(GL_LINES);
      
      float ang;
      float dis;
      float alt;
      
      for (int i=0 ; i<2 ; i++)
	{

	  if(i>0)
	  {
		glColor4f(1.0, 1.0, 0.2, vida/3000.0);
	  }
	  else
	  {
	  	glColor4f(0.2, 0.2, 1.0, vida/3000.0);
	  }
  
	  ang = Particulas[i].x;
	  dis = Particulas[i].y;
	  alt = Particulas[i].z;
	  
	  glVertex3f(x + ((radio+dis)*zcos(angulo+ang)), y + 0.1 + alt, z + ((radio+dis)*zsin(angulo+ang)));

	  glColor4f(1.0, 1.0, 0.0, 0.0);

	  glVertex3f(x + ((radio+dis)*zcos(angulo+ang)), y + 0.8    + alt, z + ((radio+dis)*zsin(angulo+ang)));
	  
	}
      
      glEnd();
      glPopMatrix();
    }
}

