//***************************************************************
//*  [[ A D V E R T E N C I A ]] =[ http://Solar-OpenSource.Org ]=
//*
//*  LICENCIA PARA LA DISTRIBUCIN DE WAR 3D
//*  1.- WAR 3D es un programa que podr ser distribuido bajo los trminos de la Licencia Pblica General, adems debern cumplirse las siguientes condiciones.
//*  2.- Al copiar cualquier parte del cdigo para ponerlo en un programa diferente a WAR 3D, el autor de dicho programa estar de acuerdo en que el cdigo completo de su programa pasa a ser software libre, por lo deber estar apegado a los trminos establecidos por la licencia LGP. Es decir que, el cdigo de WAR 3D solo puede ser tomado si se va a usar en otro proyecto de software libre. De lo contrario abstngase de usar el cdigo o parte de el cdigo de WAR3D.
//*  3.- Queda estrictamente prohibido modificar los nombres que aparecen en los crditos del programa, solo el grupo de desarrollo de  Solar-OpenSource podr aadir nuevos nombres en los crditos. Si ha hecho alguna modificacin y quiere que su nombre aparezca en los crditos debe ponerse en contacto con nosotros.
//*  4.- Cualquier modificacin del cdigo debe apegarse en lo posible a las normas que ha establecido el grupo de desarrollo de Solar-OpenSource, esto es para mayor claridad en el cdigo. Dichas normas pueden encontrarse en nuestra pagina web http://www.solar-opensource.org
//*  5.- Puede copiar y distribuir el programa siempre y cuando no olvide: Acompaarlo con el cdigo fuente completo correspondiente, legible para la mquina, as como el cdigo escrito por usted o las modificaciones hechas al cdigo original.
//*  6.- No debe distribuirse el ejecutable sin el cdigo fuente.
//*  7.- Este texto no debe suprimirse. Las distribuciones deben acompaarse con la informacin que se recibi as como el ofrecimiento para distribuir el cdigo fuente correspondiente.
//*
//***************************************************************

#ifndef __ejercito_h__
#define __ejercito_h__


#include <iostream>
#include <string>
#include <vector>

using namespace std;

#include "constantes.h"

#include <math.h>

#include "zeru_mat.h"
#include "oSoldado.h"
#include "oSoldadoConstructor.h"

#include "oEdificio.h"

#include "modelosMS3D.h"
#include "army.h"
#include "SoundServer.h"


#ifndef SolarSocketsDebug
#include <SolarSockets/SolarSockets.h> // Libreria http://solar-opensource.org
#else
#include "../SolarSockets/include/SolarSockets.h" // Libreria http://solar-opensource.org
#endif

#include "oConstruye.h"
#include "Recursos.h"

class Ejercito;

class Ejercito
{

  private:

  z2DVector BaseLocalizacion;

  static int NumeroDeEjercito;

  bool Miejercito;

  int color;

  Army *MiArmy;

  vector<oSoldado*> Soldados;
  vector<oEdificio*> Edificios;

  oConstruye *Contruccion;
  
  float Retardo;
  int localBichoID; // ID asignado localmente
  int localEdificioID; // ID asignado localmente
  int internetID; // ID asignado para juegos multiplayer.

  int delSoldado (int ID, float x, float y);

  Recurso *MisRecursos;
  unsigned int Poblacion;

  void RecolectaRecursos();
  void RecolectaElectricidad();

  float Clock;
  float Clock2;
  float Clock3;

 public:

  inline Recurso *getRecursos() {return MisRecursos;};
  inline unsigned int getPoblacion() {return Poblacion;};
  string strArmy;
  string strNick;

  inline Army* getArmy() {return MiArmy;};

  void BibujaBandera(float x, float y, float z);

  static vector<Ejercito> TodosLosEjercitos;
  static oSoldado* getBichoReferencia (int ID);
  static oEdificio* getEdificioReferencia (int ID);

  static oSoldado* BichoSeleccionado;
  static oSoldado* BichoEnemigoSeleccionado;
  static oEdificio* EdificioSelecionado;

  void Update ();

  static int MiejercitoInetID;  
  
  void setArmy (string strArmy);
  bool ArmyListo; //

  Ejercito (int internetID, z2DVector BaseLocalizacion);
  ~Ejercito ();
  
  void Inicia ();

  inline void setMiejercito (bool Miejercito) {this->Miejercito = Miejercito;};
  inline bool getMiejercito () {return Miejercito;};

  inline int getinternetID() {return internetID;};
    
  void movilizar ();

  oSoldado *addSoldado (int tipo, float x, float y, int ID);
  oEdificio *addEdificio (int tipo, float x, float y, int ID);


  void setRetardo (float Retardo);
  void MouseInteraccion (float x, float y, int Boton, int estado);


  inline vector<oSoldado*> *getEjercito (){return &Soldados;};
  inline vector<oEdificio*> *getEdificios (){return &Edificios;};
  static oObjetos* GetBichoInet(int InternetID, int ID);
  
  void IADeCombate(vector<Ejercito>::iterator EjercitoEnemigo);

  void Reaccion(oObjetos* BichoMio, oSoldado* BichoEnemigo);
  
  //-------
  void EnemigoCercano (oSoldado* BichoMio, oSoldado* BichoEnemigo);

  int getArmyNumUnidades (){ return MiArmy->getNumUnidades();};
  void EliminaBajas();

  inline void setBaseLocalizacion(float x, float y) {BaseLocalizacion.x = x; BaseLocalizacion.y = y;};
  inline z2DVector getBaseLocalizacion() {return BaseLocalizacion;};

};

#endif










