//***************************************************************
//*  [[ A D V E R T E N C I A ]] =[ http://Solar-OpenSource.Org ]=
//*
//*  LICENCIA PARA LA DISTRIBUCIN DE WAR 3D
//*  1.- WAR 3D es un programa que podr ser distribuido bajo los trminos de la Licencia Pblica General, adems debern cumplirse las siguientes condiciones.
//*  2.- Al copiar cualquier parte del cdigo para ponerlo en un programa diferente a WAR 3D, el autor de dicho programa estar de acuerdo en que el cdigo completo de su programa pasa a ser software libre, por lo deber estar apegado a los trminos establecidos por la licencia LGP. Es decir que, el cdigo de WAR 3D solo puede ser tomado si se va a usar en otro proyecto de software libre. De lo contrario abstngase de usar el cdigo o parte de el cdigo de WAR3D.
//*  3.- Queda estrictamente prohibido modificar los nombres que aparecen en los crditos del programa, solo el grupo de desarrollo de  Solar-OpenSource podr aadir nuevos nombres en los crditos. Si ha hecho alguna modificacin y quiere que su nombre aparezca en los crditos debe ponerse en contacto con nosotros.
//*  4.- Cualquier modificacin del cdigo debe apegarse en lo posible a las normas que ha establecido el grupo de desarrollo de Solar-OpenSource, esto es para mayor claridad en el cdigo. Dichas normas pueden encontrarse en nuestra pagina web http://www.solar-opensource.org
//*  5.- Puede copiar y distribuir el programa siempre y cuando no olvide: Acompaarlo con el cdigo fuente completo correspondiente, legible para la mquina, as como el cdigo escrito por usted o las modificaciones hechas al cdigo original.
//*  6.- No debe distribuirse el ejecutable sin el cdigo fuente.
//*  7.- Este texto no debe suprimirse. Las distribuciones deben acompaarse con la informacin que se recibi as como el ofrecimiento para distribuir el cdigo fuente correspondiente.
//*
//***************************************************************


#include "fogofwar.h"


#include "configuracion.h"

// Volumetric Fog -->
PFNGLFOGCOORDFEXTPROC glFogCoordfEXT=NULL;
PFNGLFOGCOORDFVEXTPROC glFogCoordfvEXT=NULL;
PFNGLFOGCOORDDEXTPROC glFogCoorddEXT=NULL;
PFNGLFOGCOORDDVEXTPROC glFogCoorddvEXT=NULL;
PFNGLFOGCOORDPOINTEREXTPROC glFogCoordPointerEXT=NULL;
// <-- Volumetric Fog


bool FOGOFWAR::SoporteDeExtensiones = true;

FOGOFWAR::FOGOFWAR()
{

}

// ---------------------------
void FOGOFWAR::LoadFogCoordExt(void)
{	

  if (FOGOFWAR::SoporteDeExtensiones)
    {
      

      //cout << "[WARNING][EXTENSIONES] Si War3D se deteine en este punto inesperadamente, edita el archivo \"War3D.conf\", desativa la noebla, \"Niebla: off\"" << endl;

#ifdef _WIN32 // Windows
  
      glFogCoordfEXT=(PFNGLFOGCOORDFEXTPROC)wglGetProcAddress("glFogCoordfEXT");
      glFogCoordfEXT=(PFNGLFOGCOORDFEXTPROC)wglGetProcAddress("glFogCoordfEXT");
      glFogCoordfvEXT=(PFNGLFOGCOORDFVEXTPROC)wglGetProcAddress("glFogCoordfvEXT");
      glFogCoorddEXT=(PFNGLFOGCOORDDEXTPROC)wglGetProcAddress("glFogCoorddEXT");
      glFogCoorddvEXT=(PFNGLFOGCOORDDVEXTPROC)wglGetProcAddress("glFogCoorddvEXT");
      glFogCoordPointerEXT=(PFNGLFOGCOORDPOINTEREXTPROC)wglGetProcAddress("glFogCoordPointerEXT");
      
#else // Linux X-Window
      
      glFogCoordfEXT=(PFNGLFOGCOORDFEXTPROC)glXGetProcAddressARB((const GLubyte*)"glFogCoordfEXT");
      glFogCoordfEXT=(PFNGLFOGCOORDFEXTPROC)glXGetProcAddressARB((const GLubyte*)"glFogCoordfEXT");
      glFogCoordfvEXT=(PFNGLFOGCOORDFVEXTPROC)glXGetProcAddressARB((const GLubyte*)"glFogCoordfvEXT");
      glFogCoorddEXT=(PFNGLFOGCOORDDEXTPROC)glXGetProcAddressARB((const GLubyte*)"glFogCoorddEXT");
      glFogCoorddvEXT=(PFNGLFOGCOORDDVEXTPROC)glXGetProcAddressARB((const GLubyte*)"glFogCoorddvEXT");
      glFogCoordPointerEXT=(PFNGLFOGCOORDPOINTEREXTPROC)glXGetProcAddressARB((const GLubyte*)"glFogCoordPointerEXT");
      
#endif
    }
  else
    {
      cout << "[WARNING][FOGWAR] No hay soporte de extesiones" << endl;
    }
  
}

void FOGOFWAR::Init(int ancho,int alto)
{


  
  cout << endl << "[WARNING][EXTENSIONES] Si War3D se deteine en este punto inesperadamente, edita el archivo \"War3D.conf\", desativa la noebla, \"Niebla: off\"" << endl << endl;
  
  FOGOFWAR::SoporteDeExtensiones =  (FOGOFWAR::SoporteDeExtensiones && configuracion::Niebla);


  // Verificaion del soporte de extensiones.
  if (FOGOFWAR::SoporteDeExtensiones)
  {
	War3DAccion ("EXTENCIONES", "Verificando soporte de extesiones");

	const unsigned char *informacion;

	informacion = glGetString(GL_VENDOR) ;
	printf("        VENDOR : %s\n", informacion) ;
	informacion = glGetString(GL_RENDERER) ;
	printf("        RENDERER : %s\n", informacion) ;
	informacion = glGetString(GL_EXTENSIONS) ;
	printf("        EXTENSIONS : %s\n", informacion) ;
	informacion = glGetString(GL_VERSION) ;
	printf("        VERSION : %s\n\n", informacion) ;

	FOGOFWAR::SoporteDeExtensiones = CheckExtension("GL_EXT_fog_coord");
  }


  this->ancho = ancho;
  this->alto = alto;

  if(ancho*alto%8){	size=(ancho*alto)/8+1;	} 
  else {	size=(ancho*alto)/8;	}

  mapa=new unsigned char[size];	memset(mapa,0,size);
}


void FOGOFWAR::Enable(void)
{

  if (FOGOFWAR::SoporteDeExtensiones)
    {

      float fogColor[4]={0.50f, 0.50f, 0.50f, 1.0f};
      
      glFogi(GL_FOG_MODE,GL_LINEAR);
      glFogfv(GL_FOG_COLOR,fogColor);
      glFogf(GL_FOG_START,0.0);
      glFogf(GL_FOG_END,50.0);
      
      glFogi(GL_FOG_COORDINATE_SOURCE_EXT,GL_FOG_COORDINATE_EXT);
    }

}

void FOGOFWAR::SetPoint(int x,int y,bool value)
{
  if(!mapa){	return;	}
  if(x<0 || x>ancho){	return;	}
  if(y<0 || y>alto) {	return;	}

  unsigned char mask[8]={128,64,32,16,8,4,2,1};

  int b=(y*ancho+x)/8;
  if(value)
    {
      mapa[b] = mapa[b] | mask[(y*ancho+x)%8];
    }
  else 
    {	
      mapa[b] = mapa[b] & mask[(y*ancho+x)%8];
    } 
}

bool FOGOFWAR::GetPoint(int x,int y)
{
  if(!mapa){	return -1;	}
  if(x<0 || x>ancho){	return -1;	}
  if(y<0 || y>alto) {	return -1;	}

  unsigned char mask[8]={128,64,32,16,8,4,2,1};

  int b=(y*ancho+x)/8;
  if(mapa[b] & mask[(y*ancho+x)%8])
    {
      return true;
    }
  else 
    {
      return false;
    }
}


void FOGOFWAR::ilumina (float x, float y, float radio, int angulo)
{
  
  int R  = (int)(Densidad * (radio*0.75));
  int X = (int)(Densidad * x);
  int Y = (int)(Densidad * y);

  char *mask = NULL;

  MascaraCircular (R, mask);


  int i, j;

  for (i=0 ; i <R*2+1 ; i++)
    {
      for (j=0 ; j <R*2+1 ; j++)
	{
	  if (mask[j*(R*2+1)+i] == 1)
	    {
	      SetPoint((X-R)+i, (Y-R)+j, true);
	    }
	}
    }

  //cout << R << endl;

  delete [] mask;

  
}


void FOGOFWAR::MascaraCircular (int radio, char *&Mascara)
{

  Mascara = new char[(radio*2+1)*(radio*2+1)];
  memset(Mascara, 0, (radio*2+1)*(radio*2+1));
   
  int l, m, rl, rm;

  for(l=0;l<radio+1;l++)
    {
      rl=l-radio;
      for(m=0;m<radio+1;m++)
	{
	  rm=m-radio;
	  if((rl*rl+rm*rm) <= (radio*radio))
	    {
	      Mascara[m*(radio*2+1)+l]=
		Mascara[((radio*2)-m)*(radio*2+1)+l]=
		Mascara[((radio*2)-m)*(radio*2+1)+((radio*2)-l)]=
		Mascara[m*(radio*2+1)+((radio*2)-l)]=
		1;
	    }
	}
    }
}

bool FOGOFWAR::getVisible(int x, int y)
{
    if( GetPoint(x-2,y+2) ||
	  GetPoint(x+0,y+2) ||
	  GetPoint(x+2,y+2) ||
	  GetPoint(x-2,y+0) ||
	  GetPoint(x+2,y+0) ||
	  GetPoint(x-2,y-2) ||
	  GetPoint(x+0,y-2) ||
	  GetPoint(x+2,y-2))
	{
	  return true;
	}
    return false;
}

void FOGOFWAR::SetFogCoord(int x,int y)
{

  if(GetPoint(x,y))
    {
      if (FOGOFWAR::SoporteDeExtensiones)
	{
	  glFogCoordfEXT(0.0f);
	}
      else 
	{
	  glColor3f(1.0 , 1.0 , 1.0); 
	}
    } 
  else 
    {

      
      
      if( GetPoint(x-1,y+1) ||
	  GetPoint(x+0,y+1) ||
	  GetPoint(x+1,y+1) ||
	  GetPoint(x-1,y+0) ||
	  GetPoint(x+1,y+0) ||
	  GetPoint(x-1,y-1) ||
	  GetPoint(x+0,y-1) ||
	  GetPoint(x+1,y-1))
	{

	  if (FOGOFWAR::SoporteDeExtensiones)
	    {
	      glFogCoordfEXT(25.0f);
	    }
	  else 
	    {
	      glColor3f(0.5 , 0.5 , 0.5); 
	    };
	  

	} else {
	  if (FOGOFWAR::SoporteDeExtensiones)
	    {
	      glFogCoordfEXT(47.0f);
	    }
	  else 
	    {
	      glColor3f(0.1 , 0.1 , 0.1); 
	    };
	}
      
    }
}

FOGOFWAR::~FOGOFWAR()
{
}

bool CheckExtension( char *extName )
{
        /*
         ** Search for extName in the extensions string.  Use of strstr()
         ** is not sufficient because extension names can be prefixes of
         ** other extension names.  Could use strtok() but the constant
         ** string returned by glGetString can be in read-only memory.
         */
       
		const unsigned char *informacion;

		informacion = glGetString(GL_EXTENSIONS);

		char *p = (char*) informacion;

		if (informacion == NULL)
			return false;

        char *end;
        int extNameLen;
        extNameLen = strlen(extName);
        end = p + strlen(p);

	
    
        while (p < end) {
            int n = strcspn(p, " ");
            if ((extNameLen == n) && (strncmp(extName, p, n) == 0)) {
                return true;
            }
            p += (n + 1);
        }
        return false;
		
	//return true;
}
