//***************************************************************
//*  [[ A D V E R T E N C I A ]] =[ http://Solar-OpenSource.Org ]=
//*
//*  LICENCIA PARA LA DISTRIBUCIN DE WAR 3D
//*  1.- WAR 3D es un programa que podr ser distribuido bajo los trminos de la Licencia Pblica General, adems debern cumplirse las siguientes condiciones.
//*  2.- Al copiar cualquier parte del cdigo para ponerlo en un programa diferente a WAR 3D, el autor de dicho programa estar de acuerdo en que el cdigo completo de su programa pasa a ser software libre, por lo deber estar apegado a los trminos establecidos por la licencia LGP. Es decir que, el cdigo de WAR 3D solo puede ser tomado si se va a usar en otro proyecto de software libre. De lo contrario abstngase de usar el cdigo o parte de el cdigo de WAR3D.
//*  3.- Queda estrictamente prohibido modificar los nombres que aparecen en los crditos del programa, solo el grupo de desarrollo de  Solar-OpenSource podr aadir nuevos nombres en los crditos. Si ha hecho alguna modificacin y quiere que su nombre aparezca en los crditos debe ponerse en contacto con nosotros.
//*  4.- Cualquier modificacin del cdigo debe apegarse en lo posible a las normas que ha establecido el grupo de desarrollo de Solar-OpenSource, esto es para mayor claridad en el cdigo. Dichas normas pueden encontrarse en nuestra pagina web http://www.solar-opensource.org
//*  5.- Puede copiar y distribuir el programa siempre y cuando no olvide: Acompaarlo con el cdigo fuente completo correspondiente, legible para la mquina, as como el cdigo escrito por usted o las modificaciones hechas al cdigo original.
//*  6.- No debe distribuirse el ejecutable sin el cdigo fuente.
//*  7.- Este texto no debe suprimirse. Las distribuciones deben acompaarse con la informacin que se recibi as como el ofrecimiento para distribuir el cdigo fuente correspondiente.
//*
//***************************************************************

#include "minimap.h"


#include "tierra.h"
#include "navegacion.h"
#include "VistasGL.h"
#include "escribe.h"
#include "ejercito.h"



Minimapa::Minimapa()
{

  Zoom = 1.0;

  
  dibujo = new GLubyte [MiniMapaResolucion*MiniMapaResolucion*3];
  mapaescenario = new GLubyte [MiniMapaResolucion*MiniMapaResolucion*3]; 
  
  memset(dibujo, 0, MiniMapaResolucion*MiniMapaResolucion*3); 
  
  glGenTextures(1, &GLTextura);
  glBindTexture(GL_TEXTURE_2D,  GLTextura); 
  glTexImage2D(GL_TEXTURE_2D, 0, GL_RGB, MiniMapaResolucion, MiniMapaResolucion, 0, GL_RGB, GL_UNSIGNED_BYTE, dibujo);
  
  
  glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, /*GL_NEAREST*/ GL_LINEAR);		// La m
  glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, /*GL_NEAREST*/ GL_LINEAR); 
  
  glTexParameterf(GL_TEXTURE_2D,GL_TEXTURE_WRAP_S,GL_REPEAT);
  glTexParameterf(GL_TEXTURE_2D,GL_TEXTURE_WRAP_T,GL_REPEAT);
  
  PutEcenario();

}


void Minimapa::PutFogWar()
{

  int x, y;
  int xx, yy;


  vector<Ejercito>::iterator Ejers;
  Ejers = Ejercito::TodosLosEjercitos.begin();
  
  int Radio1 = (int)((MiniMapaResolucion*0.25)*(MiniMapaResolucion*0.25));
  int Radio2 = (int)(Radio1 * 1.6 * 1.6);

  for(x=0; x<MiniMapaResolucion; x++)
    {
      for (y=0; y<MiniMapaResolucion; y++)
	{
	  if (!Tierra::ME()->fow.GetPoint((x*Tierra::ME()->getAncho() / MiniMapaResolucion),(y*Tierra::ME()->getAlto() / MiniMapaResolucion)))
	    {
	      PutPixel(x, y, 60, 60, 100, dibujo);
	    }


          xx = (x-(int)(((Ejers->getBaseLocalizacion().x*Densidad)/Tierra::ME()->getAncho()) * MiniMapaResolucion))*
	    (x-(int)(((Ejers->getBaseLocalizacion().x*Densidad)/Tierra::ME()->getAncho()) * MiniMapaResolucion));
	  yy = (y-(int)(((Ejers->getBaseLocalizacion().y*Densidad)/Tierra::ME()->getAncho()) * MiniMapaResolucion))*
	    (y-(int)(((Ejers->getBaseLocalizacion().y*Densidad)/Tierra::ME()->getAncho()) * MiniMapaResolucion));
	  

	  if(xx+yy >= Radio1)
	    {
	      if(xx+yy <= Radio2)
		{
		  if (dibujo[(y*MiniMapaResolucion + x)*3+2] + 40 < 255)
		    {
		      dibujo[(y*MiniMapaResolucion + x)*3+2]= dibujo[(y*MiniMapaResolucion + x)*3+2] + 40;
		    }
		  else
		    {
		      dibujo[(y*MiniMapaResolucion + x)*3+2]=255;
		    }
		}
	    }


	}
    }

}



void Minimapa::PutEcenario()
{

  verticeTierra *v=(verticeTierra *)Tierra::ME()->getVertices();
  

  int x, y;

  for(x=0; x<MiniMapaResolucion; x++)
    {
      for (y=0; y<MiniMapaResolucion; y++)
	{
	  if (v[(y*Tierra::ME()->getAlto() / MiniMapaResolucion)*Tierra::ME()->getAncho() + (x*Tierra::ME()->getAncho() / MiniMapaResolucion)].ObjetosMap != NULL)
	    {
	      
	      PutPixel(x, y, 60, 60, 60, mapaescenario);
	      
	    }
	  else
	    {
	      int Gris = 50 + (int)(100 * (v[(y*Tierra::ME()->getAlto() / MiniMapaResolucion)*Tierra::ME()->getAncho() + (x*Tierra::ME()->getAncho() / MiniMapaResolucion)].Altura));
	      PutPixel(x, y, Gris, Gris, Gris, mapaescenario);
	    }  
	  
	}
    }




}


// -----------------------
void Minimapa::PutDios(float x, float y)
{
  Dios.x = x;
  Dios.y = y;
}



void Minimapa::Refresaca()
{
  
  PutEjercitos();
  PutFogWar();
  PutRecursos();

  glBindTexture(GL_TEXTURE_2D,  GLTextura);
  glTexSubImage2D (GL_TEXTURE_2D, 0, 0, 0, MiniMapaResolucion, MiniMapaResolucion, GL_RGB, GL_UNSIGNED_BYTE, dibujo);
  
}


void Minimapa::PutRecursos()
{

  int x, y;
  int xx, yy;

  vector<RecursoCombustible>::iterator Ite;

  for(x=0; x<MiniMapaResolucion; x++)
    { 
      for (y=0; y<MiniMapaResolucion; y++)
	{
	  for(Ite = Recursos::ME()->TodosLosRecursos.begin() ; Ite != Recursos::ME()->TodosLosRecursos.end() ; Ite++)
	    {
	      xx = (int)(((Ite->localizacion.x*Densidad)/Tierra::ME()->getAncho()) * MiniMapaResolucion); 
	      yy = (int)(((Ite->localizacion.y*Densidad)/Tierra::ME()->getAncho()) * MiniMapaResolucion); 
	      PutPixel(xx, yy, 255, 255, 255, dibujo);
	    }
	}
    }
}


// -----------------------
void Minimapa::PutEjercitos()
{
  
  vector<Ejercito>::iterator Ejers;
  vector<oSoldado*> *EjeX;
  vector<oSoldado*>::iterator Bicho;
  vector<oEdificio*> *EdiX;
  vector<oEdificio*>::iterator EdiIte;

  int xx;
  int yy;

  int Color;


  memcpy(dibujo, mapaescenario, MiniMapaResolucion*MiniMapaResolucion*3);

 
  


  for (Ejers=(Ejercito::TodosLosEjercitos.begin()); Ejers != Ejercito::TodosLosEjercitos.end(); Ejers++)
    {
      
  
      if (Ejers->getMiejercito())
	{
	  Color = 150;
	}
      else
	{
	  Color = 200;
	}
      EjeX = Ejers->getEjercito();
      for (Bicho=EjeX->begin(); Bicho != EjeX->end(); Bicho++)
	{

	  xx = (int)((((*Bicho)->getLocalizacion().x*Densidad)/Tierra::ME()->getAncho()) * MiniMapaResolucion); 
	  yy = (int)((((*Bicho)->getLocalizacion().y*Densidad)/Tierra::ME()->getAncho()) * MiniMapaResolucion); 
	  PutPixel(xx, yy, 200, Color, 150, dibujo);
	}

      EdiX = Ejers->getEdificios();
      for (EdiIte=EdiX->begin(); EdiIte != EdiX->end(); EdiIte++)
	{
	  xx = (int)((((*EdiIte)->getLocalizacion().x*Densidad)/Tierra::ME()->getAncho()) * MiniMapaResolucion); 
	  yy = (int)((((*EdiIte)->getLocalizacion().y*Densidad)/Tierra::ME()->getAncho()) * MiniMapaResolucion); 
	  PutPixel(xx, yy, Color, 150, 200, dibujo);
	    

	}
      
    }

}


// -----------------------
void Minimapa::PutPixel(unsigned int x, unsigned int y, GLubyte R, GLubyte G, GLubyte B, GLubyte * Mapa)
{

  if (x<MiniMapaResolucion && y<MiniMapaResolucion)
    {
      Mapa[(y*MiniMapaResolucion + x)*3+0]=R;
      Mapa[(y*MiniMapaResolucion + x)*3+1]=G;
      Mapa[(y*MiniMapaResolucion + x)*3+2]=B;
    }
}


// ---------------------------------
void Minimapa::Dibujame(bool ZoomON, float angulo)
{

  /*
  if (ZoomON)
    {
      if (Zoom < 2.0)
	{
	  Zoom =  Zoom + 0.03;
	}
    }
  else
    {
      if (Zoom > 1.0)
	{
	  Zoom =  Zoom - 0.03;
	}
    }
      
  */
  miVistaGL.setVista(VistaGL_Ortogonal);
  /*
  
  glColor4f(1.0, 1.0, 1.0, 0.0 );
  
  glTranslatef(Zoom*0.1, 0.12+((Zoom-1.0)*0.1), 0);
  glRotatef(angulo, 0.0, 0.0, 1.0);
  
  */

  glPushMatrix();

  
  glBindTexture(GL_TEXTURE_2D,  GLTextura); 
  
  glBegin(GL_QUADS);
  {
    
    glTexCoord2f(0,0);
    glVertex2f(-0.08*Zoom, -0.08*Zoom);

    glTexCoord2f(1,0);
    glVertex2f(0.08*Zoom, -0.08*Zoom);


    glTexCoord2f(1,1);
    glVertex2f(0.08*Zoom, 0.08*Zoom);

    glTexCoord2f(0,1);	
    glVertex2f(-0.08*Zoom, 0.08*Zoom);
    	
  }
  glEnd();
  

  /*

  float xx = Zoom*((((Dios.x*Densidad)/Tierra::ME()->getAncho()) *  0.16) - 0.08);
  float yy = Zoom*((((Dios.y*Densidad)/Tierra::ME()->getAlto()) * 0.16)- 0.08);

  glDisable(GL_TEXTURE_2D);
      
  glColor4f(1.0, 1.0, 1.0, 0.00);
  glBegin(GL_QUADS);
  {
    glVertex2f(Zoom* -0.5/Tierra::ME()->getAncho()+xx, Zoom* -0.5/Tierra::ME()->getAlto()+yy);
    glVertex2f(Zoom*  0.5/Tierra::ME()->getAncho()+xx, Zoom* -0.5/Tierra::ME()->getAlto()+yy);
    glVertex2f(Zoom*  0.5/Tierra::ME()->getAncho()+xx, Zoom*  0.5/Tierra::ME()->getAlto()+yy);
    glVertex2f(Zoom* -0.5/Tierra::ME()->getAncho()+xx, Zoom*  0.5/Tierra::ME()->getAlto()+yy);
  }
  glEnd();

  */

  glPopMatrix();
  
  
}

void Minimapa::CheckClick(float x,float y)
{
  MATRIX4X4 projMat,modelMat,modelMat1;
  
  projMat.SetProperties(2,0,0,0,0,-2,0,0,0,0,1,0,-1,1,0,1);
  
  glTranslatef(Zoom*0.1,0.12+((Zoom-1.0)*0.1),0.0f);
  glRotatef(Navegacion::ME()->getLocalizacion().AngVista,0.0,0.0,1.0);
  glGetFloatv(GL_MODELVIEW_MATRIX,(float*)&modelMat1.m);
  
  float c=(float)cos(Navegacion::ME()->getLocalizacion().AngVista*0.01745328f);
  float s=(float)sin(Navegacion::ME()->getLocalizacion().AngVista*0.01745328f);
  modelMat.m[0][0]=c;		modelMat.m[0][1]=s;		modelMat.m[0][2]=0.0f;	modelMat.m[0][3]=0.0f;
  modelMat.m[1][0]=-s;		modelMat.m[1][1]=c;		modelMat.m[1][2]=0.0f;	modelMat.m[1][3]=0.0f;
  modelMat.m[2][0]=0.0f;	modelMat.m[2][1]=0.0f;	modelMat.m[2][2]=1.0f;	modelMat.m[2][3]=0.0f;
  modelMat.m[3][0]=Zoom*0.1*c+0.12+((Zoom-1.0)*0.1)*-s;
  modelMat.m[3][1]=Zoom*0.1*s+((Zoom-1.0)*0.1)*c;
  modelMat.m[3][2]=0.0f;
  modelMat.m[3][3]=1.0f;
  
  MATRIX4X4 transMat,rotMat,modelMat2;
  transMat.SetProperties(1,0,0,0,0,1,0,0,0,0,1,0,Zoom*0.1,0.12+((Zoom-1.0)*0.1),0.0f,0.0f);
  rotMat.SetProperties(c,s,0,0,-s,c,0,0,0,0,1,0,0,0,0,1);
  modelMat2=transMat*rotMat;
  
  MATRIX4X4 finalMat=modelMat1*projMat;
  POINT3 mmapScreen(x,y,0);
  MATRIX4X4 finalMatInv=finalMat.Inverse();
  POINT3 mmapPoint=finalMatInv.Point(mmapScreen);
  
  /* TODO: Buscar mmapPoint dentro del cuadrado del minimapa */
  
  cout << "MinMapa X: " << x << "  Y: " << y << endl;
}
