//***************************************************************
//*  [[ A D V E R T E N C I A ]] =[ http://Solar-OpenSource.Org ]=
//*
//*  LICENCIA PARA LA DISTRIBUCIN DE WAR 3D
//*  1.- WAR 3D es un programa que podr ser distribuido bajo los trminos de la Licencia Pblica General, adems debern cumplirse las siguientes condiciones.
//*  2.- Al copiar cualquier parte del cdigo para ponerlo en un programa diferente a WAR 3D, el autor de dicho programa estar de acuerdo en que el cdigo completo de su programa pasa a ser software libre, por lo deber estar apegado a los trminos establecidos por la licencia LGP. Es decir que, el cdigo de WAR 3D solo puede ser tomado si se va a usar en otro proyecto de software libre. De lo contrario abstngase de usar el cdigo o parte de el cdigo de WAR3D.
//*  3.- Queda estrictamente prohibido modificar los nombres que aparecen en los crditos del programa, solo el grupo de desarrollo de  Solar-OpenSource podr aadir nuevos nombres en los crditos. Si ha hecho alguna modificacin y quiere que su nombre aparezca en los crditos debe ponerse en contacto con nosotros.
//*  4.- Cualquier modificacin del cdigo debe apegarse en lo posible a las normas que ha establecido el grupo de desarrollo de Solar-OpenSource, esto es para mayor claridad en el cdigo. Dichas normas pueden encontrarse en nuestra pagina web http://www.solar-opensource.org
//*  5.- Puede copiar y distribuir el programa siempre y cuando no olvide: Acompaarlo con el cdigo fuente completo correspondiente, legible para la mquina, as como el cdigo escrito por usted o las modificaciones hechas al cdigo original.
//*  6.- No debe distribuirse el ejecutable sin el cdigo fuente.
//*  7.- Este texto no debe suprimirse. Las distribuciones deben acompaarse con la informacin que se recibi as como el ofrecimiento para distribuir el cdigo fuente correspondiente.
//*
//***************************************************************

#include "navegacion.h"

//--------------------------------------
Navegacion::Navegacion ()
{

  Localizacion.Giro = 0;
  Localizacion.TierraX = 1.2;
  Localizacion.TierraY = 1.2;
  NuevoAngulo = 290;
  Localizacion.AngVista = 90;
  Lux = 1.5;
  Retardo = 24;

}

void Navegacion::SetPosicionInicial(float x, float y)
{
  Localizacion.TierraX = x;
  Localizacion.TierraY = y;
  NuevoAngulo = 130;
  Localizacion.AngVista = 10;
}

//--------------------------------------
void Navegacion::setLocalizacion(float x, float y, float angulo)
{
  Localizacion.TierraX = x;
  Localizacion.TierraY = y;
  Localizacion.AngVista = angulo;
}

//--------------------------------------
void Navegacion::setLocalizacion(float x, float y)
{
  Localizacion.TierraX = x;
  Localizacion.TierraY = y;
}


//--------------------------------------
bool Navegacion::Avanzo (int x, int y, int px, int py, float TierraXLimit, float TierraYLimit)
{

  if (x > px/3)
    {
      if ( Localizacion.Giro <= 10)
	Localizacion.Giro = Localizacion.Giro + 3.0/Retardo;
    }
  if (x < (px - px/3))
    {
      if (Localizacion.Giro >= -10)
	Localizacion.Giro = Localizacion.Giro - 3.0/Retardo;
    }

  bool Avance=false;

  float Xant = Localizacion.TierraX;
  float Yant = Localizacion.TierraY;

  if (x > (px-10))
    { 
      Avanzar(0, -2.0/Retardo, 0);
      Avance=true;
    } 
  
  if (x < 10)
    {    
      Avanzar(0, 2.0/Retardo, 0);
      Avance=true;
    }
  
  if (y > (py-10))
    {    
      Avanzar(-2.0/Retardo, 0, 0);
      Avance=true;
    }
  
  if (y < 10)
    {
      Avanzar(2.0/Retardo, 0, 0);
      Avance=true;
    }
  

  if ((Localizacion.TierraX > TierraXLimit)
      || (Localizacion.TierraX < 0)
      || (Localizacion.TierraY > TierraYLimit)
      || (Localizacion.TierraY < 0))
    {
      Localizacion.TierraX = Xant;
      Localizacion.TierraY = Yant;
      return (false);
    }

  return (Avance);
}

// --------------------------------------
strLocalizacion Navegacion::getLocalizacion()
{ 
  return (Localizacion);
};

// --------------------------------------
void Navegacion::setRetardo(float Ret)
{


  Localizacion.AngVista = GiroSuave(Localizacion.AngVista, NuevoAngulo, (int)Ret);

 
 Retardo = Ret;

}

//-----------------------------------
void Navegacion::Avanzar(float Vertical, float Horizontal, float Giro)
{

  float Angulo = Localizacion.AngVista + Localizacion.Giro;

  Localizacion.TierraX += (-zsin(Angulo)* Vertical - zcos(Angulo) * Horizontal);
  Localizacion.TierraY += (-zcos(Angulo)* Vertical + zsin(Angulo) * Horizontal);

  Localizacion.AngVista += Giro;
  
}

//-----------------------------------
//---------------------------------
void Navegacion::DibujaEjes (void)
{
  
 glBegin(GL_LINES);	 // dibujamos los 'ejes'
 
 glColor3f(0.0f,0.0f,1.0f);		// B
 
 glVertex3f(-2.0f,0.0f,0.0f);	//eje X		
 glVertex3f(2.0f,0.0f,0.0f);			
 
 glVertex3f(0.0f,-2.0f,0.0f);   //eje Y		
 glVertex3f(0.0f,2.0f,0.0f);			
 
 glColor3f(1.0f,0.0f,0.0f);		// R
 
 glVertex3f(1.0f,2.0f,0.0f);	// eje x = 1, sirve como referencia visual.		
 glVertex3f(1.0f,-2.0f,0.0f);			
 
 glEnd();

}















