/*=[[ Solar OpenSource Org (c) 2003 ]]=*/

//***************************************************************
//*  [[ A D V E R T E N C I A ]] =[ http://Solar-OpenSource.Org ]=
//*
//*  LICENCIA PARA LA DISTRIBUCIN DE WAR 3D
//*  1.- WAR 3D es un programa que podr ser distribuido bajo los trminos de la Licencia Pblica General, adems debern cumplirse las siguientes condiciones.
//*  2.- Al copiar cualquier parte del cdigo para ponerlo en un programa diferente a WAR 3D, el autor de dicho programa estar de acuerdo en que el cdigo completo de su programa pasa a ser software libre, por lo deber estar apegado a los trminos establecidos por la licencia LGP. Es decir que, el cdigo de WAR 3D solo puede ser tomado si se va a usar en otro proyecto de software libre. De lo contrario abstngase de usar el cdigo o parte de el cdigo de WAR3D.
//*  3.- Queda estrictamente prohibido modificar los nombres que aparecen en los crditos del programa, solo el grupo de desarrollo de  Solar-OpenSource podr aadir nuevos nombres en los crditos. Si ha hecho alguna modificacin y quiere que su nombre aparezca en los crditos debe ponerse en contacto con nosotros.
//*  4.- Cualquier modificacin del cdigo debe apegarse en lo posible a las normas que ha establecido el grupo de desarrollo de Solar-OpenSource, esto es para mayor claridad en el cdigo. Dichas normas pueden encontrarse en nuestra pagina web http://www.solar-opensource.org
//*  5.- Puede copiar y distribuir el programa siempre y cuando no olvide: Acompaarlo con el cdigo fuente completo correspondiente, legible para la mquina, as como el cdigo escrito por usted o las modificaciones hechas al cdigo original.
//*  6.- No debe distribuirse el ejecutable sin el cdigo fuente.
//*  7.- Este texto no debe suprimirse. Las distribuciones deben acompaarse con la informacin que se recibi as como el ofrecimiento para distribuir el cdigo fuente correspondiente.
//*
//***************************************************************

#ifndef __oEdificio_h__
#define __oEdificio_h__

#include <iostream>
#include <string>
#include <fstream>

using namespace std;

#include "oObjetos.h"

#include "animaEdificio.h"
#include "oConstruye.h"

#include "tierra.h"

#define ConsModoNormal 0


#define EstadoEdificioPreparandoDisparo 3
#define EstadoEdificioEsperandoADisparar 4
#define EstadoEdificioTerminadoDisparo  5


#define NuevoBichoError_TodoOK              000
#define NuevoBichoError_MuchoEnCola         100
#define NuevoBichoError_NoHayRecursos       200
#define NuevoBichoError_EdificioNoTerminado 300
#define NuevoBichoError_BichoNoValido       400
#define NuevoBichoError_LimiteDePoblacion   500


// -----------------------------------------
class oEdificio : public oObjetos
{


 private:
  float AnguloDeDisparoDib;

  // --------------------------
  // Constructores y destructor
  // --------------------------
 public:
  oEdificio(float x, float y, int ID, int internetID, bool Mio);
  ~oEdificio();

  // --------------------------
  // Render
  // --------------------------
 public:
  void dibujame(float Altura, z3DVector N, bool Seleccion);   

  // --------------------------
  // Army
  // --------------------------
 public:
  void onSetArmy();


// --------------------------
// Modo y estado
// --------------------------

 private:
  void setEstado(int Estado);


  // --------------------------
  // Animaciones
  // --------------------------
 public:
  void playAnimacion ();


  // --------------------------
  // Tiempo y retardos
  // --------------------------
 private:
  void onRetardo();


  // --------------------------
  // Disparos
  // --------------------------
 private:
  void onSetDanio(int Danio);
  void onIntentaDisparo(bool Alcanzado);


  // --------------------------
  // Sonidos
  // --------------------------
 public:
  void PlaySeleccionado();
  void PlayMuerto();
  void PlayTerminado();


  //////////////
  /// EXTRAS ///
  //////////////

  // --------------------------
  // Army
  // --------------------------
 public:
  inline float getAnima() {return Anima;};
  inline int getNumUnidades () {return ((ConstruArmy*)MyArmy)->getNumUnidades();};
  inline UnidadArmy ** getUnidades () {return ((ConstruArmy*)MyArmy)->Unidades;};
  inline Textura getMinifoto() {return ((ConstruArmy*)MyArmy)->MiniFoto;};

  int getCostoUnidad(int UnidadTipo);

  // --------------------------
  // Constructor
  // --------------------------
 private:
  float ContruccionAvance;
  oConstruye *Construccion;
 public:
  void setEdificioContructor(oConstruye *Construccion);  


  // --------------------------
  // Nuevos Bichos
  // --------------------------
 private:
  float BichoTerminado;
  z2DVector BichoLocalizacion; 
 public:
  vector <int> ListaDeEspera;
  inline z2DVector getBichoLocalizacion(){return BichoLocalizacion;};
  inline void setBichoLocalizacion(float x, float y){BichoLocalizacion.x = x; BichoLocalizacion.y = y;};
  float getBichoTerminado() {return BichoTerminado;};
  int nuevoBicho (int Tipo);
  void cancelaBicho (unsigned int Index);


};
#endif


