/*=[[ Solar OpenSource Org (c) 2003 ]]=*/

//***************************************************************
//*  [[ A D V E R T E N C I A ]] =[ http://Solar-OpenSource.Org ]=
//*
//*  LICENCIA PARA LA DISTRIBUCIÓN DE WAR 3D
//*  1.- WAR 3D es un programa que podrá ser distribuido bajo los términos de la Licencia Pública General, además deberán cumplirse las siguientes condiciones.
//*  2.- Al copiar cualquier parte del código para ponerlo en un programa diferente a WAR 3D, el autor de dicho programa estará de acuerdo en que el código completo de su programa pasa a ser software libre, por lo deberá estar apegado a los términos establecidos por la licencia LGP. Es decir que, el código de WAR 3D solo puede ser tomado si se va a usar en otro proyecto de software libre. De lo contrario absténgase de usar el código o parte de el código de WAR3D.
//*  3.- Queda estrictamente prohibido modificar los nombres que aparecen en los créditos del programa, solo el grupo de desarrollo de  Solar-OpenSource podrá añadir nuevos nombres en los créditos. Si ha hecho alguna modificación y quiere que su nombre aparezca en los créditos debe ponerse en contacto con nosotros.
//*  4.- Cualquier modificación del código debe apegarse en lo posible a las normas que ha establecido el grupo de desarrollo de Solar-OpenSource, esto es para mayor claridad en el código. Dichas normas pueden encontrarse en nuestra pagina web http://www.solar-opensource.org
//*  5.- Puede copiar y distribuir el programa siempre y cuando no olvide: Acompañarlo con el código fuente completo correspondiente, legible para la máquina, así como el código escrito por usted o las modificaciones hechas al código original.
//*  6.- No debe distribuirse el ejecutable sin el código fuente.
//*  7.- Este texto no debe suprimirse. Las distribuciones deben acompañarse con la información que se recibió así como el ofrecimiento para distribuir el código fuente correspondiente.
//*
//***************************************************************

#include "oObjetos.h"

#include "ejercito.h"

// --------------------------
// Constructores y destructor
// --------------------------

oObjetos::oObjetos (float x, float y, int ID, int internetID, bool Mio)
{

  localizacion.x = x;
  localizacion.y = y;
  this->internetID = internetID;
  this->ID = ID;
  this->Mio = Mio;

  Retardo = 1.0;
  Angulo = 0;
  AnguloDeDisparo = 0;
  Transparencia = 1.0; 

  // La animacion comienza en el frame 1
  Anima = 1.0;  

  // La unidad no esta selecionada.
  Seleccionado = false;

  // Launidad no esta producinedo ningun sonido.
  ReproduciendoSonido = false;

  // Cada cuando se ejecuta la animacion de quieto, al azar.
  Azar = rand() % 1000;

  // inicializamos el contador para animaciones al azar
  ContadorAzar = 0;

  // ID de la presa a cazar, bicho a seguir, o edificio a atacar.
  PresaOSeguirID = 0;


  DisparoRetardo = 0;
}


// --------------------------
// Render
// --------------------------

// --------------------------------------
float oObjetos::getAngulo()
{
  return Angulo;
} 


// --------------------------
// Army
// --------------------------

// --------------------------------------
void oObjetos::setArmy(UnidadArmyBase *MyArmy)
{

  this->MyArmy = MyArmy;
  Sangre = MyArmy->sangre;
  onSetArmy();
}


// --------------------------
// Tiempo y retardos
// --------------------------

// --------------------------------------
void oObjetos::setRetardo(float Retardo)
{

  // Esta parte del codigo mantiene sicronizadas las cosas, 
  // sin importar la velocidad del CPU

  this->Retardo = Retardo;

  AnimPlayer->setRetardo(Retardo);
  playAnimacion();

  onRetardo();

  // Cada segundo llamamos al evento onClock_1_00Sec()
  // solo algunos objetos lo utilizan.

  static float Clock = 0.0;
  if (Clock > 1.0) {Clock = 0.0; onClock_1_00Sec();}
  else {Clock = Clock + 1/Retardo;}


  if (getEstado() == EstadoMuertoDestruido)
    {
      if (DesaparecerMuerto < MinimoDesaparece)
	{
	  DesaparecerMuerto = DesaparecerMuerto + 0.020/Retardo;
	}
    }

  DisparoRetardo = DisparoRetardo + 1/Retardo;

}


// --------------------------
// Disparos
// --------------------------

// --------------------------------------
void oObjetos::setDanio(int Danio)
{

  // A esta unidad le han disparado
  // Decrementamos la sangre
  
  Sangre = Sangre - Danio;
  
  if (Sangre < 1)
    {

      // Si la sangre es menor a 1, deseccionamos la unidad, la colocamos en estado
      // muerto para que los demas bichos comprueven si esta viva, con getEstado()
      setEstado(EstadoMuertoDestruido);

      Seleccionado = false;

      // Reproducimos el sonido de muerte de esta unidad, espesificado por el army
      PlayMuerto();      
    }

  onSetDanio(Danio);

}

// --------------------------------------
bool oObjetos::Desapareceme() 
{
  if (DesaparecerMuerto > MinimoDesaparece) return true; 
  return false;
};




// --------------------------
// Disparos
// --------------------------

//-----------------------------------------
bool oObjetos::IntentaDisparo()
{
	
// Hacemos el daño, aunque la animacion no se realizara.
 
  float DistanciaEntreBichos;
 
  DistanciaEntreBichos =  zDistancia(getLocalizacion().x, 
				     getLocalizacion().y, 
				     getPresaOSeguir()->getLocalizacion().x, 
				     getPresaOSeguir()->getLocalizacion().y);
  
  if (DistanciaEntreBichos < getAlcance())
    {
      Dispara (getPresaOSeguir());
      onIntentaDisparo(true);
      return true;
    }

  onIntentaDisparo(false);
  return false;

}

// ------------------------------------------
bool oObjetos::getArmaLista()
{
  if ((DisparoRetardo)>((12.0-MyArmy->veldedisparo)/5.0))
    {
      return true;
    }
  return false;
}


// --------------------------------------
void oObjetos::Dispara (oObjetos* Victima)
{
  if (MyArmy->danio > 0)
    {
      PresaOSeguirID = Victima->ID;
      setEstado(EstadoDisparando); 
    }
}


// ---------------------------------------------
oObjetos *oObjetos::getPresaOSeguir()
{

  oObjetos *PresaOSeguir = (oObjetos*)NULL; 

  PresaOSeguir = Ejercito::getBichoReferencia(PresaOSeguirID);

  if (PresaOSeguir == (oObjetos*)NULL)
  {
    PresaOSeguir = Ejercito::getEdificioReferencia(PresaOSeguirID);

    if (PresaOSeguir == (oObjetos*)NULL)
      {
	PresaOSeguirID = 0;
	War3DWarning("oObjetos", " Solado o Edificio inexistentes");
      }
  }
  return PresaOSeguir;
}
