//***************************************************************
//*  [[ A D V E R T E N C I A ]] =[ http://Solar-OpenSource.Org ]=
//*
//*  LICENCIA PARA LA DISTRIBUCIÓN DE WAR 3D
//*  1.- WAR 3D es un programa que podrá ser distribuido bajo los términos de la Licencia Pública General, además deberán cumplirse las siguientes condiciones.
//*  2.- Al copiar cualquier parte del código para ponerlo en un programa diferente a WAR 3D, el autor de dicho programa estará de acuerdo en que el código completo de su programa pasa a ser software libre, por lo deberá estar apegado a los términos establecidos por la licencia LGP. Es decir que, el código de WAR 3D solo puede ser tomado si se va a usar en otro proyecto de software libre. De lo contrario absténgase de usar el código o parte de el código de WAR3D.
//*  3.- Queda estrictamente prohibido modificar los nombres que aparecen en los créditos del programa, solo el grupo de desarrollo de  Solar-OpenSource podrá añadir nuevos nombres en los créditos. Si ha hecho alguna modificación y quiere que su nombre aparezca en los créditos debe ponerse en contacto con nosotros.
//*  4.- Cualquier modificación del código debe apegarse en lo posible a las normas que ha establecido el grupo de desarrollo de Solar-OpenSource, esto es para mayor claridad en el código. Dichas normas pueden encontrarse en nuestra pagina web http://www.solar-opensource.org
//*  5.- Puede copiar y distribuir el programa siempre y cuando no olvide: Acompañarlo con el código fuente completo correspondiente, legible para la máquina, así como el código escrito por usted o las modificaciones hechas al código original.
//*  6.- No debe distribuirse el ejecutable sin el código fuente.
//*  7.- Este texto no debe suprimirse. Las distribuciones deben acompañarse con la información que se recibió así como el ofrecimiento para distribuir el código fuente correspondiente.
//*
//***************************************************************


#include "pantallaInicio.h"

#include "Solar3DWidGets/Solar3DWidGetPanel.h"
#include "Solar3DWidGets/Solar3DWidGetLabel.h"
#include "eventos.h"

#include "pantallaMultiplayerIRC.h"

#include "navegacion.h"

#include "dianoche.h"


// ---------------------------------------
pantallaInicio::pantallaInicio()
{
  // Singleton     ZG: ODIO Windows y VC++
  // zMacro_SingletonHack;

  Nombre = "pantallaInicio";
  setTexturaDeFondo("Interface/Pantallas/Cargando.png");
  izq = 0.0;
  alto = 0.0;
  ancho = 1.0;
  alto = 1.0;


  // ----------------
  TextoChat = new Solar3DWidGetTextBox ("Charla", 0.01, 0.01, 0.65, 0.65);
  TextoChat->SetFontSize(5);
  agregarHijo(TextoChat);


  // ----------------
  TextoDeSalidaChat = new Solar3DWidGetText("Texto_01", 0.01, 0.67, 0.65, 0.04);
  TextoDeSalidaChat->SetFontSize(7);
  TextoDeSalidaChat->FontColor.setColor(0.0, 0.0 ,0.5, 1.0);
  TextoDeSalidaChat->onKeyPress = onTextoDeSalidaChat_keyPress;
  agregarHijo(TextoDeSalidaChat);


  NickChat = new Solar3DWidGetTextBox ("Nicks", 0.67, 0.01, 0.32, 0.70);
  NickChat->SetFontSize(5);
  agregarHijo(NickChat);

  // ----------------
  Solar3DWidGetLabel * NuevoLabel;
  NuevoLabel = new Solar3DWidGetLabel ("lblMapa", 0.67, 0.73, 0.1, 0.1, ">SegundoMapa60x60");
  NuevoLabel->FontColor.setColor(0.9, 0.9 ,1.0, 1.0);
  NuevoLabel->SetFontSize(5);
  agregarHijo(NuevoLabel);


  Solar3DWidGetTextBox * SeleccionMapas;
  SeleccionMapas = new Solar3DWidGetTextBox ("Mapas", 0.67, 0.76, 0.32, 0.15);
  SeleccionMapas->SetTexto("SegundoMapa60x60");
  SeleccionMapas->SetFontSize(5);
  agregarHijo(SeleccionMapas);


  // ZG Creamos un nuevo boton
  BotonIniciar = new Solar3DWidGetBoton("Iniciar partida", 0.67, 0.94, 0.32, 0.05, "Iniciar");
  //NuevoBoton->setTexturaDeFondo("Interface/Pantallas/Prepartida/BotonIniciarPartida.tga");
  BotonIniciar->onMouseClic = BotonIniciarPartida;
  agregarHijo(BotonIniciar);

  // ----------------
  Solar3DWidGetLabel * RazaLabel;
  RazaLabel = new Solar3DWidGetLabel ("lblRaza", 0.01, 0.73, 0.1, 0.1, ">Selecciona alguna");
  RazaLabel->FontColor.setColor(0.9, 0.9 ,1.0, 1.0);
  RazaLabel->SetFontSize(5);
  agregarHijo(RazaLabel);


  Solar3DWidGetTextBox * SeleccionRaza;
  SeleccionRaza = new Solar3DWidGetTextBox ("Raza", 0.01, 0.76, 0.32, 0.15);
  SeleccionRaza->SetTexto(string("Eutomats") + "\n " +  "LosUltimosDeCajosp" + "\n " + "HYK3" + " ");
  SeleccionRaza->SetFontSize(5);
  agregarHijo(SeleccionRaza);



  // ZG Creamos un nuevo boton
  Solar3DWidGetBoton *NuevoBotonCancelar;
  NuevoBotonCancelar = new Solar3DWidGetBoton("cancelar partida", 0.01, 0.94, 0.32, 0.05, "Cancelar");
  NuevoBotonCancelar->onMouseClic = BotonCancelarPartida;
  agregarHijo(NuevoBotonCancelar);

  //Evento render, para contar el tiempo.
  onRender = Render;

}


// -----------------------------
void pantallaInicio::setRoll(int Roll)
{
  this->Roll = Roll;
  if (Roll == pantallaNuevaPartidaRollServer)
    {
      BotonIniciar->Visible = true;
      AddText("Eres el administrador de la partida.");
    }
  if (Roll == pantallaNuevaPartidaRollCliente)
    {
      BotonIniciar->Visible = false;
      AddText("Eres un invitado de esta partida.");
    }
}


// ------------------------------
void pantallaInicio::onTextoDeSalidaChat_keyPress(const char key, Solar3DWidGetBase* This)
{

  string Texto;
  pantallaInicio *Padre = (pantallaInicio*)(This->getPadre());

  if (key == 13)
    {
      Texto = Padre->TextoChat->GetTexto() + "Yo" + ": " + ((Solar3DWidGetText*)This)->GetTexto() + "\n ";
      // ZeruGiran el espacio al final es un parche de mierda que no deberia estar.
      Padre->TextoChat->SetTexto(Texto);
      Padre->sendCHAT(((Solar3DWidGetText*)This)->GetTexto());   // Comando de RED
      ((Solar3DWidGetText*)This)->Clean();
    }
}


// ---------------------------------------
void pantallaInicio::BotonIniciarPartida(unsigned int boton, float x, float y, Solar3DWidGetBase* This)
{
  pantallaInicio *Padre = (pantallaInicio*)(This->getPadre());

  Padre->sendINICIA();
}


// ---------------------------------------
void pantallaInicio::BotonCancelarPartida(unsigned int boton, float x, float y, Solar3DWidGetBase* This)
{
  pantallaInicio *Padre = (pantallaInicio*)(This->getPadre());

  Padre->DesConectar();
  Eventos::ME()->SetRenderModo(Eventos::ME()->getRenderModoAnterior());
  
}


// ------------------------------
void pantallaInicio::AddText(string text)
{
  TextoChat->SetTexto(TextoChat->GetTexto() + text + "\n ");
}


// ------------------------------
void pantallaInicio::Reset()
{
  TextoChat->SetTexto("");
  NickChat->SetTexto("");
  Ejercito::TodosLosEjercitos.clear();
}


// ------------------------------
void pantallaInicio::RefreshNicks()
{
  NickChat->SetTexto("");

  vector<Ejercito>::iterator Ejers;
    for (Ejers=(Ejercito::TodosLosEjercitos.begin()); Ejers != Ejercito::TodosLosEjercitos.end(); Ejers++)
    {
      NickChat->SetTexto(NickChat->GetTexto() + Ejers->strNick + ".." + "\n ");
    }
    cout << "RefrescaNicks" << endl;
}


// ---------------------------------
void pantallaInicio::datosDePartida(string nombre, string mapa)
{
  nombreDePartida = nombre;
  mapaDePartida = mapa;

  timebase = glutGet(GLUT_ELAPSED_TIME);

  enviarDatosDePartida();

  if (pantallaMultiplayerIRC::ME()->getMiIP() != pantallaMultiplayerIRC::ME()->getIPSocket())
    {
      AddText("Estas detras de una red NAT, recuerda que debes redireccionar el puerto 6300 usado por War3D");
    }

}


// ---------------------------------
void pantallaInicio::enviarDatosDePartida()
{
  pantallaMultiplayerIRC::ME()->sendNUEVAPARTIDA(nombreDePartida, 1, mapaDePartida);
}


// ---------------------------------
void pantallaInicio::Render(Solar3DWidGetBase* This)
{

  if (pantallaInicio::ME()->Roll == pantallaNuevaPartidaRollServer)
    {
  
      int Tiempo = glutGet(GLUT_ELAPSED_TIME) - pantallaInicio::ME()->timebase;
      
      if (Tiempo > 20000)
	{
	  pantallaInicio::ME()->timebase = glutGet(GLUT_ELAPSED_TIME);
	  
	  pantallaInicio::ME()->enviarDatosDePartida();
	}
    }
}


// ------------------------------
void pantallaInicio::onPOSINI(int InternetID, float x, float y)
{
  cout << "[[PI]] InetID: " << InternetID << "  x: " << x << "  y: " << y << endl;

  z2DVector POS;
  POS.x = x;
  POS.y = y;
  Navegacion::ME()->SetPosicionInicial(x, y);        

  Ejercito MiEjercito(InternetID , POS);
  MiEjercito.setMiejercito(true);

  // MOVER ESTE CODIGO de Aqui; !!TODO !!
  srand(glutGet(GLUT_ELAPSED_TIME));
  
  switch (rand() %4)
    {
    case 0: case 3: MiEjercito.setArmy("LosUltimosDeCajosp"); break;
    case 1: MiEjercito.setArmy("HYK3"); break;
    case 2: MiEjercito.setArmy("Eutomats"); break;
    }
  ////

  if (pantallaMultiplayerIRC::ME()->StatusIRCConectado) 
    {
      sendNICK(pantallaMultiplayerIRC::ME()->getMiNick());
    }
  else
    {
      sendNICK("PlayerX");
    }

  Ejercito::TodosLosEjercitos.insert(Ejercito::TodosLosEjercitos.begin(), MiEjercito);  
  sendLISTO(true);
  
  if (configuracion::Server == "SINGLEPLAYER")
    {
      // Conecta el BOT
      zSleep(1000);
      SinglePlayerBot.Inicio();
    }
}

// ------------------------------
void pantallaInicio::onCHAT(int InternetID, string strMensaje)
{
  cout << "[[CHAT]] " << InternetID << " " << strMensaje << endl;

  vector<Ejercito>::iterator Ejers;
  string Nick;

  for (Ejers=(Ejercito::TodosLosEjercitos.begin()); Ejers != Ejercito::TodosLosEjercitos.end(); Ejers++)
    {
      cout << "Ejers->getinternetID()" << Ejers->getinternetID() << endl;
      if (Ejers->getinternetID() == InternetID)
	{
	  Nick = Ejers->strNick;
	}
    }

  if (true/*Nick != ""*/)
    {

      if (Eventos::ME()->getRenderModo() == pModoPartida)
	{
	  pantallaInicio::ME()->AddText(Nick + "[" + zitoa(InternetID) + "]: " + strMensaje);
	}
      else if (Eventos::ME()->getRenderModo() == pModoJuego)
	{
	  ConsolaChat::ME()->Chat(Nick + "[" + zitoa(InternetID) + "]" , strMensaje);
	}
    }
  else
    {
      cout << "Alguien sin ID esta hablando" << endl;
    }
  
}


// ------------------------------
void pantallaInicio::onADMIN( )
{
  cout << "[[RO]]" << endl;
  Eventos::ME()->SoyAdmin = true; // !!TODO!!  getSoyAdmin()
  War3DAccion ("PARTIDA", "Designado Administrador");
  setRoll(pantallaNuevaPartidaRollServer);
}

// ------------------------------
void pantallaInicio::onENTRA(int InternetID)
{
  cout << "[[NJ]] InternetID: " << InternetID << endl;
  
  z2DVector POS;
  POS.x=0;
  POS.y=0;
  
  Ejercito EjercitoEnemigo(InternetID, POS);
  Ejercito::TodosLosEjercitos.push_back(EjercitoEnemigo);

  pantallaInicio::ME()->AddText("Un nuevo jugador ah entrado");

  pantallaInicio::ME()->RefreshNicks();

  sendLISTO(true);
}


// ------------------------------
void pantallaInicio::onLISTANICKS(int InternetID, string strNick, string strArmy)
{
  // cout << "[[LI]] InternetID: " << InternetID << endl;
  
  z2DVector POS;
  POS.x=0;
  POS.y=0;
  

  // TODO ZG Verificar si el ejercito ya existe y si asi es no agregarlo de nuevo; 
  // NOTA Posiblemete no es necesario si el servidor esta bien hecho.

  Ejercito EjercitoEnemigo(InternetID, POS);
  EjercitoEnemigo.strNick = strNick;
  EjercitoEnemigo.setArmy(strArmy);
  Ejercito::TodosLosEjercitos.push_back(EjercitoEnemigo);

  pantallaInicio::ME()->RefreshNicks();

  sendLISTO(true);
}



// ------------------------------
void pantallaInicio::onSETARMY(int InternetID, string strArmy)
{
  // cout << "[[AR]] InternetID: " << InternetID << "  Army: " << strArmy << endl;
  vector<Ejercito>::iterator Ejers;
  for (Ejers=(Ejercito::TodosLosEjercitos.begin()); Ejers != Ejercito::TodosLosEjercitos.end(); Ejers++)
    {
      if (Ejers->getinternetID() == InternetID)
	{
	  Ejers->setArmy(strArmy);
	  return;
	}
    }
}

// ------------------------------
void pantallaInicio::onNICK(int InternetID, string strNick)
{
  cout << "[[NI]] InternetID: " << InternetID << "  Nick: " << strNick << endl;

  vector<Ejercito>::iterator Ejers;
  for (Ejers=(Ejercito::TodosLosEjercitos.begin()); Ejers != Ejercito::TodosLosEjercitos.end(); Ejers++)
    {
      if (Ejers->getinternetID() == InternetID)
	{

	  cout << "Camibo de Nick de: " << Ejers->strNick;
	  Ejers->strNick = strNick;
	  cout << " a:" << Ejers->strNick << endl;
	  pantallaInicio::ME()->RefreshNicks();
	  return;
	}
    }
}

/* DEPRECATED ZG
// ------------------------------
void pantallaInicio::onRD( )
{
  // cout << "[[RD]]" << endl;
}
*/


// ------------------------------
void pantallaInicio::onCLIMA(string Condicion, int Duracion)
{
  // cout << "[[CL]]" << "Condicion: " << Condicion << "  Duracion: " << Duracion << endl;

  DiaNocheClima::ME()->setClima(Condicion, Duracion); //!!TODO!! Singleton
  cout << "CLIMATE SERVER" << endl;
  
  if (Condicion == "DIA")
    {
      Recursos::ME()->cleanRecurso(); //!!TODO!! Singleton
    }
  else if (Condicion == "NOCHE")
    {
      Eventos::ME()->Anuncios01->Escribe(0.10, 0.30, "Los suministros seran enviados al anochecer.", 7);
      Eventos::ME()->Anuncios02->Escribe(0.25 , 0.35, "Date prisa en recolectarlos.", 7); // !! TODO!! PRivate
    }
}

// ------------------------------
void pantallaInicio::onINICIA( )
{
  cout << "[[ST]]" << endl;

  Tierra::ME()->Inicia("SegundoMapa60x60");  // Objeto tierra.
  Eventos::ME()->ElPanelDeMiniMapa.PutEcenario();

  vector<Ejercito>::iterator Ejers;
  for (Ejers=(Ejercito::TodosLosEjercitos.begin()); Ejers != Ejercito::TodosLosEjercitos.end(); Ejers++)
    {
      Ejers->Inicia();
    }


  cout <<  "Comienza la partida"  << endl;
  DiaNocheClima::ME()->setClok(0);
  Eventos::ME()->SetRenderModo(pModoJuego);


  // Mi Ejercito
  vector<Ejercito>::iterator MiEjers = Ejercito::TodosLosEjercitos.begin();
  MiEjers->addSoldado(1, MiEjers->getBaseLocalizacion().x+0.4, 
		      MiEjers->getBaseLocalizacion().y-0.0, 0);
  MiEjers->addSoldado(2, MiEjers->getBaseLocalizacion().x+0.5, 
		      MiEjers->getBaseLocalizacion().y-0.0, 0);
  MiEjers->addEdificio(3, MiEjers->getBaseLocalizacion().x + 0, 
		       MiEjers->getBaseLocalizacion().y, 0);
  MiEjers->addEdificio(2, MiEjers->getBaseLocalizacion().x + 1.0, 
		       MiEjers->getBaseLocalizacion().y, 0);

  cout << "[o]" << MiEjers->getBaseLocalizacion().x << " " << MiEjers->getBaseLocalizacion().y << "[o]";

}


// ------------------------------
void pantallaInicio::onAGREGAEDIFICIO(int InternetID, int tipo, float x, float y, int ID)
{

  // cout << "[[AE]]" << " InternetID: " << InternetID << "  tipo: " << tipo << "  x: " << x << "  y: " << y << "  ID: " << ID << endl;
  vector<Ejercito>::iterator Ejers;
  for (Ejers=(Ejercito::TodosLosEjercitos.begin()); Ejers != Ejercito::TodosLosEjercitos.end(); Ejers++)
    {
      if (Ejers->getinternetID() == InternetID)
	{
	  Ejers->addEdificio(tipo, x, y, ID); 
	  return;
	}
    }      
}


// ------------------------------
void pantallaInicio::onAGREGASOLDADO(int InternetID, int tipo, float x, float y, int ID)
{
  // cout << "[[AD]]" << " InternetID: " << InternetID << "  tipo: " << tipo << "  x: " << x << "  y: " << y << "  ID: " << ID << endl;
  vector<Ejercito>::iterator Ejers;
  for (Ejers=(Ejercito::TodosLosEjercitos.begin()); Ejers != Ejercito::TodosLosEjercitos.end(); Ejers++)
    {
      if (Ejers->getinternetID() == InternetID)
	{
	  Ejers->addSoldado(tipo, x, y, ID); 
	}
    }      
}


// ------------------------------
void pantallaInicio::onRECURSOS(float x, float y)
{
  // cout << "[[RE]]" << " x: " << x << "  y: " << y << endl;
   Recursos::ME()->putRecurso(x, y); //!!TODO!! Singleton
}


// ------------------------------
void pantallaInicio::onMOD(int MiInternetID, int Modo, int MiBichoID, 
		      float x, float y, float xRedundante, float yRedundante,
		      int EnemigoID, int EnemigoInternetID)
{

  // cout << "[[MD]]" << " ..." << endl;

  // -- BICHO DE INTERES -- Vamos a buscar el bicho que realiza la accion.
  oObjetos* BichoOEdificio  = Ejercito::GetBichoInet (MiInternetID, MiBichoID);      
  if (BichoOEdificio == (oObjetos*) NULL) return;


  // -- BICHO A CAZAR -- Vamos a buscar el bicho o edificio sobre el cual se ejerce la accion
  oObjetos* EnemigoBichoOEdificio;
  if (EnemigoID == -1 || EnemigoInternetID == -1)
    {
      EnemigoBichoOEdificio = (oObjetos*) NULL;
    }
  else
    { 
      if(EnemigoInternetID == -1)
	{
	  EnemigoBichoOEdificio = Ejercito::GetBichoInet (BichoOEdificio->internetID, EnemigoID);
	}
      else
	{
	  EnemigoBichoOEdificio = Ejercito::GetBichoInet (EnemigoInternetID, EnemigoID);
	}
      if (EnemigoBichoOEdificio == (oObjetos*) NULL) return;
    }
   
  if (EnemigoBichoOEdificio == (oObjetos*) NULL)
    {
      BichoOEdificio->setModo(Modo, x, y, 0, xRedundante, yRedundante);  
    }
  else
    {
      BichoOEdificio->setModo(Modo, x, y, EnemigoBichoOEdificio->ID, xRedundante, yRedundante);  
    }
  
  return;
}

//  -----------------------------------
void pantallaInicio::onSALIDA(int InternetID)
{
  vector<Ejercito>::iterator Ejers;
  for (Ejers=(Ejercito::TodosLosEjercitos.begin()); Ejers != Ejercito::TodosLosEjercitos.end(); Ejers++)
    {
      if (Ejers->getinternetID() == InternetID)
	{
	  Eventos::ME()->Anuncios01->Escribe(0.02, 0.30, "EL JUGADOR " + Ejers->strNick + " AVANDONO LA PARTIDA", 7);
	  cout << "El jugador " + Ejers->strNick + " avandono la partida." << endl;

	  pantallaInicio::ME()->AddText("El jugador " + Ejers->strNick + " avandono la partida.");
	  pantallaInicio::ME()->RefreshNicks();

	  Ejercito::TodosLosEjercitos.erase(Ejers);
	  return;
	}
    }
}
