//***************************************************************
//*  [[ A D V E R T E N C I A ]] =[ http://Solar-OpenSource.Org ]=
//*
//*  LICENCIA PARA LA DISTRIBUCIN DE WAR 3D
//*  1.- WAR 3D es un programa que podr ser distribuido bajo los trminos de la Licencia Pblica General, adems debern cumplirse las siguientes condiciones.
//*  2.- Al copiar cualquier parte del cdigo para ponerlo en un programa diferente a WAR 3D, el autor de dicho programa estar de acuerdo en que el cdigo completo de su programa pasa a ser software libre, por lo deber estar apegado a los trminos establecidos por la licencia LGP. Es decir que, el cdigo de WAR 3D solo puede ser tomado si se va a usar en otro proyecto de software libre. De lo contrario abstngase de usar el cdigo o parte de el cdigo de WAR3D.
//*  3.- Queda estrictamente prohibido modificar los nombres que aparecen en los crditos del programa, solo el grupo de desarrollo de  Solar-OpenSource podr aadir nuevos nombres en los crditos. Si ha hecho alguna modificacin y quiere que su nombre aparezca en los crditos debe ponerse en contacto con nosotros.
//*  4.- Cualquier modificacin del cdigo debe apegarse en lo posible a las normas que ha establecido el grupo de desarrollo de Solar-OpenSource, esto es para mayor claridad en el cdigo. Dichas normas pueden encontrarse en nuestra pagina web http://www.solar-opensource.org
//*  5.- Puede copiar y distribuir el programa siempre y cuando no olvide: Acompaarlo con el cdigo fuente completo correspondiente, legible para la mquina, as como el cdigo escrito por usted o las modificaciones hechas al cdigo original.
//*  6.- No debe distribuirse el ejecutable sin el cdigo fuente.
//*  7.- Este texto no debe suprimirse. Las distribuciones deben acompaarse con la informacin que se recibi as como el ofrecimiento para distribuir el cdigo fuente correspondiente.
//*
//***************************************************************

#include "tierra.h"
#include "astar_v1.h"


//------------------------------------
// Constructor 
//------------------------------------

void* Tierra::getVertices()
{
  return Tierra::verticesMapa;
}

//--------------------
int Tierra::getAncho()
{
  return ancho;
}


//--------------------
int Tierra::getAlto()
{
  return alto;
}

//--------------------
void Tierra::clean()
{
  
  delete [] Tierra::verticesMapa;
  Tierra::Tex.clear();
  Tierra::ModelosDeObjetos.clear();
  Tierra::alto = 0;
  Tierra::ancho = 0;
  Tierra::Inicializado = false;

}

//--------------------
Tierra::Tierra()
{

  alto = 0; // Altura del mapa
  ancho = 0; // Ancho del mapa 
  Inicializado = false;
}


//--------------------
Tierra::~Tierra()
{
  
}

int Tierra::Inicia (string Mapa)
{  

  if ( Tierra::Inicializado == true)
    {
      cout << "El Objeto Tierra ya estba inicializado " << endl;
      cout << "Debes limpiarlo antes con clean() " << endl;
      exit(0);
    }
    else
    {
      int NoObjetos;
      int NoTexturas;
      
      
      string version;
      string Nombre;
      string Autor;
      
      
      string Basura;
      int i, j;
      
      string Archivo = "Esenarios/Mapas/"; 
      Archivo += Mapa + ".mapa";
      
      ifstream Arch(Archivo.c_str());
      if (Arch == NULL) 
	{ 
	  cout << "Error al abrir el archivo " << Archivo << endl;
	}
      
      cout << "Leyendo Archivo de mapa: " << Archivo << endl;
      
      Arch >> Basura; Arch >> version;
      cout << "Version: " << version << endl;
      Arch >> Basura; Arch >> Nombre;
      Arch >> Basura; Arch >> Autor;
      Arch >> Basura; Arch >> Basura;
      Arch >> Basura; Arch >> Tierra::alto; cout << "Alto: " << Tierra::alto << endl;
      Arch >> Basura; Arch >> Tierra::ancho; cout << "Ancho: " << Tierra::ancho << endl;
      Arch >> Basura; Arch >> NoTexturas; cout << "Textures: " << NoTexturas << endl;
      Arch >> Basura; Arch >> NoObjetos; cout << "Objetos: " << NoObjetos << endl;
      Arch >> Basura;
      
      Tierra::verticesMapa = new verticeTierra [Tierra::alto*Tierra::ancho];
      
      int tmp;
      cout << "Cargando mapa de niveles ";
      for (j=0; j<Tierra::alto; j++)
	{
	  for (i=0; i<Tierra::ancho; i++)	
	    {
	      Arch >> tmp;
	      Tierra::verticesMapa[j*Tierra::ancho+i].Altura = tmp/Desnivel;
	    }
	  
	  // Zeru DEprecated -->>
	  //pPantallas::BarraDeCarga.Avance = 33*(float(j)/Tierra::alto)+0;
	  //pPantallas::BarraDeCarga.Cadena = "Cargando mapa de alturas";
	  //pPantallas::PantallaActiva->Dibujame();
	  // << ----
	}
      
      Arch >> Basura;
      
      cout << "Cargando texturas " << endl;

      string texID;
      string texNombre;
      string TipoDeTextura;
      string NumFrames;
      string Consitencia;

      for (i=0; i<NoTexturas; i++)
	{

	  texturaTierrita texTemp;    

	  Arch >> texNombre;
	  Arch >> texTemp.TexTierritaID;
	  Arch >> TipoDeTextura;
	  Arch >> NumFrames;
	  Arch >> texTemp.Consistencia;	

	  cout << texNombre << endl;

	  string texNombre2 = "Esenarios/Texturas/" +  texNombre +".png";
	  texNombre = "Esenarios/Texturas/" +  texNombre +".tga";

  

	  if (TipoDeTextura == "Multitextura")
	    {
	      texTemp.tex = ServidorDeTexturas::ME()->NuevaMultiTextura(texNombre2.c_str(), atoi(NumFrames.c_str()));
	    }
	  else
	    {
	      texTemp.tex = ServidorDeTexturas::ME()->Nueva(texNombre.c_str());
	    }

	  Tierra::Tex.push_back(texTemp);

	}

      Arch >> Basura;	

      cout << "Cargando mapa de texturas" << endl;
      for (j=0; j<Tierra::alto; j++)
	{
	  for (i=0; i<Tierra::ancho; i++)	
	    {
	      Arch >> Tierra::verticesMapa[j*Tierra::ancho+i].intTextura;
	      if (Tierra::verticesMapa[j*Tierra::ancho+i].intTextura >= NoTexturas)
		{
		  Tierra::verticesMapa[j*Tierra::ancho+i].intTextura = 0;
		}
	    }

	  // Zeru DEprecated -->>
	  //antallas::BarraDeCarga.Avance = 33*(float(j)/Tierra::alto)+33;
	  //pPantallas::BarraDeCarga.Cadena = "Cargando mapa de texturas";
	  //pPantallas::PantallaActiva->Dibujame();
	} // < ----


      Arch >> Basura;

      cout << "Cargando objetos" << endl;

      for (i=0; i<NoObjetos; i++)
	{

	  MapObjetos tmpObj;

	  Arch >> tmpObj.Nombre;
	  tmpObj.Nombre = string("Esenarios/Objetos/") + tmpObj.Nombre;
	  Arch >> tmpObj.ID;
	  Arch >> tmpObj.strTextura;
	  tmpObj.strTextura = string("Esenarios/Objetos/") + tmpObj.strTextura;
	  Arch >> tmpObj.Animacion;
	  if(tmpObj.Animacion == "NULL")
	    {
	      tmpObj.Animacion = "";
	    }
	  else
	    {
	      tmpObj.Animacion = string("Esenarios/Objetos/") + tmpObj.Animacion;
	    }
	  Arch >> tmpObj.Escala;
	  Arch >> tmpObj.Tipo;


	  tmpObj.Modelo = new Model;
	  tmpObj.Modelo->Inicia(tmpObj.Nombre, tmpObj.strTextura, tmpObj.Animacion , tmpObj.Escala);
	  Tierra::ModelosDeObjetos.push_back(tmpObj);
	

	}

      Arch >> Basura;


      cout << "Cargando mapa de objetos " << endl;

      int ob;
      vector<MapObjetos>::iterator Ite;

      for (j=0; j<Tierra::alto; j++)
	{
	  for (i=0; i<Tierra::ancho; i++)	
	    {
	      //Arch >> tmp;
	      float I = i/Densidad;
	      float J = j/Densidad;

	      Arch >> ob;
	      Tierra::verticesMapa[j*Tierra::ancho+i].ObjetosMap = NULL;
	      if (ob > 0)
		{
		  for(Ite = Tierra::ModelosDeObjetos.begin() ; Ite != Tierra::ModelosDeObjetos.end() ; Ite++)
		    {
		      if (ob == Ite->ID)
			{  
			  Tierra::verticesMapa[j*Tierra::ancho+i].ObjetosMap = new oEscenografia(I, J);

			  // BORRAME ->
			  // Aun no hago un tipo de army especial para los objetos del
			  // escenario, por eso vamos a ocupar un army de Soldado mientrastant
			  UnidadArmy *tmpBORRAME = new UnidadArmy(NULL);
			  Tierra::verticesMapa[j*Tierra::ancho+i].ObjetosMap->setArmy(tmpBORRAME);
			  // <- BORRAME

			  Tierra::verticesMapa[j*Tierra::ancho+i].ObjetosMap->Inicia(Ite->Modelo, Ite->Tipo);      
			  break;
			}
		    }    
		}
	    }
	  // Zeru DEprecated -->>
	  // pPantallas::BarraDeCarga.Avance = 33*(float(j)/Tierra::alto)+66;
	  // pPantallas::BarraDeCarga.Cadena = "Cargando mapa de Objetos";
	  // pPantallas::PantallaActiva->Dibujame();
	  // < ---

	}


      calculaNormales();

      fow.Init(Tierra::alto,Tierra::ancho);
      fow.LoadFogCoordExt();
      fow.Enable();

    }



  Tierra::alto = Tierra::alto-1;
  AStar::ME()->Crear(); // Creamos el mapa de IA  


  return (1);
}

// -------------------------------------
void Tierra::DibujarNormales (int x,int y)
{

  
  if (x < 0) x = -x -1;
  else if (x > Tierra::ancho) x = (Tierra::ancho * 2) - x + 1;
  
  if (y < 0) y = -y -1;
  else if (y > Tierra::alto) y = (Tierra::alto  * 2) - y + 1;

  glNormal3f(Tierra::verticesMapa[y*Tierra::ancho+x].Normal.x,
	     Tierra::verticesMapa[y*Tierra::ancho+x].Normal.z,
	     Tierra::verticesMapa[y*Tierra::ancho+x].Normal.y);
  
  /*
  glNormal3f(0.0,1.0,0.0);
  */
}


// -------------------------------------
z2DVector Tierra::getPunto (int Lineal)
{
  float Den = Densidad * DenSelect;
  Lineal = Lineal-10000;
  z2DVector P;
  P.y = (int(Lineal/(Tierra::ancho*DenSelect))) / Den + 1/(Den*2);
  P.x = (int(Lineal)%(Tierra::ancho*DenSelect)) / Den + 1/(Den*2);
  return P;
}



verticeTierra Tierra::getVertice(int x, int y)
{

  bool xInv = true;
  bool yInv = true;

  int i, j;

  if (x < 0) i = -x -1;
  else if (x > Tierra::ancho) i = (Tierra::ancho * 2) - x + 1;
  else {i = x; xInv = false;}
  
  if (y < 0) j = -y -1;
  else if (y > Tierra::alto) j = (Tierra::alto  * 2) - y + 1;
  else {j = y; yInv = false;}
 
  verticeTierra Resultado = Tierra::verticesMapa[j*Tierra::ancho+i];
  
  if (xInv || yInv)
    {
      Resultado.fuera = true;
      if (((i == 0) || (i == Tierra::ancho ) ||
		  (j == 0 ) || (j == Tierra::alto )) &&
		  (y > -2 && x > -2 && y < Tierra::alto+2 && x < Tierra::ancho+2))
	  {
	  Resultado.Altura =  Resultado.Altura - 0.40;
	}
      else
	{
	  Resultado.Altura =  (Resultado.Altura) + 0.30;
	}
   
    }

  return Resultado;

}


//------------------------------------
int Tierra::inversor(bool valor)
{
  if (valor) return 1;
  else return 0;
}


//------------------------------------
// Ahora si, a dibujar el terreno
//------------------------------------
int Tierra::dibujame ()
{

  glEnable(GL_TEXTURE_2D);
  glEnable(GL_LIGHTING);

  int i,j, teX;

  // Cuatro vectores forman los cuadros de la maya.
  // en realidad son trangulos (vec1,vec2,vec3) y (vec2,vec3,vec4)

  z3DVector vec1, vec2, vec3, vec4;

  float col1;

  float alpha00, alpha01, alpha10, alpha11;
  
  glEnable(GL_FOG);
  teX =0;

  vector<texturaTierrita>::iterator Ite;

  bool xInv = false ;
  bool yInv = false ;
  
  for (Ite=Tierra::Tex.begin(); Ite != Tierra::Tex.end(); Ite++)
    {
      if (!configuracion::Debug)
	{
	  Ite->tex.usaGLTextura(TextAltaCalidad);
	}
      else
	{
	  Ite->tex.usaGLTextura(TextBajaCalidad);
	}
      
      for (j=int(Tierra::MaxMin[3]*Densidad) ; j<int(Tierra::MaxMin[2]*Densidad) ; j++)
	{
	  for (i=int(Tierra::MaxMin[1]*Densidad) ; i<int(Tierra::MaxMin[0]*Densidad) ; i++)
	    {

     
	      vec1.x = i / Densidad;
	      vec1.y = j / Densidad;
	      
	      //if (i>=0 && j>=0)
	      //if (i<Tierra::ancho-1 && j<Tierra::alto-1) 
		  {
		    

		    alpha00 = 0; alpha10 = 0; alpha01 = 0; alpha11 = 0;
		    
		    if (getVertice(i+inversor( xInv), j+inversor( yInv)).intTextura == teX) alpha00 = 1;
		    if (getVertice(i+inversor( xInv), j+inversor(!yInv)).intTextura == teX) alpha01 = 1;
		    if (getVertice(i+inversor(!xInv), j+inversor( yInv)).intTextura == teX) alpha10 = 1;
		    if (getVertice(i+inversor(!xInv), j+inversor(!yInv)).intTextura == teX) alpha11 = 1;
		    
		    if (alpha00+alpha01+alpha10+alpha11 >= 1)
		      {		

			vec1.z = getVertice(i+inversor( xInv), j+inversor( yInv)).Altura;

		
			vec2.x = (i+1)/Densidad;
			vec2.y = j/Densidad;
			vec2.z = getVertice(i+inversor(!xInv), j+inversor( yInv)).Altura;
			
		

			vec3.x = (i+1)/Densidad;
			vec3.y = (j+1)/Densidad;  
			vec3.z = getVertice(i+inversor(!xInv), j+inversor(!yInv)).Altura;
			
		

			vec4.x = i/Densidad;
			vec4.y = (j+1)/Densidad;
			vec4.z = getVertice(i+inversor( xInv), j+inversor(!yInv)).Altura;
			
		
			
			glBegin (GL_TRIANGLES /* GL_LINE_STRIP*/);
			{
			  //t1
			  
			  col1 = vec1.z + 0.3;
			  glColor4f (col1, col1, col1, alpha00);
			  DibujarNormales(i,j);
			  glTexCoord2f(0, 0);
			  fow.SetFogCoord(i,j);
			  glVertex3f(vec1.x, vec1.z, vec1.y);
			  
			  col1 = vec2.z + 0.3;
			  glColor4f (col1, col1, col1, alpha10);
			  DibujarNormales(i+1,j);
			  glTexCoord2f(1, 0);
			  fow.SetFogCoord(i+1,j);
			  glVertex3f(vec2.x, vec2.z, vec2.y);
			  
			  col1 = vec4.z + 0.3;
			  glColor4f (col1, col1, col1, alpha01);
			  DibujarNormales(i,j+1);
			  glTexCoord2f(0, 1);
			  fow.SetFogCoord(i,j+1);
			  glVertex3f(vec4.x, vec4.z, vec4.y);
			  
			  //t2
			  
			  col1 = vec2.z + 0.3;
			  glColor4f (col1, col1, col1, alpha10);
			  DibujarNormales(i+1,j);
			  glTexCoord2f(1, 0);
			  fow.SetFogCoord(i+1,j);
			  glVertex3f(vec2.x, vec2.z, vec2.y);
			  
			  col1 = vec3.z + 0.3;
			  glColor4f (col1, col1, col1, alpha11);
			  DibujarNormales(i+1,j+1);
			  glTexCoord2f(1, 1);
			  fow.SetFogCoord(i+1,j+1);
			  glVertex3f(vec3.x, vec3.z, vec3.y);  
			  
			  col1 = vec4.z + 0.3;
			  glColor4f (col1, col1, col1, alpha01);
			  DibujarNormales(i,j+1);
			  glTexCoord2f(0, 1);
			  fow.SetFogCoord(i,j+1);
			  glVertex3f(vec4.x, vec4.z, vec4.y);
			  
			}
			glEnd ();
		    
			
		      }
		  }

	      //GRaficar las normales... No todas.
	      /*
		if (teX==0)
		{
		glDisable(GL_TEXTURE_2D);
	      
		glColor3f (1.0, 1.5, 1.0);
	      
		glBegin (GL_LINES);
		glVertex3f(vec1.x, vec1.z, vec1.y);
		glVertex3f(vec1.x+Tierra::verticesMapa[j*Tierra::ancho+i].Normal.x/4, vec1.z+Tierra::verticesMapa[j*Tierra::ancho+i].Normal.z/4, vec1.y+Tierra::verticesMapa[j*Tierra::ancho+i].Normal.y/4);
		glEnd ();

		glEnable(GL_TEXTURE_2D);
		}
	      */

		
	    }
	}
      
      teX++;
      
    }
  
  glDisable(GL_FOG);

  return (1);
}


//--------------------------------------
int Tierra::dibujaObjetos ()
{

  glEnable(GL_FOG);
 
  glColor3f (1.0, 1.0, 1.0);
  

  
  float I,J;

  int i,j;

  oEscenografia *ob; 
  z3DVector obNormal;

  /*
    obNormal.x = 0.0;
    obNormal.y = 0.0;
    obNormal.z = 1.0;
  */

  glEnable(GL_LIGHTING);

  for (j=int(Tierra::MaxMin[3]*Densidad) ; j<int(Tierra::MaxMin[2]*Densidad); j++)
    {
      for (i=int(Tierra::MaxMin[1]*Densidad) ; i<int(Tierra::MaxMin[0]*Densidad); i++)	
	{
	  I = i/Densidad;
	  J = j/Densidad;
	  
	  //if (fow.GetPoint(i,j))
	  {
	    if (i>=0 && j>=0)
	      if (i<Tierra::ancho-1 && j<Tierra::alto-1) 
		{
		  ob = Tierra::verticesMapa[(j*Tierra::ancho) + i].ObjetosMap;
		    
		  if (ob != NULL)
		    {
		      fow.SetFogCoord(i,j);

		      
		      ob->setRetardo(Retardo);
		      
		      obNormal = Tierra::verticesMapa[j*Tierra::ancho+i].Normal;

		      ob->dibujame(Tierra::verticesMapa[(j*Tierra::ancho) + i].Altura, obNormal, false);
		    }
		}
	  }
	}
    }
 
  glDisable(GL_FOG);
	
  return (1);
}


// ---------------------------------------
void Tierra::setCamara(float PosX, float PosY, float anguloVista)
{
  PibotesDelFrustumCulling(PosX, PosY, anguloVista, Tierra::MaxMin);
}


// ---------------------------------------
bool Tierra::getFrustumCulling (float x, float y)
{
  if ((Tierra::MaxMin[3] < y) &&  (Tierra::MaxMin[2] > y))
    {
      if((Tierra::MaxMin[1] < x) && (Tierra::MaxMin[0] > x))
	{
	  return true;
	}
    }	
  return false;
}

// ---------------------------------------
void Tierra::PibotesDelFrustumCulling(float x, float z, float angulo, float *Frust)
{
  // Esta funcion es solo un auxiliar, es para dibujar los 
  // "pibores" del FrustumCulling del mapa.

  // Vamos a calcular que tanto del mapa es nesario dibujar.

  // Frust[0] es el  X Maximo  
  // Frust[1] es el  X Minimo
  // Frust[2] es el  Z Maximo
  // Frust[3] es el  Z Minimo

  const float Zoom = 0.9;
  
  float xx[4];
  float zz[4];
  
  xx[0] = x + (zsin(angulo+210) * 4.8 * Zoom); 
  zz[0] = z + (zcos(angulo+210) * 4.8 * Zoom);
  xx[1] = x + (zsin(angulo+150) * 4.8 * Zoom); 
  zz[1] = z + (zcos(angulo+150) * 4.8 * Zoom);

  xx[2] = x + (zsin(angulo+38) * 2.3 * Zoom); 
  zz[2] = z + (zcos(angulo+38) * 2.3 * Zoom);
  xx[3] = x + (zsin(angulo-38) * 2.3 * Zoom); 
  zz[3] = z + (zcos(angulo-38) * 2.3 * Zoom);
  
  Frust[0] = xx[0];
  Frust[1] = xx[0];
  Frust[2] = zz[0];
  Frust[3] = zz[0];

  for (int i = 1; i<4 ; i++)
    {
      // Calcula Xmax y Xmin
      if (Frust[0] < xx[i])
	{
	  Frust[0]=xx[i];
	}
      if (Frust[1] > xx[i])
	{
	  Frust[1]=xx[i];
	}
      
      // Calcula Zmax y Zmin
      if (Frust[2] < zz[i])
	{
	  Frust[2]=zz[i];
	}
      if (Frust[3] > zz[i])
	{
	  Frust[3]=zz[i];
	}
    }

  /*
    cout << "xMax:" << Frust[0] << endl;
    cout << "xMin:" << Frust[1] << endl;
    cout << "x[0]:" << xx[0] << endl;
    cout << "x[1]:" << xx[1] << endl;
    cout << "x[2]:" << xx[2] << endl;
    cout << "x[3]:" << xx[3] << endl;
    cout << "zMax:" << Frust[2] << endl;
    cout << "zMin:" << Frust[3] << endl;
  */
  //--
    
  /*
      glColor3f (1.0, 0.2, 0.2);
  
      glBegin (GL_LINES);
      {
      glVertex3f(xx[0], 0.0, zz[0]);
      glVertex3f(xx[0], 1.0, zz[0]);
      glVertex3f(xx[1], 0.0, zz[1]);
      glVertex3f(xx[1], 1.0, zz[1]);

      glVertex3f(xx[2], 0.0, zz[2]);
      glVertex3f(xx[2], 1.0, zz[2]);
      glVertex3f(xx[3], 0.0, zz[3]);
      glVertex3f(xx[3], 1.0, zz[3]);
      }
      glEnd ();
  
      glColor3f (0.2, 0.2, 1.0);
  
      glBegin (GL_LINES);
      {
      glVertex3f(x, 0.0, z);
      glVertex3f(x, 1.0, z);
      }
      glEnd ();
  */
  //--  
}

// ---------------------------------------
float Tierra::getAltura(float X, float Z)
{
  int i = (int)(X*Densidad);
  int j = (int)(Z*Densidad);
        

  if (i<0 || i>Tierra::ancho-1 || j<0 || j>Tierra::alto-1)
    {
      return (0);
    }


  float desnivel_00 = 0;
  float desnivel_01 = 0;
  float desnivel_10 = 0;
  float desnivel_11 = 0;

  if (Tex[Tierra::verticesMapa[(j+0)*Tierra::ancho+(i+0)].intTextura].Consistencia == "Liquido") desnivel_00 = 0.05;
  if (Tex[Tierra::verticesMapa[(j+0)*Tierra::ancho+(i+1)].intTextura].Consistencia == "Liquido") desnivel_01 = 0.05;
  if (Tex[Tierra::verticesMapa[(j+1)*Tierra::ancho+(i+0)].intTextura].Consistencia == "Liquido") desnivel_10 = 0.05;
  if (Tex[Tierra::verticesMapa[(j+1)*Tierra::ancho+(i+1)].intTextura].Consistencia == "Liquido") desnivel_11 = 0.05;

  z3DVector v1,v2,v3;
	
  if (((X - i/Densidad)+(Z - j/Densidad)) > (1.0/Densidad))
    {
      v1.x = (i+1)/Densidad;
      v1.y = Tierra::verticesMapa[(j+1)*Tierra::ancho+(i+1)].Altura - desnivel_11;
      v1.z = (j+1)/Densidad;
    }
  else
    {
      v1.x = i/Densidad;
      v1.y = Tierra::verticesMapa[(j)*Tierra::ancho+(i)].Altura - desnivel_00;
      v1.z = j/Densidad;
    }

  v2.x = (i+1)/Densidad;
  v2.y = Tierra::verticesMapa[(j)*Tierra::ancho+(i+1)].Altura - desnivel_01;
  v2.z = j/Densidad;

  v3.x = i/Densidad;
  v3.y = Tierra::verticesMapa[(j+1)*Tierra::ancho+(i)].Altura - desnivel_10;
  v3.z = (j+1)/Densidad;

  // By K-ballo
	
  float a=v1.y*(v2.z-v3.z) + v2.y*(v3.z-v1.z) + v3.y*(v1.z-v2.z);
  float b=v1.z*(v2.x-v3.x) + v2.z*(v3.x-v1.x) + v3.z*(v1.x-v2.x);
  float c=v1.x*(v2.y-v3.y) + v2.x*(v3.y-v1.y) + v3.x*(v1.y-v2.y);
  float d=-( v1.x*( v2.y*v3.z - v3.y*v2.z ) +v2.x*(v3.y*v1.z - v1.y*v3.z) +v3.x*(v1.y*v2.z - v2.y*v1.z) );


  if ((-d-a*X-c*Z)/b > 2)
    {
      cout << "Error Tierra::getAltura():  [" << i << "," << j << "] " << (-d-a*X-c*Z)/b << endl;
      return 0;
    }

 if ((-d-a*X-c*Z)/b < -0.10)
    {
      cout << "Error Tierra::getAltura():  [" << i << "," << j << "] " << (-d-a*X-c*Z)/b << endl;
      return 0;
    }

  return (-d-a*X-c*Z)/b;
	
}


float Tierra::getVelocidadPonderada(float X, float Y, float Angulo)
{
  float VelocidadPonderada = 1.0;

  int i = (int)(X*Densidad);
  int j = (int)(Y*Densidad);

  if (Tex[Tierra::verticesMapa[(j+0)*Tierra::ancho+(i+0)].intTextura].Consistencia == "Liquido") 
    {
      VelocidadPonderada = VelocidadPonderada * 0.85;
    }
  if (Tex[Tierra::verticesMapa[(j+0)*Tierra::ancho+(i+1)].intTextura].Consistencia == "Liquido")
    {
      VelocidadPonderada = VelocidadPonderada * 0.85;
    }
  if (Tex[Tierra::verticesMapa[(j+1)*Tierra::ancho+(i+0)].intTextura].Consistencia == "Liquido")
    {
      VelocidadPonderada = VelocidadPonderada * 0.85;
    }
  if (Tex[Tierra::verticesMapa[(j+1)*Tierra::ancho+(i+1)].intTextura].Consistencia == "Liquido")
    {
      VelocidadPonderada = VelocidadPonderada * 0.85;
    }

  return VelocidadPonderada;
}


//--------------------------------------------
z3DVector Tierra::getNormal(float X, float Y)
{

  X = X*Densidad;
  Y = Y*Densidad;

  int i = (int)(X);
  int j = (int)(Y);



  return (Tierra::verticesMapa[j*Tierra::ancho+i].Normal);
}

//----------------------------------------------
// Pregunta si un objeto colocado en (x,y) y que tiene radio (miRadio)
// Esta en colicion con algun objeto del mapa.
bool  Tierra::colicion (float x, float y, float miRadio)
{

  const float RadioMaximo = 0.5; // Es estimado.

  int i;
  int j;
  float I,J;
  float Distancia;
  float SumRadios;

  

  oEscenografia *ob;
  
  for (j=int((y-RadioMaximo)*Densidad)+1 ; j<int((y+RadioMaximo)*Densidad)+1; j++)
    {
      for (i=int((x-RadioMaximo)*Densidad)+1 ; i<int((x+RadioMaximo)*Densidad)+1; i++)
	{
		
	  // Hacemos un barrido buscando objetos del senario que esten en una cuadro
	  // alrededor de (x,y), este cuadro es de 2*RadioMaximo x 2*RadioMaximo
	  // esto lo hacemos por optimizacion, para no barrer todo el mapa completo.

	  ob = Tierra::verticesMapa[j*Tierra::ancho+i].ObjetosMap;
	  if (ob != NULL)
	    {

	      // Este objeto esta colocado en las coordenadas (I,J) que acontinuacion
	      // calculamos.

	      I = i/Densidad;
	      J = j/Densidad;

	      // Miramos si la distancia entre (x,y) y el objeto en el mapa es menor a
	      // la suma de sus radios.
		    
	      Distancia = zDistancia(x, y, I, J);
	      SumRadios = miRadio + ob->getRadio();


	      if (SumRadios > Distancia)
		{
		  // Si hay colicion.
		  return true;
		}
	    }
	}
    }

  return false;
}

//---------------------------

void Tierra::calculaNormales()
{
  // Calculamos las normales de los poligonos.
  
  
  cout << "Calculando normales del mapa" << endl;
  
  z3DVector * NormalesDePoligonos = new z3DVector [(Tierra::alto)*(Tierra::ancho)*2];
  int j;
  int i;
  
  
  
  z3DVector A, B, C, D, AB, BC, CD;
  
  for (j=0 ; j<(Tierra::alto-1) ; j++)
    {
       
      for (i=0 ; i<(Tierra::ancho-1) ; i++)
	{
	  
	  A.x = i/Densidad;
	  A.y = j/Densidad;
	  A.z = Tierra::verticesMapa[j*Tierra::ancho+i].Altura;
	  
	  B.x = (i+1)/Densidad;
	  B.y = j/Densidad;
	  B.z = Tierra::verticesMapa[j*Tierra::ancho+(i+1)].Altura;
	  
	  C.x = (i+1)/Densidad;
	  C.y = (j+1)/Densidad;  
	  C.z = Tierra::verticesMapa[(j+1)*Tierra::ancho+(i+1)].Altura;
	  
	  D.x = i/Densidad;
	  D.y = (j+1)/Densidad;
	  D.z = Tierra::verticesMapa[(j+1)*Tierra::ancho+(i)].Altura;
	  
	  AB = CalcVector(A,B);
	  BC = CalcVector(B,C);
	  NormalesDePoligonos[(j*Tierra::ancho+i)*2] = CalcNormalizar(CalcCruz (AB,BC));
	  
	  CD = CalcVector(C,D);
	  NormalesDePoligonos[(j*Tierra::ancho+i)*2+1] = CalcNormalizar(CalcCruz (BC,CD));
	  
	  // ------------------
	   
	}
    }
  
  z3DVector VectorCero = {0.0, 0.0, 0.0};
  
  cout << "X" << endl;
  
  for (j=1 ; j<(Tierra::alto-2) ; j++)
    {
      for (i=1 ; i<(Tierra::ancho-2) ; i++)
	{
	  z3DVector X = VectorCero;
	  
	  X = CalcSuma(X, NormalesDePoligonos[((j-1)*(Tierra::ancho)+(i-1))*2 + 1]);
	  X = CalcSuma(X, NormalesDePoligonos[((j-1)*(Tierra::ancho)+(i))*2 + 0]);
	  X = CalcSuma(X, NormalesDePoligonos[((j-1)*(Tierra::ancho)+(i))*2 + 1]);
	  
	  X = CalcSuma(X, NormalesDePoligonos[((j)*(Tierra::ancho)+(i-1))*2 + 0]);
	  X = CalcSuma(X, NormalesDePoligonos[((j)*(Tierra::ancho)+(i-1))*2 + 1]);
	  X = CalcSuma(X, NormalesDePoligonos[((j)*(Tierra::ancho)+(i))*2 + 1]);
	  
	  X = CalcDividirPorEscalar(X,6);
	  
	  Tierra::verticesMapa[j*Tierra::ancho+i].Normal = X;
	}
    }
  delete NormalesDePoligonos;
}




/*
#include "Mouse.h"
*/

//------------------------------------
// Ahora si, a dibujar el terreno
//------------------------------------
int Tierra::dibujameSelect ()
{


  // Este es el render del terreno si Objetos, ni  textura ni normales
  // es DenSelect veces mas denso, se usa para calcular los clicasos.
  // Hack by ZeruGiran


  float Den = Densidad*DenSelect;

  int i,j;

  // Cuatro vectores forman los cuadros de la maya.
  // en realidad son trangulos (vec1,vec2,vec3) y (vec2,vec3,vec4)

  z3DVector vec1, vec2, vec3, vec4;

  
  glDisable(GL_FOG);
  glDisable(GL_TEXTURE_2D);
  glDisable(GL_LIGHTING);

  for (j=int(Tierra::MaxMin[3]*Den) ; j<int(Tierra::MaxMin[2]*Den); j++)
    {
      for (i=int(Tierra::MaxMin[1]*Den) ; i<int(Tierra::MaxMin[0]*Den); i++)
	{

	  vec1.x = i/Den;
	  vec1.y = j/Den;
					
					
	  if (i>=0 && j>=0)
	    if (i<(Tierra::ancho*DenSelect)-1 && j<(Tierra::alto*DenSelect)-1) 
	      {
					
		vec1.z = getAltura(vec1.x,vec1.y);

		vec2.x = (i+1)/Den;
		vec2.y = j/Den;
		vec2.z = getAltura(vec2.x,vec2.y);
								
		vec3.x = (i+1)/Den;
		vec3.y = (j+1)/Den;  
		vec3.z = getAltura(vec3.x,vec3.y);
								
								
		vec4.x = i/Den;
		vec4.y = (j+1)/Den;
		vec4.z = getAltura(vec4.x,vec4.y);

		glPushName((j*(Tierra::ancho*DenSelect)+i) + 10000);

		glBegin (GL_QUADS);
		{

		  glVertex3f(vec1.x, vec1.z, vec1.y);
		  glVertex3f(vec2.x, vec2.z, vec2.y);
		  glVertex3f(vec3.x, vec3.z, vec3.y);
		  glVertex3f(vec4.x, vec4.z, vec4.y);
	  								
		}
		glEnd ();

		glPopName();
					
	      }
	}
    }
  
  glColor3f (1.0, 1.0, 1.0);


      // ----------------------------------
      // ----------------------------------
      // ----------------------------------
  /*
      float zpos;

      int x = Mouse::ME()->getMouseState().x;
      int y = Mouse::ME()->getMouseState().y;
      
      glReadPixels(x,y,1,1,GL_DEPTH_COMPONENT,GL_FLOAT,&zpos);
      
      GLdouble model[4*4];
      GLdouble proj[4*4];
      GLint view[4];
      
      glGetDoublev(GL_MODELVIEW_MATRIX, model);
      glGetDoublev(GL_PROJECTION_MATRIX, proj);
      glGetIntegerv(GL_VIEWPORT, view);
      
      double pan_x, pan_y, pan_z;

      //  gluProject(x,y,zpos,model,proj,view,&pan_x,&pan_y,&pan_z); 

      gluUnProject(x,y,zpos,model,proj,view,&pan_x,&pan_y,&pan_z);

      cout << "x: " << pan_x << "   y: "  << pan_z << "    "  << zpos  <<  endl;


      Mouse::ME()->posTierra.x = pan_x;
      Mouse::ME()->posTierra.y = pan_z;

*/
      // ----------------------------------
      // ----------------------------------
      // ----------------------------------



  return (1);
}


